/*!
 * 
 * Angle - Bootstrap Admin App + AngularJS
 * 
 * Version: 3.7.5
 * Author: @themicon_co
 * Website: http://themicon.co
 * License: https://wrapbootstrap.com/help/licenses
 * 
 */

// APP START
// ----------------------------------- 

(function() {
    'use strict';

    angular
        .module('angle', [
            'app.core',
            'app.cadastros',
            'app.gerenciamento',
            'app.relatorios',
            'app.services',
            'app.routes',
            'app.sidebar',
            'app.navbar',
            'app.preloader',
            'app.loadingbar',
            'app.translate',
            'app.settings',
            'app.utils',
            'app.pages'
        ]);

    String.prototype.replaceAll = function(search, replacement) {
        var target = this;
        return target.split(search).join(replacement);
    };
})();


(function() {
    'use strict';

    angular
        .module('app.colors', []);
})();
(function() {
    'use strict';

    angular
        .module('app.cadastros', []);
})();
(function() {
    'use strict';

    angular
        .module('app.core', [
            'ngRoute',
            'ngAnimate',
            'ngStorage',
            'ngCookies',
            'pascalprecht.translate',
            'ui.bootstrap',
            'ui.router',
            'oc.lazyLoad',
            'cfp.loadingBar',
            'ngSanitize',
            'ngResource',
            'ui.utils'
        ]);
})();
(function() {
    'use strict';

    angular
        .module('app.lazyload', []);
})();
(function() {
    'use strict';

    angular
        .module('app.gerenciamento', []);
})();
(function() {
    'use strict';

    angular
        .module('app.loadingbar', []);
})();
(function() {
    'use strict';

    angular
        .module('app.preloader', []);
})();


(function() {
    'use strict';

    angular
        .module('app.navbar', []);
})();
(function() {
    'use strict';

    angular
        .module('app.pages', []);
})();
(function() {
  'use strict';

  angular
      .module('app.relatorios', []);
})();
(function() {
    'use strict';

    angular
        .module('app.routes', [
            'app.lazyload'
        ]);
})();
(function() {
  'use strict';
  
  angular
    .module('app.services', [

    ]);
})();
(function() {
    'use strict';

    angular
        .module('app.settings', []);
})();
(function() {
    'use strict';

    angular
        .module('app.sidebar', []);
})();
(function() {
    'use strict';

    angular
        .module('app.translate', []);
})();
(function() {
    'use strict';
    
    angular
        .module('app.utils', [
          'app.colors'
          ]);
})();

(function() {
    'use strict';

    angular
        .module('app.colors')
        .constant('APP_COLORS', {
          'primary':                '#5d9cec',
          'success':                '#27c24c',
          'info':                   '#23b7e5',
          'warning':                '#ff902b',
          'danger':                 '#f05050',
          'inverse':                '#131e26',
          'green':                  '#37bc9b',
          'pink':                   '#f532e5',
          'purple':                 '#7266ba',
          'dark':                   '#3a3f51',
          'yellow':                 '#fad732',
          'gray-darker':            '#232735',
          'gray-dark':              '#3a3f51',
          'gray':                   '#dde6e9',
          'gray-light':             '#e4eaec',
          'gray-lighter':           '#edf1f2'
        })
        ;
})();
/**=========================================================
 * Module: colors.js
 * Services to retrieve global colors
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.colors')
        .service('Colors', Colors);

    Colors.$inject = ['APP_COLORS'];
    function Colors(APP_COLORS) {
        this.byName = byName;

        ////////////////

        function byName(name) {
          return (APP_COLORS[name] || '#fff');
        }
    }

})();

// business-unit.controller.js
(function() {
  'use strict';

  angular
      .module('app.cadastros')
      .controller('BusinessUnitController', Controller);

  Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
  
  function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {
      var vm = this;

      activate();

      function activate() {
        vm.currentUser = $rootScope.globals.currentUser;
        vm.loading = false;
        vm.objModel = {
            filial_related: ($rootScope.globals.currentUser.profile === 'filial') ? $rootScope.globals.currentUser : undefined
        };
        vm.limit_options = ["5","10","30","50","100"];
        vm.filter = {
          value: '',
          limit: "5"
        };

        if(!Utils.isEmpty(vm.currentUser.customer)) {
          vm.objModel.customer_related = vm.currentUser.customer;

          if(vm.objModel.customer_related.person_type == 'PJ') {
            if(!Utils.isEmpty(vm.objModel.customer_related.company_name))
              vm.objModel.customer_related.label = vm.objModel.customer_related.company_name;
            else
              vm.objModel.customer_related.label = vm.objModel.customer_related.fantasy_name;
          }
          else
            vm.objModel.customer_related.label = vm.objModel.customer_related.name;

          vm.filter.customer = vm.currentUser.customer;
          if(vm.filter.customer.person_type == 'PJ') {
            if(!Utils.isEmpty(vm.filter.customer.company_name))
              vm.filter.customer.label = vm.filter.customer.company_name;
            else
              vm.filter.customer.label = vm.filter.customer.fantasy_name;
          }
          else
            vm.filter.customer.label = vm.filter.customer.name;
        }
      }

      function getDataById() {
          $http({
                method: "GET",
                url: `${Utils.getBaseUrlApi()}/business-unit/${Utils.getUrlVars().id}`
              }).then(
                  function successCallback(response) {
                    if(!Utils.isEmpty(response.data.customer_related)) {
                    if(response.data.customer_related.person_type == 'PJ') {
                    if(!Utils.isEmpty(response.data.customer_related.company_name))
                    response.data.customer_related.label = response.data.customer_related.company_name;
                    else
                    response.data.customer_related.label = response.data.customer_related.fantasy_name;
                    }
                    else
                    response.data.customer_related.label = response.data.customer_related.name;
                    }

                    vm.objModel = response.data;
                  },
                  function errorCallback(response) {
                    toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                  }
              );
      }

      vm.getAll = function(offset) {
          var req_url = `${Utils.getBaseUrlApi()}/business-units`;
              req_url += `?offset=${offset}&limit=${parseInt(vm.filter.limit)}`;

          if(!Utils.isEmpty(vm.filter.value))
              req_url += '&filter='+ vm.filter.value;
          
          if(!Utils.isEmpty(vm.filter.customer))
            req_url += `&customer_related_id=${vm.filter.customer.id}`;
    
          if ($rootScope.globals.currentUser.profile === 'filial') {
            req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
          }

          vm.items = {};

          $http({
              method: "GET",
              url: req_url
          }).then(
              function successCallback(response) {
                  vm.items = response.data;
              },
              function errorCallback(response) {
                  vm.items = null;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+ response.data
                  });
              }
          );
      }

      vm.save = function() {
          if(!Utils.validateFields(vm, '#form-person')) {
              vm.loading = true;

              $http({
                  method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                  url: `${Utils.getBaseUrlApi()}/business-unit`,
                  data: JSON.stringify(vm.objModel)
              }).then(
                  function successCallback(response) {
                      activate();

                      var success_message = '<strong>Operação realizada</strong><br/>'+
                                            'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                      toaster.pop({
                          type: 'success',
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: success_message,
                          onHideCallback: function() {
                              $state.go('app.business-unit-list');
                          }
                      });
                  },
                  function errorCallback(response) {
                      vm.loading = false;
                      toaster.pop({
                          type: 'error', 
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: '<strong>Desculpe!</strong><br/>'+response.data
                      });
                  }
              );
          }
          else {
              toaster.pop({
                  type: 'warning', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
              });
          }
      }

      vm.confirmDelete = function() {
          vm.loading = true;
          $http({
              method: "DELETE",
              url: `${Utils.getBaseUrlApi()}/business-unit/${Utils.getUrlVars().id}`
          }).then(
              function successCallback(response) {
                  toaster.pop({
                      type: 'success',
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                      onHideCallback: function() {
                          $state.go('app.business-unit-list');
                      }
                  });
              },
              function errorCallback(response) {
                  vm.loading = false;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+response.data
                  });
              }
          );
      }

      vm.openModal = function(modal_name, item){
          var modal_instance = $uibModal.open({ 
              size: 'md',
              backdrop: false,
              templateUrl: '/'+ modal_name +'.html',
              controller: ModalInstanceCtrl
          });

          ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $uibModalInstance) {
              $scope.limit_options = ["5","10","30","50","100"];
              $scope.filter = {
                  value: '',
                  limit: "5"
              };

              $scope.selectItem = function(items, item_selected) {
                  angular.forEach(items, function(item) {
                      item.selected = false;
                  });
                  item_selected.selected = true;
                  $scope.selected_item = angular.copy(item_selected);
              }

              $scope.confirmSelectItem = function() {
                  vm.objModel.customer_related = angular.copy($scope.selected_item);
                  if(vm.objModel.customer_related.person_type == 'PJ') {
                      if(!Utils.isEmpty(vm.objModel.customer_related.company_name))
                          vm.objModel.customer_related.label = vm.objModel.customer_related.company_name;
                      else
                          vm.objModel.customer_related.label = vm.objModel.customer_related.fantasy_name;
                  }
                  else
                      vm.objModel.customer_related.label = vm.objModel.customer_related.name;

                  $uibModalInstance.close('closed');
              }

              $scope.cancelSelection = function(){
                  $uibModalInstance.close('closed');
              }

              $scope.getClientesEmpresas = function(offset) {
                  var req_url = Utils.getBaseUrlApi()+'/persons';
                      req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                  if(!Utils.isEmpty($scope.filter.value))
                      req_url += '&filter='+ $scope.filter.value;
                
                  if ($rootScope.globals.currentUser.profile === 'filial') {
                    req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
                  }

                  $scope.clientesEmpresas = {};

                  $http({
                      method: "GET",
                      url: req_url
                  }).then(
                      function successCallback(response) {
                          if(!Utils.isEmpty(vm.service_selected)) {
                              angular.forEach(response.data.records, function(item){
                                  if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                      item.selected = true;
                              });
                          }
                          $scope.clientesEmpresas = response.data;
                      },
                      function errorCallback(response) {
                          $scope.clientesEmpresas = null;
                          toaster.pop({
                              type: 'error', 
                              timeout: 2000, 
                              bodyOutputType: 'trustedHtml',
                              body: '<strong>Desculpe!</strong><br/>'+ response.data
                          });
                      }
                  );
              }
          }
      }

      if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
          getDataById();
  }
})();
(function() {
    'use strict';

	angular
        .module('app.cadastros')
        .filter('NumberFormat', NumberFormat)
        .filter('DateFormat', DateFormat);

		function NumberFormat() {
			return filter;

			////////////////////////
			function filter(number, decimals, dec_point, thousands_sep) {
				number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
				var n = !isFinite(+number) ? 0 : +number,
					prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
					sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
					dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
					s = '',
					toFixedFix = function(n, prec) {
						var k = Math.pow(10, prec);
						return '' + (Math.round(n * k) / k)
						.toFixed(prec);
					};
				s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
				if (s[0].length > 3) {
					s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
				}
				if ((s[1] || '').length < prec) {
					s[1] = s[1] || '';
					s[1] += new Array(prec - s[1].length + 1).join('0');
				}
				return s.join(dec);
			}
		};

		function DateFormat() {
			return filter;

			////////////////////////
			function filter(inputFormat,tipo) {
				function pad(s) { return (s < 10) ? '0' + s : s; }
				if (isEmpty(inputFormat)) return "" ;
				if(inputFormat.length < 6){
					return "" ;
				}else if(inputFormat == '0000-00-00'){
					return "" ;
				}else if(tipo == 'date-m/y'){;
					if(inputFormat.length == 6)
						return inputFormat.substring(0,2)+'/'+inputFormat.substring(2,6);
					else{
						var arr = inputFormat.split('-');
						return arr[1]+'/'+arr[0];
					}
				}

				inputFormat = inputFormat.replace(/-/g,"/");
				var d = new Date(inputFormat);
				if(tipo == null || tipo == "dateTime"){
					var hora = d.getHours() < 10 ? '0'+d.getHours() : d.getHours() ;
					var minutos = d.getMinutes() < 10 ? '0'+d.getMinutes() : d.getMinutes() ;
					var segundos = d.getSeconds() < 10 ? '0'+d.getSeconds() : d.getSeconds() ;

					return pad(d.getDate())+'/'+pad(d.getMonth()+1)+'/'+d.getFullYear()+' '+hora+':'+minutos+':'+segundos;
				}else if(tipo=="time"){
					var hora = d.getHours() < 10 ? '0'+d.getHours() : d.getHours() ;
					var minutos = d.getMinutes() < 10 ? '0'+d.getMinutes() : d.getMinutes() ;
					var segundos = d.getSeconds() < 10 ? '0'+d.getSeconds() : d.getSeconds() ;
					return hora+':'+minutos+':'+segundos;
				}else if(tipo=='time-HH:mm'){
					var hora = d.getHours() < 10 ? '0'+d.getHours() : d.getHours() ;
					var minutos = d.getMinutes() < 10 ? '0'+d.getMinutes() : d.getMinutes() ;
					return hora+':'+minutos;
				}
				else
					return pad(d.getDate())+'/'+pad(d.getMonth()+1)+'/'+d.getFullYear();
			}
		};

})();
// criminal-article.controller.js
(function() {
  'use strict';

  angular
      .module('app.cadastros')
      .controller('CriminalArticleController', Controller);

  Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
  
  function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {
      var vm = this;

      activate();

      function activate() {
        vm.currentUser = $rootScope.globals.currentUser;
        vm.loading = false;
        vm.objModel = {};
        vm.limit_options = ["5","10","30","50","100"];
        vm.filter = {
          value: '',
          limit: "30"
        };
      }

      function getDataById() {
          $http({
                method: "GET",
                url: `${Utils.getBaseUrlApi()}/criminal-article/${Utils.getUrlVars().id}`
              }).then(
                  function successCallback(response) {
                    vm.objModel = response.data;
                  },
                  function errorCallback(response) {
                    toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                  }
              );
      }

      vm.getAll = function(offset) {
          var req_url = `${Utils.getBaseUrlApi()}/criminal-articles`;
              req_url += `?offset=${offset}&limit=${parseInt(vm.filter.limit)}`;

          if(!Utils.isEmpty(vm.filter.value))
              req_url += '&filter='+ vm.filter.value;

          vm.items = {};

          $http({
              method: "GET",
              url: req_url
          }).then(
              function successCallback(response) {
                  vm.items = response.data;
              },
              function errorCallback(response) {
                  vm.items = null;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+ response.data
                  });
              }
          );
      }

      vm.save = function() {
          if(!Utils.validateFields(vm, '#form-person')) {
            vm.loading = true;

            let req_url = `${Utils.getBaseUrlApi()}/criminal-article`;

            if(!Utils.isEmpty(vm.objModel.id)) {
                req_url += `/${Utils.getUrlVars().id}`;
            }
            
            $http({
                method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                url: req_url,
                data: JSON.stringify(vm.objModel)
            }).then(
                function successCallback(response) {
                    activate();

                    var success_message = '<strong>Operação realizada</strong><br/>'+
                                        'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: success_message,
                        onHideCallback: function() {
                            $state.go('app.criminal-article-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
          }
          else {
              toaster.pop({
                  type: 'warning', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
              });
          }
      }

      vm.confirmDelete = function() {
          vm.loading = true;
          $http({
              method: "DELETE",
              url: `${Utils.getBaseUrlApi()}/criminal-article/${Utils.getUrlVars().id}`
          }).then(
              function successCallback(response) {
                  toaster.pop({
                      type: 'success',
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                      onHideCallback: function() {
                          $state.go('app.criminal-article-list');
                      }
                  });
              },
              function errorCallback(response) {
                  vm.loading = false;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+response.data
                  });
              }
          );
      }

      if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
          getDataById();
  }
})();
// order-record-layout.controller.js
(function() {
    'use strict';

    angular
        .module('app.cadastros')
        .controller('OrderRecordLayoutController', Controller);

    Controller.$inject = ['$log', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
    
    function Controller($log, $scope, $state, $http, $uibModal, Utils, toaster) {
        var vm = this;

        activate();

        function activate() {
            vm.loading = false;
            vm.objModel = {};
            vm.limit_options = ["5","10","30","50","100"];
            vm.filter = {
                value: '',
                limit: "5"
            };
            vm.default_field_values = [
                {label: 'Nome da Empresa/Pessoa', value: '|--person.name--|'},
                {label: 'CPF/CNPJ', value: '|--person.cpf_cnpj--|'},
                {label: 'RG', value: '|--person.rg--|'},
                {label: 'Data de Nascimento', value: '|--person.birth_date--|'},
                {label: 'Nome da Mãe', value: '|--person.mothers_name--|'},
                {label: 'Nome do Pai', value: '|--person.fathers_name--|'}
            ];
            vm.search_types = [
                {label: 'Boletim de Ocorrência', value: 'police_report_bulletin'},
                {label: 'Criminal', value: 'criminal'},
                {label: 'Financeiro', value: 'finance'},
                {label: 'Veículos', value: 'vehicle'}
            ];
        }

        function getDataById() {
            $http({
                    method: "GET",
                    url: Utils.getBaseUrlApi()+'/order/records/layout/'+ Utils.getUrlVars().id
                }).then(
                    function successCallback(response) {
                    	if(!Utils.isEmpty(response.data.fields)){
	                        angular.forEach(response.data.fields, function(field){
	                            field.delete = false;
                                if(!Utils.isEmpty(field.default_value))
                                    field.default_value = _.findWhere(vm.default_field_values, {value: field.default_value});
                                if(!Utils.isEmpty(field.search_type))
                                    field.search_type = _.findWhere(vm.search_types, {value: field.search_type});
	                        });
	                    }

                        vm.objModel = response.data;
                    },
                    function errorCallback(response) {
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
        }

        vm.editField = function(field) {
            vm.field = field;
        }

        vm.addField = function() {
        	if(Utils.isEmpty(vm.objModel.fields))
        		vm.objModel.fields = [];
        
        	if(Utils.isEmpty(vm.field.id) && !Utils.isEmpty(_.findWhere(vm.objModel.fields, {name: vm.field.name, delete: false}))) {
        		toaster.pop({
        			type: 'error', 
        			timeout: 2000, 
        			bodyOutputType: 'trustedHtml',
        			body: '<strong>Desculpe!</strong><br/>Já existe um campo cadastrado com esses dados.'
        		});
        	}
        	else {
                if(Utils.isEmpty(vm.field.id)){
        		  vm.field.delete = false;
        		  vm.objModel.fields.push(angular.copy(vm.field));
                }
                else {
                    var idx = _.indexOf(vm.objModel.fields, vm.field);
                    vm.objModel.fields[idx] = vm.field;
                }
        	}

    		vm.field = null;
        }

        vm.getAll = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/order/records/layouts';
                req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);

            if(!Utils.isEmpty(vm.filter.value))
                req_url += '&filter='+ vm.filter.value;

            vm.items = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.items = response.data;
                },
                function errorCallback(response) {
                    vm.items = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        vm.save = function() {
            if(!Utils.validateFields(vm, '#form-person')) {
                vm.loading = true;

                $http({
                    method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                    url: Utils.getBaseUrlApi()+'/order/records/layout',
                    data: JSON.stringify(vm.objModel)
                }).then(
                    function successCallback(response) {
                        activate();

                        var success_message = '<strong>Operação realizada</strong><br/>'+
                                              'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                        toaster.pop({
                            type: 'success',
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: success_message,
                            onHideCallback: function() {
                                $state.go('app.order-record-layout-list');
                            }
                        });
                    },
                    function errorCallback(response) {
                        vm.loading = false;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
                });
            }
        }

        vm.confirmDelete = function() {
            vm.loading = true;
            $http({
                method: "DELETE",
                url: Utils.getBaseUrlApi()+'/order/records/layout/'+ Utils.getUrlVars().id
            }).then(
                function successCallback(response) {
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                        onHideCallback: function() {
                            $state.go('app.order-record-layout-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.addOptions = function(option) {
            if(Utils.isEmpty(vm.field.options_value))
                vm.field.options_value = [];
            vm.field.options_value.push({value: option});
            vm.field.option_value = null;
        }

        vm.removeOptions = function(indexOption) {
            vm.field.options_value.splice(indexOption, 1);
        }

        if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
            getDataById();
    }
})();
// person.controller.js
(function() {
    'use strict';

    angular
        .module('app.cadastros')
        .controller('PersonController', Controller);

    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
    
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {
        var vm = this;

        activate();

        function activate() {
            vm.currentUser = $rootScope.globals.currentUser;
            vm.loading = false;
            vm.objModel = {
                person_type: 'PJ',
                filial_related: ($rootScope.globals.currentUser.profile === 'filial') ? $rootScope.globals.currentUser : undefined
            };
            vm.limit_options = ["5","10","30","50","100"];
            vm.filter = {
                person_type: 'both',
                value: '',
                limit: "5"
            };
        }

        function getDataById() {
            $http({
                method: "GET",
                url: Utils.getBaseUrlApi()+'/person/'+ Utils.getUrlVars().id
            }).then(
                function successCallback(response) {
                    if(!Utils.isEmpty(response.data.adresses)){
                        angular.forEach(response.data.adresses, function(address){
                            address.delete = false;
                        });
                    }
                    
                    if(!Utils.isEmpty(response.data.phones)){
                        angular.forEach(response.data.phones, function(phone){
                            phone.delete = false;
                        });
                    }

                    if(!Utils.isEmpty(response.data.emails)){
                        angular.forEach(response.data.emails, function(email){
                            email.delete = false;
                        });
                    }

                    if(!Utils.isEmpty(response.data.foto)) {
                        response.data.foto = {
                            path: Utils.getBaseUrlApi() +"/"+ response.data.foto,
                            changed: false
                        };
                    }

                    vm.objModel = response.data;

                    if(vm.objModel.customer_related.person_type == 'PJ') {
                        if(!Utils.isEmpty(vm.objModel.customer_related.company_name))
                            vm.objModel.customer_related.label = vm.objModel.customer_related.company_name;
                        else
                            vm.objModel.customer_related.label = vm.objModel.customer_related.fantasy_name;
                    }
                    else
                        vm.objModel.customer_related.label = vm.objModel.customer_related.name;
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.removePhoto = function() {
            delete vm.objModel.foto;
        }

        vm.getAll = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/persons';
                req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);

            if(!Utils.isEmpty(vm.filter.person_type) && vm.filter.person_type != 'both')
                req_url += '&person_type='+ vm.filter.person_type;

            if(!Utils.isEmpty(vm.filter.value))
                req_url += '&filter='+ vm.filter.value;
            
            if ($rootScope.globals.currentUser.profile === 'filial') {
                req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
            }

            vm.items = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.items = response.data;
                },
                function errorCallback(response) {
                    vm.items = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        vm.selectPersonType = function() {
            vm.objModel.cpf_cnpj = null;
            if(vm.objModel.person_type == 'PJ'){
                vm.objModel.name = null;
            }
            else if(vm.objModel.person_type == 'PF') {
                vm.objModel.company_name = null;
                vm.objModel.fantasy_name = null;
                vm.objModel.branch_activity = null;
            }
        }

        vm.openModal = function(modal_name){
            var modal_instance = $uibModal.open({ 
                templateUrl: '/'+ modal_name +'.html',
                backdrop: false,
                controller: ModalInstanceCtrl
            });

            modal_instance.result.then(function(x,y,z){
                console.log(x,y,z);
            }, function(x,y,z){
                console.log(x,y,z);
            });

            ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
            function ModalInstanceCtrl($scope, $uibModalInstance) {
                $scope.loading = {
                    address: false
                };

                $scope.consultAddressByCEP = function() {
                    $scope.loading.address = true;

                    Utils.getAddressByCEP($scope.address.zip_code,
                        function successCallback(response) {
                            if(!response.data.erro) {
                                $scope.address = _.extend($scope.address, {
                                    street: response.data.logradouro,
                                    district: response.data.bairro,
                                    city: response.data.localidade,
                                    state: response.data.uf
                                });
                                $scope.loading.address = false;
                            }
                            else {
                                toaster.pop({
                                    type: 'error', 
                                    timeout: 2000, 
                                    bodyOutputType: 'trustedHtml',
                                    body: '<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!'
                                });
                                $scope.loading.address = false;
                            }
                        },
                        function errorCallback(response){
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!'
                            });
                        }
                    );
                    // $scope = _.extend(Utils.getAddressByCEP($scope.zip_code));
                }

                $scope.save = function (model) {
                    var added = false;

                    switch(model) {
                        case 'objModel':
                            break;
                        case 'address':
                            if(!Utils.validateFields($scope, '#form-address')) {
                                if(Utils.isEmpty(vm.objModel.adresses))
                                    vm.objModel.adresses = [];
                                var obj = angular.copy($scope[model]);
                                obj.delete = false;
                                vm.objModel.adresses.push(obj);
                                added = true;
                            }
                            break;
                        case 'phone':
                            if(!Utils.validateFields($scope, '#form-phone')) {
                                if(Utils.isEmpty(vm.objModel.phones))
                                    vm.objModel.phones = [];
                                var obj = angular.copy($scope[model]);
                                obj.delete = false;
                                vm.objModel.phones.push(obj);
                                added = true;
                            }
                            break;
                        case 'mail':
                            if(!Utils.validateFields($scope, '#form-email')) {
                                if(Utils.isEmpty(vm.objModel.emails))
                                    vm.objModel.emails = [];
                                var obj = angular.copy($scope[model]);
                                obj.delete = false;
                                vm.objModel.emails.push(obj);
                                added = true;
                            }
                            break;
                    }

                    if(added == true)
                        $uibModalInstance.close('closed');
                };

                $scope.closeModal = function(){
                    $uibModalInstance.close('closed');
                }
            }
        }

        vm.save = function() {
            if(!Utils.validateFields(vm, '#form-person')) {
                vm.loading = true;

                $http({
                    method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                    url: Utils.getBaseUrlApi()+'/person',
                    data: JSON.stringify(vm.objModel)
                }).then(
                    function successCallback(response) {
                        activate();

                        var success_message = '<strong>Operação realizada</strong><br/>'+
                                              'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                        toaster.pop({
                            type: 'success',
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: success_message,
                            onHideCallback: function() {
                                $state.go('app.person-list');
                            }
                        });
                    },
                    function errorCallback(response) {
                        vm.loading = false;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
                });
            }
        }

        vm.confirmDelete = function() {
            vm.loading = true;
            $http({
                method: "DELETE",
                url: Utils.getBaseUrlApi()+'/person/'+ Utils.getUrlVars().id
            }).then(
                function successCallback(response) {
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                        onHideCallback: function() {
                            $state.go('app.person-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.enableFotoUpload = function() {
            setTimeout(function(){
                $(".btn-upload").change(function(){
                    var file = this.files[0];
                    var reader = new FileReader();

                    if(Utils.isEmpty(vm.objModel.foto))
                        vm.objModel.foto = {};

                    var type = file.type.substring(file.type.indexOf('/')+1, file.type.length);
                    if(Utils.isEmpty(type)){
                        type = file.name.substring((file.name.lastIndexOf('.')+1), file.name.length);
                    }

                    vm.objModel.foto.name = file.name;
                    vm.objModel.foto.type = type;
                    vm.objModel.foto.size = (file.size / 1024);

                    if(vm.objModel.foto.size < 1024)
                        vm.objModel.foto.size = Utils.numberFormat(vm.objModel.foto.size, 2, ',', '.') + ' KB';
                    else if(vm.objModel.foto.size > 1024)
                        vm.objModel.foto.size = Utils.numberFormat(vm.objModel.foto.size, 2, ',', '.') + ' MB';

                    reader.onload = function (e) {
                        vm.objModel.foto.path = e.target.result;
                        vm.objModel.foto.changed = true;
                    }

                    if(!Utils.isEmpty(file))
                        reader.readAsDataURL(file);
                });
            }, 10);
        }

        if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
            getDataById();
    }
})();
// service.controller.js
(function() {
    'use strict';

    angular
        .module('app.cadastros')
        .controller('ServiceController', Controller);

    Controller.$inject = ['$log', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
    
    function Controller($log, $scope, $state, $http, $uibModal, Utils, toaster) {
        var vm = this;

        activate();

        function activate() {
            vm.loading = false;
            vm.objModel = {};
            vm.limit_options = ["5","10","30","50","100"];
            vm.filter = {
                value: '',
                limit: "5"
            };
        }

        function getDataById() {
            $http({
                    method: "GET",
                    url: `${Utils.getBaseUrlApi()}/service/${Utils.getUrlVars().id}`
                }).then(
                    function successCallback(response) {
                    	if(!Utils.isEmpty(response.data.aditional_fields)){
                            angular.forEach(response.data.records_layouts, function(layout){
                                layout.delete = false;
                            });
	                        angular.forEach(response.data.aditional_fields, function(field){
	                            field.delete = false;
	                        });
	                    }

                        if(!Utils.isEmpty(response.data.customer_related)) {
                            if(response.data.customer_related.person_type == 'PJ') {
                                if(!Utils.isEmpty(response.data.customer_related.company_name))
                                    response.data.customer_related.label = response.data.customer_related.company_name;
                                else
                                    response.data.customer_related.label = response.data.customer_related.fantasy_name;
                            }
                            else
                                response.data.customer_related.label = response.data.customer_related.name;
                        }

                        vm.objModel = response.data;
                    },
                    function errorCallback(response) {
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
        }

        vm.selectReportType = function(){
            switch(vm.objModel.report_model) {
                case 'report-simple-search':
                case 'report-simple-search-level-two':
                    vm.objModel.simplified = true;
                    break;
                default:
                    vm.objModel.simplified = false;
                    break;
            }
        }

        vm.addAditionalField = function() {
        	if(Utils.isEmpty(vm.objModel.aditional_fields))
        		vm.objModel.aditional_fields = [];
        
        	if(!Utils.isEmpty(_.findWhere(vm.objModel.aditional_fields, {name: vm.aditional_field.name, delete: false}))) {
        		toaster.pop({
        			type: 'error', 
        			timeout: 2000, 
        			bodyOutputType: 'trustedHtml',
        			body: '<strong>Desculpe!</strong><br/>Já existe um campo cadastrado com esses dados.'
        		});
        	}
        	else {
        		vm.aditional_field.delete = false;
        		vm.objModel.aditional_fields.push(angular.copy(vm.aditional_field));
        	}

    		vm.aditional_field = null;
        }

        vm.getAll = function(offset) {
            var req_url = `${Utils.getBaseUrlApi()}/services`;
                req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);

            if(!Utils.isEmpty(vm.filter.value))
                req_url += '&filter='+ vm.filter.value;

            if(!Utils.isEmpty(vm.filter.report_model))
                req_url += '&report_model='+ vm.filter.report_model;
            
            if(!Utils.isEmpty(vm.filter.customer_related))
                req_url += '&customer_related_id='+ vm.filter.customer_related.id;

            vm.items = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.items = response.data;
                },
                function errorCallback(response) {
                    vm.items = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        vm.save = function() {
            if(!Utils.validateFields(vm, '#form-person')) {
                vm.loading = true;

                $http({
                    method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                    url: `${Utils.getBaseUrlApi()}/service`,
                    data: JSON.stringify(vm.objModel)
                }).then(
                    function successCallback(response) {
                        activate();

                        var success_message = '<strong>Operação realizada</strong><br/>'+
                                              'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                        toaster.pop({
                            type: 'success',
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: success_message,
                            onHideCallback: function() {
                                $state.go('app.service-list');
                            }
                        });
                    },
                    function errorCallback(response) {
                        vm.loading = false;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
                });
            }
        }

        vm.confirmDelete = function() {
            vm.loading = true;
            $http({
                method: "DELETE",
                url: `${Utils.getBaseUrlApi()}/service/${Utils.getUrlVars().id}`
            }).then(
                function successCallback(response) {
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                        onHideCallback: function() {
                            $state.go('app.service-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.openModal = function(modal_name, item, obj_model_destination){
            var modal_instance = $uibModal.open({ 
                size: 'md',
                backdrop: false,
                templateUrl: '/'+ modal_name +'.html',
                controller: ModalInstanceCtrl
            });

            ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
            function ModalInstanceCtrl($scope, $uibModalInstance) {
                $scope.limit_options = ["5","10","30","50","100"];
                $scope.filter = {
                    value: '',
                    limit: "5"
                };

                if (!obj_model_destination) {
                    obj_model_destination = vm.objModel || {};
                }

                $scope.getOrderRecordLayouts = function(offset) {
                    let limit = parseInt($scope.filter.limit);
                    var req_url = `${Utils.getBaseUrlApi()}/order/records/layouts?offset=${offset}&limit=${limit}`;

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += `&filter=${$scope.filter.value}`;

                    $scope.layouts = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            if(!Utils.isEmpty(vm.objModel)) {
                                angular.forEach(response.data.records, function(item){
                                    if(!Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id})))
                                        item.selected = true;
                                });
                            }
                            $scope.layouts = response.data;
                        },
                        function errorCallback(response) {
                            $scope.layouts = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }

                $scope.addItem = function(item){
                    if(Utils.isEmpty(vm.objModel.records_layouts))
                        vm.objModel.records_layouts = [];
                    if(Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id}))) {
                        item.selected = true;
                        item.delete = false;
                        vm.objModel.records_layouts.push( angular.copy(item) );
                    }
                    else {
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>Este layout já foi adicionado na lista.'
                        });
                    }
                }

                $scope.selectItem = function(items, item_selected) {
                    angular.forEach(items, function(item) {
                        item.selected = false;
                    });
                    item_selected.selected = true;
                    $scope.selected_item = angular.copy(item_selected);
                }

                $scope.confirmSelectItem = function() {
                    obj_model_destination.customer_related = angular.copy($scope.selected_item);
                    if(obj_model_destination.customer_related.person_type == 'PJ') {
                        if(!Utils.isEmpty(obj_model_destination.customer_related.company_name))
                            obj_model_destination.customer_related.label = obj_model_destination.customer_related.company_name;
                        else
                            obj_model_destination.customer_related.label = obj_model_destination.customer_related.fantasy_name;
                    }
                    else
                        obj_model_destination.customer_related.label = obj_model_destination.customer_related.name;

                    $uibModalInstance.close('closed');
                }

                $scope.cancelSelection = function(){
                    $scope.service_selected = null;
                    $scope.objModelPerson = null;
                    $scope.new_cliente = false;
                    $uibModalInstance.close('closed');
                }

                $scope.getClientesEmpresas = function(offset) {
                    var req_url = Utils.getBaseUrlApi()+'/persons';
                        req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += '&filter='+ $scope.filter.value;

                    $scope.clientesEmpresas = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            if(!Utils.isEmpty(vm.service_selected)) {
                                angular.forEach(response.data.records, function(item){
                                    if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                        item.selected = true;
                                });
                            }
                            $scope.clientesEmpresas = response.data;
                        },
                        function errorCallback(response) {
                            $scope.clientesEmpresas = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }
            }
        }

        vm.addAttribute = () => {
            if(Utils.isEmpty(vm.objModel.attributes))
                vm.objModel.attributes = [];
            vm.objModel.attributes.push({});
        }

        vm.removeAttribute = (index) => {
            vm.objModel.attributes.splice(index, 1);
        }

        if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
            getDataById();
    }
})();
// user.controller.js
(function() {
    'use strict';

    angular
        .module('app.cadastros')
        .controller('UserController', Controller);

    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
    
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {
        var vm = this;

        activate();

        function activate() {
            vm.currentUser = $rootScope.globals.currentUser;
            vm.loading = false;
            vm.objModel = {
                filial_related: ($rootScope.globals.currentUser.profile === 'filial') ? $rootScope.globals.currentUser : undefined
            };
            vm.limit_options = ["5","10","30","50","100"];
            vm.filter = {
                value: '',
                limit: "5"
            };
            vm.password_field_type = "password";

            if(!Utils.isEmpty(vm.currentUser.customer))
                vm.objModel.customer = vm.currentUser.customer;
        }

        function getDataById() {
            $http({
                method: "GET",
                url: Utils.getBaseUrlApi()+'/user/'+ Utils.getUrlVars().id
            }).then(
                function successCallback(response) {
                    vm.objModel = response.data;

                    if(vm.objModel.customer.person_type == 'PJ') {
                        if(!Utils.isEmpty(vm.objModel.customer.company_name))
                            vm.objModel.customer.label = vm.objModel.customer.company_name;
                        else
                            vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                    }
                    else
                        vm.objModel.customer.label = vm.objModel.customer.name;
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.changePasswordFieldType = function() {
            if(vm.password_field_type == "password")
                vm.password_field_type = "text";
            else if(vm.password_field_type == "text")
                vm.password_field_type = "password";
        }

        vm.getAll = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/users';
                req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);

            if(!Utils.isEmpty(vm.filter.value))
                req_url += '&filter='+ vm.filter.value;

            if(!Utils.isEmpty(vm.currentUser.customer))
                req_url += '&customer_id='+ vm.currentUser.customer.id;
            
            if ($rootScope.globals.currentUser.profile === 'filial') {
                req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
              }

            vm.items = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.items = response.data;
                },
                function errorCallback(response) {
                    vm.items = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        vm.save = function() {
            if(!Utils.validateFields(vm, 'form[role="form"]')) {
                vm.loading = true;

                $http({
                    method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                    url: Utils.getBaseUrlApi()+'/user',
                    data: JSON.stringify(vm.objModel)
                }).then(
                    function successCallback(response) {
                        activate();

                        var success_message = '<strong>Operação realizada</strong><br/>'+
                                              'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                        toaster.pop({
                            type: 'success',
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: success_message,
                            onHideCallback: function() {
                                $state.go('app.user-list');
                            }
                        });
                    },
                    function errorCallback(response) {
                        vm.loading = false;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
                });
            }
        }

        vm.confirmDelete = function() {
            vm.loading = true;
            $http({
                method: "DELETE",
                url: Utils.getBaseUrlApi()+'/user/'+ Utils.getUrlVars().id
            }).then(
                function successCallback(response) {
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                        onHideCallback: function() {
                            $state.go('app.user-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.openModal = function(modal_name){
            var modal_instance = $uibModal.open({ 
                size: 'lg',
                backdrop: false,
                templateUrl: '/'+ modal_name +'.html',
                controller: ModalInstanceCtrl
            });

            ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
            function ModalInstanceCtrl($scope, $uibModalInstance) {
                $scope.loading = {
                    address: false
                };

                $scope.limit_options = ["5","10","30","50","100"];
                $scope.filter = {
                    value: '',
                    limit: "5"
                };

                $scope.getClientesEmpresas = function(offset) {
                    var req_url = Utils.getBaseUrlApi()+'/persons';
                        req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += '&filter='+ $scope.filter.value;
                    
                    if ($rootScope.globals.currentUser.profile === 'filial') {
                        req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
                    }

                    $scope.clientesEmpresas = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            if(!Utils.isEmpty(vm.service_selected)) {
                                angular.forEach(response.data.records, function(item){
                                    if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                        item.selected = true;
                                });
                            }
                            $scope.clientesEmpresas = response.data;
                        },
                        function errorCallback(response) {
                            $scope.clientesEmpresas = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }

                $scope.selectItem = function(items, item_selected) {
                    angular.forEach(items, function(item) {
                        item.selected = false;
                    });
                    item_selected.selected = true;
                    $scope.selected_item = angular.copy(item_selected);
                }

                $scope.confirmSelectItem = function() {
                    vm.objModel.customer = angular.copy($scope.selected_item);
                    if(vm.objModel.customer.person_type == 'PJ') {
                        if(!Utils.isEmpty(vm.objModel.customer.company_name))
                            vm.objModel.customer.label = vm.objModel.customer.company_name;
                        else
                            vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                    }
                    else
                        vm.objModel.customer.label = vm.objModel.customer.name;

                    $uibModalInstance.close('closed');
                }

                $scope.cancelSelection = function(){
                    $scope.service_selected = null;
                    $scope.objModelPerson = null;
                    $scope.new_cliente = false;
                    $uibModalInstance.close('closed');
                }
            }
        }

        if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
            getDataById();
    }
})();
(function() {
    'use strict';

    angular
        .module('app.core')
        .config(coreConfig);

    coreConfig.$inject = ['$controllerProvider', '$compileProvider', '$filterProvider', '$provide', '$animateProvider'];
    function coreConfig($controllerProvider, $compileProvider, $filterProvider, $provide, $animateProvider){

      var core = angular.module('app.core');
      // registering components after bootstrap
      core.controller = $controllerProvider.register;
      core.directive  = $compileProvider.directive;
      core.filter     = $filterProvider.register;
      core.factory    = $provide.factory;
      core.service    = $provide.service;
      core.constant   = $provide.constant;
      core.value      = $provide.value;

      // Disables animation on items with class .ng-no-animation
      $animateProvider.classNameFilter(/^((?!(ng-no-animation)).)*$/);

      // Improve performance disabling debugging features
      // $compileProvider.debugInfoEnabled(false);

    }

    angular
      .module('app.core')
      .config(['$httpProvider', Interceptor]);

    function Interceptor($httpProvider) {
      $httpProvider.interceptors.push('Interceptors')
    }

})();
/**=========================================================
 * Module: constants.js
 * Define constants to inject across the application
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.core')
        .constant('APP_MEDIAQUERY', {
          'desktopLG':             1200,
          'desktop':                992,
          'tablet':                 768,
          'mobile':                 480
        })
      ;

})();
(function() {
    'use strict';

    angular
        .module('app.core')
        .run(appRun);

    appRun.$inject = ['$rootScope', '$state', '$stateParams', '$window', '$templateCache', 'Colors', '$location', '$cookies'];
    
    function appRun($rootScope, $state, $stateParams, $window, $templateCache, Colors, $location, $cookies) {
      
      // Set reference to access them from any scope
      $rootScope.$state = $state;
      $rootScope.$stateParams = $stateParams;
      $rootScope.$storage = $window.localStorage;

      // Uncomment this to disable template cache
      /*$rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams) {
          if (typeof(toState) !== 'undefined'){
            $templateCache.remove(toState.templateUrl);
          }
      });*/

      // Allows to use branding color with interpolation
      // {{ colorByName('primary') }}
      $rootScope.colorByName = Colors.byName;

      // cancel click event easily
      $rootScope.cancel = function($event) {
        $event.stopPropagation();
      };

      // Hooks Example
      // ----------------------------------- 

      // Hook not found
      $rootScope.$on('$stateNotFound',
        function(event, unfoundState/*, fromState, fromParams*/) {
            console.log(unfoundState.to); // "lazy.state"
            console.log(unfoundState.toParams); // {a:1, b:2}
            console.log(unfoundState.options); // {inherit:false} + default options
        });
      // Hook error
      $rootScope.$on('$stateChangeError',
        function(event, toState, toParams, fromState, fromParams, error){
          console.log(error);
        });
      // Hook success
      $rootScope.$on('$stateChangeSuccess',
        function(/*event, toState, toParams, fromState, fromParams*/) {
          // display new view from top
          $window.scrollTo(0, 0);
          // Save the route title
          $rootScope.currTitle = $state.current.title;
        });

      // Load a title dynamically
      $rootScope.currTitle = $state.current.title;
      $rootScope.pageTitle = function() {
        var title = $rootScope.app.name + ' - ' + ($rootScope.currTitle || $rootScope.app.description);
        document.title = title;
        return title;
      };      

      $rootScope.globals = $cookies.getObject('globals') || {};
      $rootScope.$on('$locationChangeStart', function(event, next, current) {
        // redirect to login page if not logged in and trying to access a restricted page
        var restrictedPage = $.inArray($location.path(), ['/page/login']) === -1;
        var loggedIn = $rootScope.globals.currentUser;
        if(restrictedPage && !loggedIn) {
          $location.path('/page/login');
        }
      });
    }

})();


(function() {
    'use strict';

    angular
        .module('app.lazyload')
        .config(lazyloadConfig);

    lazyloadConfig.$inject = ['$ocLazyLoadProvider', 'APP_REQUIRES'];
    function lazyloadConfig($ocLazyLoadProvider, APP_REQUIRES){

      // Lazy Load modules configuration
      $ocLazyLoadProvider.config({
        debug: false,
        events: true,
        modules: APP_REQUIRES.modules
      });

    }
})();
(function() {
    'use strict';

    angular
        .module('app.lazyload')
        .constant('APP_REQUIRES', {
          // jQuery based and standalone scripts
          scripts: {
            'underscore': ['vendor/underscore/underscore-min.js'],
            'highcharts': ['vendor/highcharts/highcharts.js'],
            'pdfobject':  ['vendor/pdfobject/pdfobject.js'],
            'modernizr':  ['vendor/modernizr/modernizr.custom.js'],
            'icons':      ['vendor/fontawesome/css/font-awesome.min.css', 'vendor/simple-line-icons/css/simple-line-icons.css']
          },
          // Angular based script (use the right module name)
          modules: [
            {
              name: 'cp.ngConfirm',
              files: [
                'vendor/angular-confirm/dist/angular-confirm.min.js', 
                'vendor/angular-confirm/dist/angular-confirm.min.css'
              ]
            },
            {
              name: 'easypiechart',
              files: [
                'vendor/jquery.easy-pie-chart/dist/angular.easypiechart.min.js'
              ]
            },
            {
              name: 'angular-underscore', 
              files: [
                'vendor/angular-underscore/angular-underscore.min.js'
              ]
            },
            {
              name: 'angular-input-masks', 
              files: [
                'vendor/angular-input-masks/angular-input-masks-standalone.min.js'
              ]
            },
            {
              name: 'brasil.filters', 
              files: [
                'vendor/ng-filters-br/dist/ng-filters-br.min.js'
              ]
            },
            {
              name: 'angularBootstrapConfirm', 
              files: [
                'vendor/angular-bootstrap-confirm/dist/angular-bootstrap-confirm.min.js'
              ]
            },
            {
              name: 'toaster', 
              files: [
                'vendor/angularjs-toaster/toaster.min.js', 
                'vendor/angularjs-toaster/toaster.min.css'
              ]
            },
            {
              name: 'angular-highcharts', 
              files: [
                'vendor/highcharts-ng/dist/highcharts-ng.js', 
                'vendor/highcharts-ng/dist/highcharts-ng.css'
              ]
            },
            {
              name: 'summernote',
              files: [
                'vendor/bootstrap/js/modal.js',
                'vendor/bootstrap/js/dropdown.js',
                'vendor/bootstrap/js/tooltip.js',
                'vendor/summernote/dist/summernote.css',
                'vendor/summernote/dist/summernote.js',
                'vendor/angular-summernote/dist/angular-summernote.js'
              ], 
              serie: true
            },
            {
              name: 'webcam', 
              files: [
                'vendor/webcam/dist/webcam.min.js'
              ]
            }
          ]
        })
        ;

})();

// dashboard-controller.js
(function() {
    'use strict';

    angular
        .module('app.gerenciamento')
        .controller('DashboardController', Controller);

    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster', 'WebcamService', 'Colors'];

    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster, WebcamService, Colors) {
        var vm = this;
        
        activate();
        
        ////////////////
        
        function activate() {
            vm.currentUser = $rootScope.globals.currentUser;

            vm.chartConfigModel = {
                chartType: 'chart',
                credits: {
                    enabled: false
                },
                chart: {
                    height: 200,
                    type: 'pie',
                    plotBackgroundColor: null,
                    plotBorderWidth: null,
                    plotShadow: false
                },
                plotOptions: {
                    pie: {
                        allowPointSelect: false,
                        cursor: 'pointer',
                        dataLabels: {
                            enabled: false
                        },
                        showInLegend: false
                    },
                    column: {
                        showInLegend: false
                    },
                    area: {
                        pointStart: 1940,
                        marker: {
                            enabled: false,
                            symbol: 'circle',
                            radius: 2,
                            states: {
                                hover: {
                                    enabled: true
                                }
                            }
                        }
                    }
                },
                title: {
                    text: null
                },
                tooltip: {
                    pointFormat: '{series.name}: <b>{point.y}</b>'
                }
            };

            vm.chartConfigAblesUnables = angular.copy(vm.chartConfigModel);
            vm.chartConfigAblesUnablesEarly = angular.copy(vm.chartConfigModel);
            vm.chartConfigCriticality = angular.copy(vm.chartConfigModel);
            vm.chartConfigBusinessUnits = angular.copy(vm.chartConfigModel);
            vm.chartConfigOrdersServices = angular.copy(vm.chartConfigModel);
            vm.chartConfigResearchesServices = angular.copy(vm.chartConfigModel);
            vm.chartConfigAndamentoStatus = angular.copy(vm.chartConfigModel);
            vm.chartConfigOrdersCustomers = angular.copy(vm.chartConfigModel);
            vm.chartConfigOrdersEarly = angular.copy(vm.chartConfigModel);
            vm.chartConfigBillingEarly = angular.copy(vm.chartConfigModel);
            vm.chartConfigResearchesEarly = angular.copy(vm.chartConfigModel);

            vm.easyPiePercent = 0;
            vm.pieOptions = {
                animate: {
                    duration: 800,
                    enabled: true
                },
                barColor: Colors.byName('success'),
                trackColor: 'rgba(200,200,200,0.4)',
                scaleColor: true,
                lineWidth: 10,
                lineCap: 'round',
                size: (vm.currentUser.profile === 'master') ? 195 : 245
            };

            vm.filter = {
                dta_from: moment().startOf('month').toDate(),
                dta_to: moment().endOf('month').toDate()
            };
            
            vm.dpOptions = {
                formatYear: 'yy',
                startingDay: 1
            };

            vm.counters = {
                all: 0,
                done: 0,
                pending: 0,
                customers: 0
            };

            if(!Utils.isEmpty(vm.currentUser.customer)) {
                vm.filter.customer = vm.currentUser.customer;
                if(vm.filter.customer.person_type == 'PJ') {
                    if(!Utils.isEmpty(vm.filter.customer.company_name))
                        vm.filter.customer.label = vm.filter.customer.company_name;
                    else
                        vm.filter.customer.label = vm.filter.customer.fantasy_name;
                }
                else
                    vm.filter.customer.label = vm.filter.customer.name;
            }
        }

        vm.applyFilter = function() {
            var dta_from = null,
                dta_to = null;

            if(!Utils.isEmpty(vm.filter.dta_from)){
                dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
                dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo De é obrigatório'
                });
            }

            if(!Utils.isEmpty(vm.filter.dta_to)) {
                dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
                dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo Até é obrigatório'
                });
            }

            if(!Utils.isEmpty(dta_from) && !Utils.isEmpty(dta_to)) {
                loadOrdersCustomersByStatus(dta_from, dta_to, 'pending', 'chartConfigAndamentoStatus', 'pie');
                loadOrdersCustomersByStatus(dta_from, dta_to, null, 'chartConfigOrdersCustomers', 'column');
                loadResearchesStatus(dta_from, dta_to);
                loadResearchesCriticality(dta_from, dta_to);
                loadResearchesByBusinessUnits(dta_from, dta_to, 'chartConfigBusinessUnits', 'column');
                loadOrdersStatus(dta_from, dta_to);
                loadOrdersByService(dta_from, dta_to, 'chartConfigOrdersServices', 'pie');
                loadResearchesByService(dta_from, dta_to, 'chartConfigResearchesServices', 'column');
                loadOrdersEarly();
                loadResearchesEarly();
                loadResearchesStatusEarly();
            }
        }

        vm.openDatepicker = function($event, model) {
            $event.preventDefault();
            $event.stopPropagation();
            vm['dp_'+ model +'_opened'] = true;
        }

        function loadOrdersCustomersByStatus(dta_from, dta_to, status, chart_name, chart_type) {
            vm.counters = {
                all: 0,
                done: 0,
                pending: 0
            };

            var req_url  = Utils.getBaseUrlApi();
                
                if(Utils.isEmpty(status))
                    req_url += '/reports/orders/customer';
                else
                    req_url += '/reports/orders/customer/'+ status;

                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;

                if(vm.currentUser.profile !== 'master') {
                    if(!Utils.isEmpty(vm.filter.customer)){
                        req_url += '&customer_id='+ vm.filter.customer.id;
                    }
                }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    var chart_data = [];

                    if(Utils.isEmpty(status)) 
                        vm.counters.customers = response.data.length;

                    for(var i = 0; i < response.data.length; i++) {
                        var item = response.data[i];

                        if(Utils.isEmpty(status)) 
                            vm.counters.all += item.orders;

                        if(!Utils.isEmpty(status))
                            vm.counters[status] += item.orders;
                        
                        if(!Utils.isEmpty(chart_name)) {
                            var customer_name = '';

                            if(item.customer.person_type == 'PJ') {
                                if(!Utils.isEmpty(item.customer.fantasy_name))
                                    customer_name = item.customer.fantasy_name;
                                else
                                    customer_name = item.customer.company_name;
                            }
                            else
                                customer_name = item.customer.name.toUpperCase();

                            chart_data.push({
                                name: customer_name,
                                y: item.orders
                            });
                        }
                    }

                    if(!Utils.isEmpty(chart_name)) {
                        vm[chart_name] = angular.copy(vm.chartConfigModel);
                        vm[chart_name].chart.type = chart_type;

                        switch(chart_type) {
                            case 'column':
                                vm[chart_name].yAxis = {
                                    min: 0,
                                    title: {
                                        text: 'Ordens de Serviço'
                                    }
                                };
                                
                                vm[chart_name].xAxis = {
                                    categories: []
                                };

                                for(var i = 0; i < chart_data.length; i++) {
                                    var item = chart_data[i];
                                    vm[chart_name].xAxis.categories.push(item.name);
                                }

                                break;
                        }

                        vm[chart_name].series = [{
                            name: "Ordens de Serviço", 
                            colorByPoint: true,
                            data: chart_data,
                            id: 's1'
                        }];
                    }
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadResearchesByService(dta_from, dta_to, chart_name, chart_type) {
            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/researches/service';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    var chart_data = [];

                    for(var i = 0; i < response.data.length; i++) {
                        var item = response.data[i];

                        if(!Utils.isEmpty(chart_name)) {
                            chart_data.push({
                                name: item.service.name.toUpperCase(),
                                y: item.orders
                            });
                        }
                    }

                    if(!Utils.isEmpty(chart_name)) {
                        vm[chart_name] = angular.copy(vm.chartConfigModel);
                        vm[chart_name].chart.type = chart_type;
                        vm[chart_name].chart.height = (vm.currentUser.profile === 'master') ? 200 : 250;

                        switch(chart_type) {
                            case 'column':
                                vm[chart_name].yAxis = {
                                    min: 0,
                                    title: {
                                        text: 'Pesquisas'
                                    }
                                };
                                
                                vm[chart_name].xAxis = {
                                    categories: []
                                };

                                for(var i = 0; i < chart_data.length; i++) {
                                    var item = chart_data[i];
                                    vm[chart_name].xAxis.categories.push(item.name);
                                }

                                break;
                        }

                        vm[chart_name].series = [{
                            name: "Pesquisas", 
                            colorByPoint: true,
                            data: chart_data,
                            id: 's1'
                        }];
                    }
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadOrdersByService(dta_from, dta_to, chart_name, chart_type) {
            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/orders/service';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    var chart_data = [];

                    for(var i = 0; i < response.data.length; i++) {
                        var item = response.data[i];

                        if(!Utils.isEmpty(chart_name)) {
                            chart_data.push({
                                name: item.service.name.toUpperCase(),
                                y: item.orders
                            });
                        }
                    }

                    if(!Utils.isEmpty(chart_name)) {
                        vm[chart_name] = angular.copy(vm.chartConfigModel);
                        vm[chart_name].chart.type = chart_type;
                        vm[chart_name].chart.height = (vm.currentUser.profile === 'master') ? 200 : 250;

                        switch(chart_type) {
                            case 'column':
                                vm[chart_name].yAxis = {
                                    min: 0,
                                    title: {
                                        text: 'Ordens de Serviço'
                                    }
                                };
                                
                                vm[chart_name].xAxis = {
                                    categories: []
                                };

                                for(var i = 0; i < chart_data.length; i++) {
                                    var item = chart_data[i];
                                    vm[chart_name].xAxis.categories.push(item.name);
                                }

                                break;
                        }

                        vm[chart_name].series = [{
                            name: "Ordens de Serviço", 
                            colorByPoint: true,
                            data: chart_data,
                            id: 's1'
                        }];
                    }
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadResearchesByBusinessUnits(dta_from, dta_to, chart_name, chart_type) {
            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/researches/business-units';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    var chart_data = [];

                    for(var i = 0; i < response.data.length; i++) {
                        var item = response.data[i];

                        if(!Utils.isEmpty(chart_name)) {
                            chart_data.push({
                                name: (!Utils.isEmpty(item.business_unit)) ? item.business_unit.description.toUpperCase() : 'N/D',
                                y: item.researches
                            });
                        }
                    }

                    if(!Utils.isEmpty(chart_name)) {
                        vm[chart_name] = angular.copy(vm.chartConfigModel);
                        vm[chart_name].chart.type = chart_type;
                        vm[chart_name].chart.height = (vm.currentUser.profile === 'master') ? 200 : 250;

                        switch(chart_type) {
                            case 'column':
                                vm[chart_name].yAxis = {
                                    min: 0,
                                    title: {
                                        text: 'Pesquisas'
                                    }
                                };
                                
                                vm[chart_name].xAxis = {
                                    categories: []
                                };

                                for(var i = 0; i < chart_data.length; i++) {
                                    var item = chart_data[i];
                                    vm[chart_name].xAxis.categories.push(item.name);
                                }

                                break;
                        }

                        vm[chart_name].series = [{
                            name: "Pesquisas", 
                            colorByPoint: true,
                            data: chart_data,
                            id: 's1'
                        }];
                    }
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadOrdersStatus(dta_from, dta_to) {
            vm.easyPiePercent = 0;
            vm.counters.done = 0;

            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/orders/status';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    var qtd_all = 0;
                    var qtd_done = 0;
                    var qtd_others = 0;

                    for(var i = 0; i < response.data.length; i++) {
                        var item = response.data[i];

                        qtd_all += item.orders;

                        if(item.status == 'done') {
                            qtd_done += item.orders;
                            vm.counters.done += item.orders;
                        }
                        else
                            qtd_others += item.orders;
                    }

                    if(qtd_done > 0)
                        vm.easyPiePercent = ((qtd_done / qtd_all) * 100);
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadOrdersEarly() {
            var dta_from = moment().subtract(12, 'months').format('YYYY-MM-DD HH:mm:ss'),
                dta_to = moment().endOf('month').format('YYYY-MM-DD HH:mm:ss')

            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/orders/customer/early';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;
            
            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    response.data = _.sortBy(response.data, 'date');
                    
                    angular.forEach(response.data, function(item) {
                        item.date_formated = moment(item.date, 'YYYY-MM').format('MM/YYYY');
                    });

                    structureOrdersEarlyData(response.data);
                    structureBillingEarlyData(response.data);
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }
        
        function structureOrdersEarlyData(data) {
            var chart_data = [];

            angular.forEach(data, function(item) {
                chart_data.push({
                    name: moment(item.date, 'YYYY-MM').format('MMM/YYYY'), // moment((x+1),'M').format('MMM') +'/'+ moment().format('YYYY')
                    y: item.orders
                });
            });

            // var chart_data = [];

            // for(var x = 0; x < data.length; x++) {
            //     var obj_mes = {
            //         name: moment(data[x].date_formated, 'MM/YYYY').format('MMM/YYYY'), // moment((x+1),'M').format('MMM') +'/'+ moment().format('YYYY')
            //         y: 0
            //     };

            //     for(var i = 0; i < data.length; i++) {
            //         var item = data[i];

            //         if((x+1) == item.month)
            //             obj_mes.y = item.orders;
            //     }

            //     chart_data.push(obj_mes);
            // }

            vm.chartConfigOrdersEarly = {
                credits: {
                    enabled: false
                },
                chart: {
                    height: 200,
                    type: 'area'
                },
                title: {
                    text: null
                },
                tooltip: {
                    pointFormat: '{series.name}: <b>{point.y}</b>'
                },
                plotOptions: {
                    area: {
                        marker: {
                            enabled: false,
                            symbol: 'circle',
                            radius: 2,
                            states: {
                                hover: {
                                    enabled: true
                                }
                            }
                        },
                        showInLegend: false
                    }
                },
                series: [{
                    name: 'Ordens de Serviço',
                    data: chart_data
                }]
            };
            
            vm.chartConfigOrdersEarly.yAxis = {
                min: 0,
                title: {
                    text: 'Ordens de Serviço'
                }
            };
            
            vm.chartConfigOrdersEarly.xAxis = {
                categories: []
            };

            for(var i = 0; i < chart_data.length; i++) {
                var item = chart_data[i];
                vm.chartConfigOrdersEarly.xAxis.categories.push(item.name);
            }
        }

        function structureBillingEarlyData(data) {
            var chart_data = [];

            angular.forEach(data, function(item) {
                chart_data.push({
                    name: moment(item.date, 'YYYY-MM').format('MMM/YYYY'), // moment((x+1),'M').format('MMM') +'/'+ moment().format('YYYY')
                    y: item.ammount
                });
            });

            // var chart_data = [];

            // for(var x = 0; x < data.length; x++) {
            //     var obj_mes = {
            //         name: moment(data[x].date_formated, 'MM/YYYY').format('MMM/YYYY'),
            //         y: 0
            //     };

            //     for(var i = 0; i < data.length; i++) {
            //         var item = data[i];

            //         if((x+1) == item.month)
            //             obj_mes.y = item.ammount;
            //     }

            //     chart_data.push(obj_mes);
            // }

            vm.chartConfigBillingEarly = {
                credits: {
                    enabled: false
                },
                chart: {
                    height: 200,
                    type: 'area'
                },
                title: {
                    text: null
                },
                plotOptions: {
                    area: {
                        marker: {
                            enabled: false,
                            symbol: 'circle',
                            radius: 2,
                            states: {
                                hover: {
                                    enabled: true
                                }
                            }
                        },
                        showInLegend: false
                    }
                },
                tooltip: {
                    pointFormatter: function() {
                        return `R$ ${Utils.numberFormat(this.y, 2, ',', '.')}`;
                    }
                },
                series: [{
                    name: 'Faturamento',
                    data: chart_data
                }]
            };
            
            vm.chartConfigBillingEarly.yAxis = {
                min: 0,
                title: {
                    text: 'Faturamento'
                }
            };
            
            vm.chartConfigBillingEarly.xAxis = {
                categories: []
            };

            for(var i = 0; i < chart_data.length; i++) {
                var item = chart_data[i];
                vm.chartConfigBillingEarly.xAxis.categories.push(item.name);
            }
        }
        
        function loadResearchesEarly() {
            var dta_from = moment().subtract(12, 'months').format('YYYY-MM-DD HH:mm:ss'),
                dta_to = moment().endOf('month').format('YYYY-MM-DD HH:mm:ss')

            var req_url  = Utils.getBaseUrlApi();
                req_url += '/reports/researches/customer/early';
                req_url += '?dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;
            
            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    req_url += '&customer_id='+ vm.filter.customer.id;
                }
            }

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    response.data = _.sortBy(response.data, 'date');

                    var chart_data = [];

                    angular.forEach(response.data, function(item) {
                        item.date_formated = moment(item.date, 'YYYY-MM').format('MM/YYYY');
                        chart_data.push({
                            name: moment(item.date, 'YYYY-MM').format('MMM/YYYY'), // moment((x+1),'M').format('MMM') +'/'+ moment().format('YYYY')
                            y: item.researches
                        });
                    });
                    
                    // for(var x = 0; x < response.data.length; x++) {
                    //     var obj_mes = {
                    //         name: moment(response.data[x].date_formated, 'MM/YYYY').format('MMM/YYYY'), // moment((x+1),'M').format('MMM') +'/'+ moment().format('YYYY')
                    //         y: 0
                    //     };

                    //     for(var i = 0; i < response.data.length; i++) {
                    //         var item = response.data[i];

                    //         if((x+1) == item.month)
                    //             obj_mes.y = item.researches;
                    //     }

                    //     chart_data.push(obj_mes);
                    // }

                    vm.chartConfigResearchesEarly = {
                        credits: {
                            enabled: false
                        },
                        chart: {
                            height: 200,
                            type: 'area'
                        },
                        title: {
                            text: null
                        },
                        tooltip: {
                            pointFormat: '{series.name}: <b>{point.y}</b>'
                        },
                        plotOptions: {
                            area: {
                                marker: {
                                    enabled: false,
                                    symbol: 'circle',
                                    radius: 2,
                                    states: {
                                        hover: {
                                            enabled: true
                                        }
                                    }
                                },
                                showInLegend: false
                            }
                        },
                        series: [{
                            name: 'Pesquisas',
                            data: chart_data
                        }]
                    };
                    
                    vm.chartConfigResearchesEarly.yAxis = {
                        min: 0,
                        title: {
                            text: 'Pesquisas'
                        }
                    };
                    
                    vm.chartConfigResearchesEarly.xAxis = {
                        categories: []
                    };

                    for(var i = 0; i < chart_data.length; i++) {
                        var item = chart_data[i];
                        vm.chartConfigResearchesEarly.xAxis.categories.push(item.name);
                    }
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        function loadResearchesStatus(dta_from, dta_to) {
            vm.qtd_total = 0;
            vm.vlr_total = 0;
    
            let params = [{
                key: 'dta_from',
                value: dta_from
            },{
                key: 'dta_to',
                value: dta_to
            }];

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    params.push({
                        key: 'customer_id',
                        value: vm.filter.customer.id
                    });
                }
            }
    
            let query_string = Utils.generateQueryString(params);
    
            var req_url  = Utils.getBaseUrlApi();
                req_url += `/reports/researches/status${query_string}`;
    
            $http({
              method: "GET",
              url: req_url
            }).then(
              function successCallback(response) {
                let counters  = response.data;

                let able_label = 'Apto';
                let unable_label = 'Inapto';

                if(vm.currentUser.profile !== 'master' && !Utils.isEmpty(vm.currentUser.customer)) {
                    able_label = vm.currentUser.customer.able_label;
                    unable_label = vm.currentUser.customer.unable_label;
                }

                vm.chartConfigAblesUnables = {
                    chart: {
                        type: 'bar'
                    },
                    title: {
                        text: null
                    },
                    credits: {
                        enabled: false
                    },
                    xAxis: {
                        categories: ['Apto', 'Inapto']
                    },
                    yAxis: {
                        min: 0,
                        title: {
                            text: 'Qtd. Pesquisas'
                        }
                    },
                    tooltip: {
                        headerFormat: '<b>{point.x}</b><br/>',
                        pointFormat: '{series.name}: {point.y}'
                    },
                    plotOptions: {
                        series: {
                            stacking: 'percent'
                        }
                    },
                    series: [{
                        name: 'Aptos',
                        data: [counters.ables.total, 0],
                        color: '#73db5c'
                    }, {
                        name: 'Inapto c/ Criminal',
                        data: [0, counters.unables.criminal],
                        color: '#c42525'
                    }, {
                        name: 'Inapto c/ Financeiro',
                        data: [0, counters.unables.finance],
                        color: '#4572A7'
                    }, {
                        name: 'Inapto c/ B.O.',
                        data: [0, counters.unables.accident_report],
                        color: '#3D96AE'
                    }]
                };

                vm.chartConfigAblesUnables.chart.height = 200;
              },
              function errorCallback(response) {
                toaster.pop({
                  type: 'error', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Desculpe!</strong><br/>'+response.data
                });
              }
            );
        }

        function loadResearchesStatusEarly() {
            var dta_from = moment().startOf('year').format('YYYY-MM-DD HH:mm:ss'),
                dta_to = moment().endOf('year').format('YYYY-MM-DD HH:mm:ss')

            vm.qtd_total = 0;
            vm.vlr_total = 0;
    
            let params = [{
                key: 'dta_from',
                value: dta_from
            },{
                key: 'dta_to',
                value: dta_to
            }];

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    params.push({
                        key: 'customer_id',
                        value: vm.filter.customer.id
                    });
                }
            }
    
            let query_string = Utils.generateQueryString(params);
    
            var req_url = `${Utils.getBaseUrlApi()}/reports/researches/status${query_string}`;
    
            $http({
              method: "GET",
              url: req_url
            }).then(
              function successCallback(response) {
                let counters  = response.data;

                vm.chartConfigAblesUnablesEarly = {
                    chart: {
                        type: 'bar'
                    },
                    title: {
                        text: null
                    },
                    credits: {
                        enabled: false
                    },
                    xAxis: {
                        categories: ['Apto', 'Inapto']
                    },
                    yAxis: {
                        min: 0,
                        title: {
                            text: 'Qtd. Pesquisas'
                        }
                    },
                    tooltip: {
                        headerFormat: '<b>{point.x}</b><br/>',
                        pointFormat: '{series.name}: {point.y}'
                    },
                    plotOptions: {
                        series: {
                            stacking: 'percent'
                        }
                    },
                    series: [{
                        name: 'Aptos',
                        data: [counters.ables.total, 0],
                        color: '#73db5c'
                    }, {
                        name: 'Inapto c/ Criminal',
                        data: [0, counters.unables.criminal],
                        color: '#c42525'
                    }, {
                        name: 'Inapto c/ Financeiro',
                        data: [0, counters.unables.finance],
                        color: '#4572A7'
                    }, {
                        name: 'Inapto c/ B.O.',
                        data: [0, counters.unables.accident_report],
                        color: '#3D96AE'
                    }]
                };

                vm.chartConfigAblesUnablesEarly.chart.height = 200;
              },
              function errorCallback(response) {
                toaster.pop({
                  type: 'error', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Desculpe!</strong><br/>'+response.data
                });
              }
            );
        }

        function loadResearchesCriticality(dta_from, dta_to) {
            vm.qtd_total = 0;
            vm.vlr_total = 0;
    
            let params = [{
                key: 'dta_from',
                value: dta_from
            },{
                key: 'dta_to',
                value: dta_to
            }];

            if(vm.currentUser.profile !== 'master') {
                if(!Utils.isEmpty(vm.filter.customer)){
                    params.push({
                        key: 'customer_id',
                        value: vm.filter.customer.id
                    });
                }
            }
    
            let query_string = Utils.generateQueryString(params);
    
            var req_url  = Utils.getBaseUrlApi();
                req_url += `/reports/researches/criticality${query_string}`;
    
            $http({
              method: "GET",
              url: req_url
            }).then(
              function successCallback(response) {
                let chart_data = [{
                    name: 'Gravíssimo',
                    y: response.data.higher
                },{
                    name: 'Grave',
                    y: response.data.serious
                },{
                    name: 'Médio',
                    y: response.data.medium
                },{
                    name: 'Leve',
                    y: response.data.light
                }];

                vm.chartConfigCriticality = angular.copy(vm.chartConfigModel);
                vm.chartConfigCriticality.chart.type = 'column';
                vm.chartConfigCriticality.chart.height = (vm.currentUser.profile === 'master') ? 200 : 250;
                vm.chartConfigCriticality.yAxis = {
                    min: 0,
                    title: {
                        text: 'Qtd'
                    }
                };
                
                vm.chartConfigCriticality.xAxis = {
                    categories: ['Gravíssimo','Grave','Médio','Leve']
                };

                vm.chartConfigCriticality.series = [{
                    name: "Pesquisas", 
                    colorByPoint: true,
                    colors: ['#910000', '#f28f43', '#2f7ed8', '#0d233a'],
                    data: chart_data,
                    id: 's1'
                }];
              },
              
              function errorCallback(response) {
                toaster.pop({
                  type: 'error', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Desculpe!</strong><br/>'+response.data
                });
              }
            );
        }

        vm.applyFilter();
    }
})();
// measurement.controller.js
(function() {
    'use strict';
  
    angular
        .module('app.gerenciamento')
        .controller('MeasurementController', Controller);
  
    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
    
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {
      var vm = this;
  
      activate();
  
      function activate() {
          vm.currentUser = $rootScope.globals.currentUser;
          vm.loading = false;
          vm.objModel = {
              creator: vm.currentUser
          };
          vm.limit_options = ["5","10","30","50","100"];
          vm.filter = {
              value: '',
              limit: "5"
          };
          vm.password_field_type = "password";
  
          if(!Utils.isEmpty(vm.currentUser.customer))
              vm.objModel.customer = vm.currentUser.customer;
      }
  
      function getDataById() {
          $http({
              method: "GET",
              url: Utils.getBaseUrlApi()+'/measurement/'+ Utils.getUrlVars().id
          }).then(
              function successCallback(response) {
                  vm.objModel = response.data;
  
                  if(vm.objModel.customer.person_type == 'PJ') {
                      if(!Utils.isEmpty(vm.objModel.customer.company_name))
                          vm.objModel.customer.label = vm.objModel.customer.company_name;
                      else
                          vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                  }
                  else
                      vm.objModel.customer.label = vm.objModel.customer.name;
                  
                  angular.forEach(vm.objModel.orders, order => {
                      order.delete = false;
                  });
              },
              function errorCallback(response) {
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+response.data
                  });
              }
          );
      }
  
      vm.calculateTotalPersonsOS = (services) => {
      let total = 0;
      services.forEach(service => { total += service.companies.length });
      return total;
      }
  
      vm.calculateTotalServicesOS = (services) => {
      let total = 0;
      services.forEach(service => { total += (service.price * service.quantity) });
      return total;
      }
  
      vm.calculateTotalCostsOS = (costs) => {
      let total = 0;
      costs.forEach(cost => { total += cost.value });
      return total;
      }
      
      vm.calculateSubtotalOS = () => {
      let total = 0;
      if(!Utils.isEmpty(vm.objModel.orders)) {
          vm.objModel.orders.forEach(order => {
              if(!order.deleted) {
                  let services = vm.calculateTotalServicesOS(order.services);
                  let costs = vm.calculateTotalCostsOS(order.costs);
                  total += (services - costs);
              }
          });
      }
      return total;
      }
  
      vm.changePasswordFieldType = function() {
          if(vm.password_field_type == "password")
              vm.password_field_type = "text";
          else if(vm.password_field_type == "text")
              vm.password_field_type = "password";
      }
  
      vm.changeStatus = function(measurement, approved) {
          let status = (approved) ? 'approve' : 'reject';
          let payload = {
              id: measurement.id,
              user: vm.currentUser,
              customer: measurement.customer,
  
          };
  
          $http({
              method: 'PUT',
              url: `${Utils.getBaseUrlApi()}/measurement/${measurement.id}/${status}`,
              data: JSON.stringify(payload)
          }).then(
              function successCallback(response) {
                  vm.getAll(1);
                  var success_message = '<strong>Operação realizada</strong><br/>'+
                                        'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                  toaster.pop({
                      type: 'success',
                      timeout: 0, 
                      bodyOutputType: 'trustedHtml',
                      body: success_message
                  });
              },
              function errorCallback(response) {
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+response.data
                  });
              }
          );
      }
  
      vm.openReport = function(measurement, detailed) {
          var modal_instance = $uibModal.open({ 
              backdrop: false,
              size: 'xl',
              templateUrl: '/reportModal.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
              var report_url = `${Utils.getBaseUrlReports()}`;
                  report_url += '?template=report-measurement';
                  report_url += '&format=A4';
                  report_url += '&id='+ measurement.id;
              
              if(detailed)
                  report_url += '&detailed=true';
  
              $scope.showPDFReport = function() {
                  new PDFObject({
                      url: report_url, 
                      id: 'report-container',
                      height: '600px'
                  }).embed('report-container');
              }
  
              $scope.downloadArquivo = function() {
                  report_url += '&filename=' + $scope.nome_arquivo_download;
                  window.open(report_url, '_blank');
              }
  
              $scope.closeModal = function() {
                  $uibModalInstance.close({});
              }
          };
      }
  
      vm.getAll = function(offset) {
          var req_url = Utils.getBaseUrlApi()+'/measurements';
              req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);
  
          if(!Utils.isEmpty(vm.filter.value))
              req_url += '&filter='+ vm.filter.value;
  
          if(!Utils.isEmpty(vm.currentUser.customer))
              req_url += '&customer_id='+ vm.currentUser.customer.id;
  
          vm.items = {};
  
          $http({
              method: "GET",
              url: req_url
          }).then(
              function successCallback(response) {
                  vm.items = response.data;
                  angular.forEach(vm.items.records, item => {
                      item.vlr_total = 0;
                      angular.forEach(item.orders, order => {
                          angular.forEach(order.services, service => {
                              item.vlr_total += (service.price * service.quantity);
                          });
                      });
                      item.vlr_total -= item.discount;
                  });
              },
              function errorCallback(response) {
                  vm.items = null;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+ response.data
                  });
              }
          );
      }
  
      vm.save = function() {
          if(!Utils.validateFields(vm, 'form[role="form"]')) {
              vm.loading = true;
  
              let payload = angular.copy(vm.objModel);
                  payload.creator  = { id: vm.objModel.creator.id };
                  payload.customer = { id: vm.objModel.customer.id };
                  payload.orders.forEach((order, index) => {
                      payload.orders[index] = { 
                          id: order.id,
                          delete: order.delete
                      };
                  });
  
              let req_url = `${Utils.getBaseUrlApi()}/measurement`;
              let req_method = Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT";
  
              $http({
                  method: req_method,
                  url: (req_method === 'POST') ? req_url : `${req_url}/${vm.objModel.id}`,
                  data: JSON.stringify(payload)
              }).then(
                  function successCallback(response) {
                      activate();
  
                      var success_message = '<strong>Operação realizada</strong><br/>'+
                                          'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                      toaster.pop({
                          type: 'success',
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: success_message,
                          onHideCallback: function() {
                              $state.go('app.measurement-list');
                          }
                      });
                  },
                  function errorCallback(response) {
                      vm.loading = false;
                      toaster.pop({
                          type: 'error', 
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: '<strong>Desculpe!</strong><br/>'+response.data
                      });
                  }
              );
          }
          else {
              toaster.pop({
                  type: 'warning', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
              });
          }
      }
  
      vm.confirmDelete = function() {
          vm.loading = true;
          $http({
              method: "DELETE",
              url: Utils.getBaseUrlApi()+'/measurement/'+ Utils.getUrlVars().id
          }).then(
              function successCallback(response) {
                  toaster.pop({
                      type: 'success',
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                      onHideCallback: function() {
                          $state.go('app.measurement-list');
                      }
                  });
              },
              function errorCallback(response) {
                  vm.loading = false;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+response.data
                  });
              }
          );
      }
  
      vm.openOSDetails = function(order) {
          console.log(order);
          vm.currentOS = order;
          vm.openModal('orderDetailsModal');
      }
  
      vm.openModal = function(modal_name, modal_size){
          var modal_instance = $uibModal.open({ 
              size: (!Utils.isEmpty(modal_size)) ? modal_size : 'lg',
              backdrop: false,
              templateUrl: '/'+ modal_name +'.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $uibModalInstance) {
              $scope.limit_options = ["5","10","30","50","100"];
              $scope.filter = {
              value: '',
              limit: "5"
              };
  
              if(!Utils.isEmpty(vm.currentOS))
              $scope.order = vm.currentOS;
  
              $scope.getClientesEmpresas = function(offset) {
              var req_url = Utils.getBaseUrlApi()+'/persons';
                  req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);
  
              if(!Utils.isEmpty($scope.filter.value))
                  req_url += '&filter='+ $scope.filter.value;
  
              $scope.clientesEmpresas = {};
  
              $http({
                  method: "GET",
                  url: req_url
              }).then(
                  function successCallback(response) {
                  if(!Utils.isEmpty(vm.service_selected)) {
                      angular.forEach(response.data.records, function(item){
                      if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                          item.selected = true;
                      });
                  }
                  $scope.clientesEmpresas = response.data;
                  },
                  function errorCallback(response) {
                  $scope.clientesEmpresas = null;
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>'+ response.data
                  });
                  }
              );
              }
  
              $scope.getOrders = function(offset) {
              var req_url = Utils.getBaseUrlApi()+'/orders';
                  req_url += '?offset='+ offset;
                  req_url += '&limit='+ parseInt($scope.filter.limit);
                  req_url += '&order_by=+created_at';
                  req_url += '&customer_id='+ vm.objModel.customer.id;
                  req_url += '&status=done';
                  req_url += '&nin_measurement=true';
              
              if(!Utils.isEmpty($scope.filter.dta_from) && !Utils.isEmpty($scope.filter.dta_to)){
                  var dta_from = JSON.parse(JSON.stringify($scope.filter)).dta_from
                      dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
                  var dta_to = JSON.parse(JSON.stringify($scope.filter)).dta_to,
                      dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
                  req_url += '&dta_from='+ dta_from;
                  req_url += '&dta_to='+ dta_to;
              }
  
              $scope.orders = {};
  
              $http({
                  method: "GET",
                  url: req_url
              }).then(
                  function successCallback(response) {
                      if(!Utils.isEmpty(vm.objModel.orders)) {
                          angular.forEach(response.data.records, function(item){
                          if(!Utils.isEmpty(_.findWhere(vm.objModel.orders, {id: item.id})))
                              item.selected = true;
                          });
                      }
                      $scope.orders = response.data;
                  },
                  function errorCallback(response) {
                      $scope.orders = null;
                      toaster.pop({
                          type: 'error', 
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: '<strong>Desculpe!</strong><br/>'+ response.data
                      });
                  }
              );
              }
  
              $scope.calculateTotalPersonsOS = vm.calculateTotalPersonsOS;
  
              $scope.calculateTotalServicesOS = vm.calculateTotalServicesOS;
      
              $scope.calculateTotalCostsOS = vm.calculateTotalCostsOS;
  
              $scope.selectItem = function(items, item_selected) {
                  item_selected.selected = !item_selected.selected;
                  switch(modal_name) {
                  case 'personsModal':
                      $scope.selected_item = angular.copy(item_selected);
                      break;
                  case 'ordersModal':
                      if(Utils.isEmpty(_.findWhere(vm.objModel.orders, {id: item_selected.id}))){
                          if(Utils.isEmpty(vm.objModel.orders))
                              vm.objModel.orders = [];
                          item_selected.delete = false;
                          vm.objModel.orders.push(item_selected);
                      }
                      else {
                          angular.forEach(vm.objModel.orders, order => {
                              if(order.id === item_selected.id) {
                                  order.delete = !order.delete;
                              }
                          });
                      }
                      break;
                  }
              }
  
              $scope.confirmSelectItem = function() {
                  vm.objModel.customer = angular.copy($scope.selected_item);
                  if(vm.objModel.customer.person_type == 'PJ') {
                      if(!Utils.isEmpty(vm.objModel.customer.company_name))
                          vm.objModel.customer.label = vm.objModel.customer.company_name;
                      else
                          vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                  }
                  else
                      vm.objModel.customer.label = vm.objModel.customer.name;
  
                  $uibModalInstance.close('closed');
              }
  
              $scope.cancelSelection = function(){
                  $scope.order = null;
                  $scope.customer = null;
                  $uibModalInstance.close('closed');
              }
          }
      }
  
      if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
          getDataById();
    }
  })();
// order-proceedings.controller.js
(function() {
    'use strict';

    angular
        .module('app.gerenciamento')
        .controller('OrderProceedingsController', Controller);

    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster', 'WebcamService', '$window'];
    
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster, WebcamService, $window) {
        var vm = this;

        activate();

        function activate() {
            vm.currentUser = $rootScope.globals.currentUser;
            vm.loading = false;
            vm.objModel = {
                attachments: [],
                user_input: $rootScope.globals.currentUser,
                id: Utils.getUrlVars().order_id
            };
        }

        function getDataById() {
            $http({
                method: "GET",
                url: Utils.getBaseUrlApi()+'/order/'+ Utils.getUrlVars().order_id
            }).then( 
                function successCallback(response) {
                    if(response.data.customer.person_type == 'PJ') {
                        if(!Utils.isEmpty(response.data.customer.company_name))
                            response.data.customer.label = response.data.customer.company_name;
                        else
                            response.data.customer.label = response.data.customer.fantasy_name;
                    }
                    else{
                        response.data.customer.label = response.data.customer.name;
                    }
                    if(!Utils.isEmpty(response.data.services)){
                        angular.forEach(response.data.services, function(service_item){
                            service_item.delete = false;
                            if(service_item.service.id === Utils.getUrlVars().service_id) {
                                vm.objModel.service = service_item;

                                angular.forEach(service_item.companies, function(company){
                                    if(company.id === Utils.getUrlVars().company_id) {
                                        vm.objModel.company = company;
                                        if(vm.objModel.company.person_type == 'PJ') {
                                            if(!Utils.isEmpty(vm.objModel.company.company_name))
                                                vm.objModel.company.label = vm.objModel.company.company_name;
                                            else
                                                vm.objModel.company.label = vm.objModel.company.fantasy_name;
                                        }
                                        else
                                            vm.objModel.company.label = vm.objModel.company.name;
                                    }
                                });
                            }
                        });
                    }

                    vm.objModel.id = response.data.id;
                    vm.objModel.customer = response.data.customer;

                    if(Utils.isEmpty(Utils.getUrlVars().service_id) || Utils.isEmpty(Utils.getUrlVars().company_id))
                        vm.objModel = response.data;
                },
                function errorCallback(response) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.save = function() {
            if(vm.objModel.description != null){
                $('#description').removeClass('has-error');
                if (vm.objModel.attachments.length >= 1){
                    var req_method = "POST";

                    var req_url  = Utils.getBaseUrlApi();
                        req_url += '/order/'+ Utils.getUrlVars().order_id;
                        req_url += '/service/'+ Utils.getUrlVars().service_id;
                        req_url += '/company/'+ Utils.getUrlVars().company_id;
                        req_url += '/proceeding';
                    
                    if(!Utils.isEmpty(Utils.getUrlVars().proceeding_id)){
                        req_method = "PUT";
                        req_url += '/'+ Utils.getUrlVars().proceeding_id;
                    }

                    $http({
                        method: req_method,
                        url:    req_url,
                        data: JSON.stringify(vm.objModel)
                    }).then(
                        function successCallback(response) {
                            console.log(vm.objModel)
                            var success_message = '<strong>Operação realizada</strong><br/>'+
                                                'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                            toaster.pop({
                                type: 'success',
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: success_message,
                                onHideCallback: function() {
                                    $window.location.href = `${$state.href('app.order-proceedings-list')}?order_id=${vm.objModel.id}&service_id=${vm.objModel.service.id}`;
                                }
                            });
                        },
                        function errorCallback(response) {
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+response.data
                            });
                        }
                    );
                }else{
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: 'Inclua um anexo.'
                    });
                }
            }else{
                $('#description').addClass('has-error');             
                toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: 'Preencha a descrição do registro.'
                });
            }
        }

        vm.addAttachment = function() {
            if(!Utils.isEmpty(vm.objModel.attachment) && !Utils.isEmpty(vm.objModel.attachment.description)){
                $('#subtitle').removeClass('has-error');
                vm.objModel.attachments.push( angular.copy(vm.objModel.attachment) );
                vm.objModel.attachment = null;
            }
            else{
                $('#subtitle').addClass('has-error');
                toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: 'Coloque uma foto e a legenda para poder incluir um anexo.'
                });
            }
        }

        vm.removeAttachment = function(index) {
            for(var i = 0; i < vm.objModel.attachments.length; i ++){
                let teste = vm.objModel.attachments.splice(index, 1);
            }
        }

        vm.loadProceedings = function() {
            var req_url = Utils.getBaseUrlApi();
                req_url += '/order/'+ Utils.getUrlVars().order_id;
                req_url += '/service/'+ vm.service_selected.service.id;
                req_url += '/company/'+ vm.company_selected.id;
                req_url += '/proceedings';

            vm.proceedings = [];

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    angular.forEach(response.data, function (data){

                        data.service.name = vm.service_selected.service.name;
                        data.company.name = ((vm.company_selected.person_type == 'PF') ? vm.company_selected.name : vm.company_selected.company_name );  
                    })
                    
                    vm.proceedings = response.data;

                },
                function errorCallback(response) {
                    vm.proceedings = null;
                    if(Utils.isEmpty(vm.currentUser.customer)) {
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                }
            );
        }

        vm.editProceeding = function() {
            if(!Utils.isEmpty(Utils.getUrlVars().proceeding_id)){
                var req_url = Utils.getBaseUrlApi();
                req_url += '/order/'      + Utils.getUrlVars().order_id;
                req_url += '/service/'    + Utils.getUrlVars().service_id;
                req_url += '/company/'    + Utils.getUrlVars().company_id;
                req_url += '/proceeding/' + Utils.getUrlVars().proceeding_id;

                $http({
                    method: "GET",
                    url: req_url
                }).then(
                    function successCallback(response) {

                        response.data.company = vm.objModel.company;
                        response.data.customer = vm.objModel.customer;
                        response.data.service = vm.objModel.service;
                        vm.objModel = response.data;
                        console.log(vm.objModel);

                    },
                    function errorCallback(response) {
                        vm.proceedings = null;
                        if(Utils.isEmpty(vm.currentUser.customer)) {
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+response.data
                            });
                        }
                    }
                );
            }else{

            }
        }

        setTimeout(function() {
            $(".btn-upload").change(function(){
                var file = this.files[0];
                var reader = new FileReader();
                
                if(Utils.isEmpty(vm.objModel.attachment))
                    vm.objModel.attachment = {};

                var type = file.type.substring(file.type.indexOf('/')+1, file.type.length);
                if(Utils.isEmpty(type)){
                    type = file.name.substring((file.name.lastIndexOf('.')+1), file.name.length);
                }

                vm.objModel.attachment.name = file.name;
                vm.objModel.attachment.type = type;
                vm.objModel.attachment.size = (file.size / 1024);

                if(vm.objModel.attachment.size < 1024)
                    vm.objModel.attachment.size = Utils.numberFormat(vm.objModel.attachment.size, 2, ',', '.') + ' KB';
                else if(vm.objModel.attachment.size > 1024)
                    vm.objModel.attachment.size = Utils.numberFormat(vm.objModel.attachment.size, 2, ',', '.') + ' MB';

                reader.onload = function (e) {
                    var path = e.target.result;

                    vm.objModel.attachment.path = path;
                    vm.objModel.attachment.deleted = false;

                    setTimeout(function(){
                        $scope.$apply();
                    },1);
                }

                if(!Utils.isEmpty(file))
                    reader.readAsDataURL(file);
            });
        }, 10);

        if(
            !Utils.isEmpty(Utils.getUrlVars()) && 
            !Utils.isEmpty(Utils.getUrlVars().order_id)
        ) {
            getDataById();
        }
        else {
            $state.go('app.order-list');
        }

        this.editProceeding();
    }
})();
// order-record.controller.js
(function () {
  "use strict";

  angular.module("app.gerenciamento").controller("OrderRecordController", Controller);

  Controller.$inject = ["$log", "$rootScope", "$scope", "$state", "$http", "$uibModal", "$timeout", "Utils", "toaster", "WebcamService", "$ngConfirm", "SintegraService", "InfoSimplesService"];

  function Controller($log, $rootScope, $scope, $state, $http, $uibModal, $timeout, Utils, toaster, WebcamService, $ngConfirm, SintegraService, InfoSimplesService) {
    var vm = this;

    activate();

    function activate() {
      vm.currentUser = $rootScope.globals.currentUser;
      vm.dev_mode = false;

      vm.loading = {
        delete: false,
        startStop: false,
      };
    }

    function getDataById() {
      $http({
        method: "GET",
        url: Utils.getBaseUrlApi() + "/order/" + Utils.getUrlVars().id,
      }).then(
        function successCallback(response) {
          if (response.data.customer.person_type == "PJ") {
            if (!Utils.isEmpty(response.data.customer.company_name)) response.data.customer.label = response.data.customer.company_name;
            else response.data.customer.label = response.data.customer.fantasy_name;
          } else response.data.customer.label = response.data.customer.name;

          if (!Utils.isEmpty(response.data.services)) {
            angular.forEach(response.data.services, function (service_item) {
              service_item.delete = false;
            });
          }

          vm.objModel = response.data;

          if (!Utils.isEmpty(vm.service_selected)) {
            angular.forEach(vm.objModel.services, (service) => {
              if (vm.service_selected.id == service.id) {
                vm.service_selected = service;
              }
            });
          }

          if (!Utils.isEmpty(vm.company_selected)) {
            angular.forEach(vm.service_selected.companies, (company) => {
              if (vm.company_selected.id == company.id) {
                vm.company_selected = company;
              }
            });
          }
        },
        function errorCallback(response) {
          toaster.pop({
            type: "error",
            timeout: 2000,
            bodyOutputType: "trustedHtml",
            body: "<strong>Desculpe!</strong><br/>" + response.data,
          });
        }
      );
    }

    vm.onServiceChanged = () => {
      const reportModel = vm.getServiceAttributeValue(vm.service_selected.service, "research-type") || 
                          vm.service_selected.service.report_model;

      switch(reportModel) {
        case "report-check-list":
        case "report-simple-search-level-two":
        case "vehicles":
          vm.loadRecords(1,10);
          break;
      }

      vm.records = null; 
      vm.company_selected = null;
    }

    vm.confirmReportModel = (company) => {
      $ngConfirm({
        title: "Escolha uma opção!",
        content: "Deseja separar os nomes por página?",
        scope: $scope,
        theme: "dark",
        buttons: {
          ok: {
            text: "Sim",
            btnClass: "btn-primary",
            keys: ["enter"],
            action: (scope, button) => {
              vm.names_per_page_report = true;
              vm.openOSReport(company);
            },
          },
          cancel: {
            text: "Não",
            btnClass: "btn-default",
            action: (scope, button) => {
              vm.names_per_page_report = false;
              vm.openOSReport(company);
            },
          },
        },
      });
    };

    vm.openOSReport = function (company) {
      var modal_instance = $uibModal.open({
        backdrop: false,
        size: vm.service_selected.service.simplified ? "xl" : "lg",
        templateUrl: "/reportModal.html",
        controller: ModalInstanceCtrl,
      });

      if (!Utils.isEmpty(company)) {
        vm.company_selected = company;
      }

      ModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
      function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
        var report_url = `${Utils.getBaseUrlReports()}?order_id=${vm.objModel.id}&format=A4&service_id=${vm.service_selected.service.id}`;
        
        if (vm.service_selected.service.report_model != "report-check-list")
          report_url = `${report_url}&restrict-use-type=${vm.service_selected.service.simplified ? "text" : "icon"}`;

        if (!vm.service_selected.service.simplified && vm.service_selected.service.report_model != "report-check-list"){
          if (vm.getServiceAttributeValue(vm.service_selected.service, "research-type") !== 'vehicles')
            report_url = `${report_url}&company_id=${vm.company_selected.id}`;
        }

        if (vm.names_per_page_report)
          report_url = `${report_url}&names_per_page=true`;

        if (vm.service_selected.service.report_model === "report-advanced" && !Utils.isEmpty(vm.company_selected)) {
          report_url = `${report_url}&template=${vm.service_selected.service.report_model}-${(vm.company_selected.person_type === 'PF') ? 'person' : 'company'}`;
          let layout_model = vm.getServiceAttributeValue(vm.service_selected.service, "pdf-layout");
          if (layout_model === 'simple') {
            report_url = `${report_url}-${layout_model}`;
          }
        }
        else if (vm.getServiceAttributeValue(vm.service_selected.service, "research-type") === 'vehicles') {
          report_url = `${report_url}&template=report-simple-vehicle`;
        }
        else
          report_url = `${report_url}&template=${vm.service_selected.service.report_model}`;

        $scope.showPDFReport = function () {
          new PDFObject({
            url: report_url,
            id: "report-container",
            height: "600px",
          }).embed("report-container");
        };

        $scope.downloadArquivo = function () {
          report_url += "&filename=" + $scope.nome_arquivo_download;
          window.open(report_url, "_blank");
        };

        $scope.closeModal = function () {
          $uibModalInstance.close({});
        };
      }
    };

    vm.loadRecords = function (offset, limit) {
      vm.loading.records = true;
      vm.records = [];

      let req_url = `${Utils.getBaseUrlApi()}/order/${Utils.getUrlVars().id}/service/${vm.service_selected.service.id}`;

      if (!vm.service_selected.service.simplified) {
        if (!Utils.isEmpty(vm.company_selected)) {
          req_url = `${req_url}/company/${vm.company_selected.id}`;
        }
      }

      req_url = `${req_url}/records?offset=${offset}&limit=${limit}`;

      $http({
        method: "GET",
        url: req_url
      }).then(
        function successCallback(response) {
          if (!vm.service_selected.service.simplified) {
            angular.forEach(response.data.records, function (record) {
              if (!Utils.isEmpty(record.company)) {
                if (record.company.person_type == "PJ") {
                  if (!Utils.isEmpty(record.company.company_name)) record.company.label = record.company.company_name;
                  else record.company.label = record.company.fantasy_name;
                } else record.company.label = record.company.name;
              }
            });
          }

          angular.forEach(vm.service_selected.companies, function (company) {
            angular.forEach(response.data.records, function (record) {
              if (vm.service_selected.service.simplified) {
                angular.forEach(record.persons, function (person) {
                  if (person.person.id === company.id) {
                    if (!Utils.isEmpty(person.status)) {
                      company.status = person.status;
                      company.flg_done_atend = person.status == "done";
                    } else company.status = "pending";
                  }
                });
              } else {
                if (record.company.id === company.id) {
                  if (!Utils.isEmpty(record.status)) {
                    company.status = record.status;
                    company.flg_done_atend = record.status == "done";
                  } else company.status = "pending";
                }
              }
            });
          });

          vm.records = response.data;
          vm.loading.records = false;
        },
        function errorCallback(response) {
          vm.records = null;
          vm.loading.records = false;
          if (Utils.isEmpty(vm.currentUser.customer)) {
            toaster.pop({
              type: "error",
              timeout: 2000,
              bodyOutputType: "trustedHtml",
              body: "<strong>Desculpe!</strong><br/>" + response.data,
            });
          }
        }
      );
    };

    vm.getShortId = function () {
      if (!Utils.isEmpty(vm.objModel)) return vm.objModel.id.substr(vm.objModel.id.length - 12, 12);
    };

    vm.getServiceAttributeValue = (service, name) => {
      const attributes = service && service.attributes || [];
      
      for (const attribute of attributes) {
          if (attribute.name === name) {
              return attribute.value;
          }
      }
      
      return undefined;
    }

    vm.editRecord = function (record) {
      vm.record_edit = record;
      const reportModel = vm.service_selected.service.report_model;
      const researchType = vm.getServiceAttributeValue(vm.service_selected.service, "research-type");
      if (reportModel === "report-advanced")
        vm.openModal("newCompanyRecordModal");
      else if (vm.service_selected.service.simplified || researchType === 'vehicles')
        vm.openModal("newRecordSimpleModal");
      else
        vm.openModal("newRecordModal");
    };

    vm.openModal = function (modal_name) {
      var modal_instance = $uibModal.open({
        size: "lg",
        backdrop: false,
        templateUrl: "/" + modal_name + ".html",
        controller: ModalInstanceCtrl,
      });

      vm.modal_name = modal_name;

      ModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance", "WebcamService"];
      function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance, WebcamService) {
        $scope.show_webcam = false;
        $scope.webcam = WebcamService.webcam;
        $scope.loading = {
          address: false,
        };
        $scope.vehicle = null;

        $scope.getResearchType = () => {
          return vm.getServiceAttributeValue(vm.service_selected.service, "research-type");
        }
        $scope.getLayoutModel = () => {
          return vm.getServiceAttributeValue(vm.service_selected.service, "pdf-layout");
        }

        $scope.isTreatCriminal = () => {
          const value = vm.getServiceAttributeValue(vm.service_selected.service, "treat-criminal");
          return !Utils.isEmpty(value) ? (value === "true") : false;
        }

        $scope.isTreatFinance = () => {
          const value = vm.getServiceAttributeValue(vm.service_selected.service, "treat-finance");
          return !Utils.isEmpty(value) ? (value === "true") : false;
        }

        $scope.isTreatAccidentReport = () => {
          const value = vm.getServiceAttributeValue(vm.service_selected.service, "treat-accident-report");
          return !Utils.isEmpty(value) ? (value === "true") : false;
        }

        $scope.isTreatVehicles = () => {
          const value = vm.getServiceAttributeValue(vm.service_selected.service, "treat-vehicles");
          return !Utils.isEmpty(value) ? (value === "true") : false;
        }

        $scope.selectVehicle = () => {
          if (!Utils.isEmpty(vm.editRecord)) {
            if (Utils.isEmpty($scope.objModel.vehicle_reference.records_layouts) || $scope.objModel.vehicle_reference.records_layouts.length === 0) {
              $scope.objModel.vehicle_reference.records_layouts = [];
              if (Utils.isEmpty($scope.objModel.vehicle_reference.values_fields) || $scope.objModel.vehicle_reference.values_fields.length === 0) {
                if (Utils.isEmpty($scope.objModel.vehicle_reference.records_layouts) || $scope.objModel.vehicle_reference.records_layouts.length === 0) {
                  $scope.objModel.vehicle_reference.records_layouts = angular.copy($scope.objModel.service_item_reference.service.records_layouts);
                }
              }
              else {
                angular.forEach($scope.objModel.vehicle_reference.values_fields, function (value_field) {
                  angular.forEach(value_field.fields, function (layout_field) {
                    layout_field = _.extend(layout_field, _.findWhere(value_field.fields, { id: layout_field.oid["$oid"] }));
                  });
                  let layout = angular.copy(_.where($scope.objModel.service_item_reference.service.records_layouts, { id: value_field.layout["$oid"] }))[0];
                  layout.fields = value_field.fields;
                  $scope.objModel.vehicle_reference.records_layouts.push(layout);
                });
              }
            }
          }
          else if (Utils.isEmpty($scope.objModel.vehicle_reference.records_layouts) || $scope.objModel.vehicle_reference.records_layouts.length === 0) {
            $scope.objModel.vehicle_reference.records_layouts = angular.copy($scope.objModel.service_item_reference.service.records_layouts);
          }
        }

        $scope.objModel = {
          created_at: moment().format("DD/MM/YYYY HH:mm:ss"),
          user_input: $rootScope.globals.currentUser,
          service_item_reference: vm.service_selected,
          customer: vm.objModel.customer
        };

        $scope.loadTabelaReferencia = () => {
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + "/fipe/tabela-referencia",
          }).then(
            function successCallback(response) {
              vm.tabela = response.data[0];
            },
            function errorCallback(response) {}
          );
        };

        // ajustar para switch e colocar loading no vehicle
        $scope.loadVehicleBrands = function (vehicle) {
          // vehicle.type_fipe = ( vehicle.type == 'carros' ) ? 1 : ( vehicle.type == 'motos' ) ? 2 : 3
          switch (vehicle.type) {
            case "carros":
              vehicle.type_fipe = 1;
              break;
            case "motos":
              vehicle.type_fipe = 2;
              break;
            case "caminhoes":
              vehicle.type_fipe = 3;
              break;
            case "outros":
              return false;
          }
          $scope.loading.vehicle_brands = true;
          vehicle.brands = [];
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + `/fipe/tabela-referencia/${vm.tabela.id}/type-vehicle/${vehicle.type_fipe}/marcas`,
            data: JSON.stringify(vehicle),
          }).then(
            function successCallback(response) {
              vehicle.brands = response.data;
              $scope.loading.vehicle_brands = false;
              if (!Utils.isEmpty(vehicle.brand)) $scope.loadVehicleModels(vehicle);
            },
            function errorCallback(response) {
              $scope.loading.vehicle_brands = false;
            }
          );
        };

        $scope.loadVehicleModels = function (vehicle) {
          $scope.loading.vehicle_models = true;
          vehicle.models = [];
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + `/fipe/tabela-referencia/${vm.tabela.id}/type-vehicle/${vehicle.type_fipe}/marcas/${vehicle.brand.id}/modelos`,
            data: JSON.stringify(vehicle),
          }).then(
            function successCallback(response) {
              vehicle.models = response.data;
              $scope.loading.vehicle_models = false;
              if (!Utils.isEmpty(vehicle.model)) $scope.loadVehicleVersions(vehicle);
            },
            function errorCallback(response) {
              $scope.loading.vehicle_models = false;
            }
          );
        };

        $scope.loadVehicleVersions = function (vehicle) {
          $scope.loading.vehicle_versions = true;
          vehicle.versions = [];
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + `/fipe/tabela-referencia/${vm.tabela.id}/type-vehicle/${vehicle.type_fipe}/marcas/${vehicle.brand.id}/modelos/${vehicle.model.id}/ano-modelo`,
            data: JSON.stringify(vehicle),
          }).then(
            function successCallback(response) {
              vehicle.versions = response.data;
              $scope.loading.vehicle_versions = false;
            },
            function errorCallback(response) {
              $scope.loading.vehicle_versions = false;
            }
          );
        };

        $scope.loadVehicleInformation = function (vehicle) {
          $scope.loading.vehicle_information = true;
          vehicle.information = {};
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + `/fipe/tabela-referencia/${vm.tabela.id}/type-vehicle/${vehicle.type_fipe}/marcas/${vehicle.brand.id}/modelos/${vehicle.model.id}/ano-modelo/${vehicle.version.id}/valor-parametros`,
            data: JSON.stringify(vehicle),
          }).then(
            function successCallback(response) {
              vehicle.information = response.data;
              $scope.loading.vehicle_information = false;
            },
            function errorCallback(response) {
              $scope.loading.vehicle_information = false;
            }
          );
        };

        $scope.loadVehicle = function (vehicle) {
          if (!Utils.isEmpty(vm.tabela)) {
            $scope.loadVehicleBrands(vehicle);
            $scope.loadVehicleModels(vehicle);
            $scope.loadVehicleVersions(vehicle);
            $scope.loadVehicleInformation(vehicle);
          } else {
            setTimeout(() => {
              $scope.loadVehicleBrands(vehicle);
              $scope.loadVehicleModels(vehicle);
              $scope.loadVehicleVersions(vehicle);
              $scope.loadVehicleInformation(vehicle);
            }, 1000);
          }
        };

        $scope.getFullFileUrl = (file) => {
          if (!Utils.isEmpty(file.path)) return file.path;
          else return `${Utils.getBaseUrlApi()}/${file}`;
        };

        $scope.getExternalCompanyInfo = function (company, partners) {
          $scope.loading.company_info = true;
          $http({
            method: "GET",
            url: Utils.getBaseUrlApi() + "/external/find/company/" + company.cpf_cnpj,
          }).then(
            function successCallback(response) {
              company.company_name = response.data.nome;
              company.fantasy_name = response.data.fantasia;
              company.branch_activity = "(" + response.data.atividade_principal[0].code + ") " + response.data.atividade_principal[0].text;
              company.opening_date = response.data.abertura;
              company.status = response.data.situacao;

              if (Utils.isEmpty(company.adresses)) company.adresses = [{}];
              else if (company.adresses.length == 0) {
                company.adresses = [{}];
              }

              company.adresses[0].zip_code = response.data.cep.replaceAll(".", "").replaceAll("-", "");
              company.adresses[0].street = response.data.logradouro;
              company.adresses[0].number = response.data.numero;
              company.adresses[0].district = response.data.bairro;
              company.adresses[0].state = response.data.uf;
              company.adresses[0].city = response.data.municipio;

              if (Utils.isEmpty(partners)) {
                partners = [];
              }

              if (!Utils.isEmpty(response.data.qsa) && response.data.qsa.length > 0) {
                angular.forEach(response.data.qsa, function (socio, index) {
                  if (Utils.isEmpty(partners[index])) {
                    partners[index] = {
                      criminal_annotations: [{ deleted: false }],
                      police_report_bulletins: [{ deleted: false }],
                      companies: [{ deleted: false, vehicles: [{ deleted: false }] }],
                      vehicles: [{ deleted: false }],
                      phones: [{ deleted: false }],
                      deleted: false,
                    };
                  }

                  if (Utils.isEmpty(partners[index].person)) partners[index].person = {};

                  partners[index].person.name = socio.nome;
                  partners[index].person.company_name = socio.nome;
                });
              }

              $scope.loading.companies_info = false;
            },
            function errorCallback(response) {
              $scope.loading.company_info = false;

              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + response.data,
              });
              $scope.loading_save = false;
            }
          );
        };

        $scope.loadCriminalArticles = function () {
          $scope.criminal_articles = [];
          $http({
            method: "GET",
            url: `${Utils.getBaseUrlApi()}/criminal-articles?no-limit=1`,
          }).then(
            function successCallback(response) {
              $scope.criminal_articles = response.data;
              if (!Utils.isEmpty($scope.objModel.company_reference)) $scope.objModel.company_reference.criminal_articles = response.data;
            },
            function errorCallback(response) {
              $scope.criminal_articles = null;
            }
          );
        };

        $scope.consultAddressByCEP = function (address) {
          $scope.loading.address = true;

          Utils.getAddressByCEP(
            address.zip_code,
            function successCallback(response) {
              if (!response.data.erro) {
                $scope.address = _.extend(address, {
                  street: response.data.logradouro,
                  district: response.data.bairro,
                  city: response.data.localidade,
                  state: response.data.uf,
                });
                $scope.loading.address = false;
              } else {
                toaster.pop({
                  type: "error",
                  timeout: 2000,
                  bodyOutputType: "trustedHtml",
                  body: "<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!",
                });
                $scope.loading.address = false;
              }
            },
            function errorCallback(response) {
              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!",
              });
            }
          );
        };

        $scope.loadDataCnpjBySintegra = (company) => {
          $scope.loading.company_info = true;
          $scope.loading.address = true;

          let params = [];

          if (!Utils.isEmpty(company)) {
            if (!Utils.isEmpty(company.company_reference)) {
              params.push({
                key: "cpf_cnpj",
                value: company.company_reference.cpf_cnpj,
              });
            } else if (!Utils.isEmpty(company.company.cpf_cnpj)) {
              params.push({
                key: "cpf_cnpj",
                value: company.company.cpf_cnpj,
              });
            } else {
              params.push({
                key: "cpf_cnpj",
                value: company.person.cpf_cnpj,
              });
            }
          }

          SintegraService.getByCNPJSintegra(params)
            .then(({ data }) => {
              if (!Utils.isEmpty(company.company_reference)) {
                company.company_reference.company_name = Utils.getObjectValueIfNotValidate(data, "nome", "********");
                company.company_reference.fantasy_name = Utils.getObjectValueIfNotValidate(data, "fantasia", "********");
                company.company_reference.branch_activity = `${Utils.getObjectValueIfNotValidate(data.atividade_principal[0], "code", "*******")} - ${Utils.getObjectValueIfNotValidate(data.atividade_principal[0], "text", "*")}`;
                company.company_reference.opening_date = data.abertura;
                company.company_reference.billing_total = parseFloat(data.capital_social.replaceAll(".", ","));

                if (Utils.isEmpty(company.company_reference.adresses) || company.company_reference.adresses.length == 0) company.company_reference.adresses = [{}];

                company.company_reference.adresses[0].zip_code = data.cep.replaceAll(".", "").replaceAll("-", "");
                company.company_reference.adresses[0].street = Utils.getObjectValueIfNotValidate(data, "logradouro", "********");
                company.company_reference.adresses[0].number = Utils.getObjectValueIfNotValidate(data, "numero", "********");
                company.company_reference.adresses[0].district = Utils.getObjectValueIfNotValidate(data, "bairro", "********");
                company.company_reference.adresses[0].state = Utils.getObjectValueIfNotValidate(data, "uf", "********");
                company.company_reference.adresses[0].city = Utils.getObjectValueIfNotValidate(data, "municipio", "********");
                company.company_reference.adresses[0].complement = Utils.getObjectValueIfNotValidate(data, "complemento", "********");

                switch (data.situacao) {
                  case "ATIVA":
                    company.company_reference.situation = "active";
                    break;
                  case "SUSPENSA":
                    company.company_reference.situation = "suspended";
                    break;
                  case "NULA":
                    company.company_reference.situation = "nulled";
                    break;
                  case "INAPTA":
                    company.company_reference.situation = "inapt";
                    break;
                  case "BAIXADA":
                    company.company_reference.situation = "canceled";
                    break;
                }

                if (!Utils.isEmpty(company.persons)) {
                  company.persons = [];
                }

                if (!Utils.isEmpty(data.qsa) && data.qsa.length > 0) {
                  angular.forEach(data.qsa, (socio, index) => {
                    if (Utils.isEmpty(company.persons[index])) {
                      company.persons[index] = {
                        criminal_annotations: [{ deleted: false }],
                        police_report_bulletins: [{ deleted: false }],
                        companies: [{ deleted: false, vehicles: [{ deleted: false }] }],
                        vehicles: [{ deleted: false }],
                        phones: [{ deleted: false }],
                        deleted: false,
                      };
                    }
                    if (Utils.isEmpty(company.persons[index].person)) {
                      company.persons[index].person = {};
                      let arr = socio.qual.split("-");

                      switch (arr[0]) {
                        case "37":
                        case "48":
                        case "57":
                        case "78":
                        case "79":
                          company.persons[index].person = { company_name: socio.nome };
                          company.persons[index].person.person_type = "PJ";
                          break;
                        default:
                          company.persons[index].person = { name: socio.nome };
                          company.persons[index].person.person_type = "PF";
                          break;
                      }
                    }
                  });
                }
              } else {
                company.company.company_name = Utils.getObjectValueIfNotValidate(data, "nome", "********");
                company.company.fantasy_name = Utils.getObjectValueIfNotValidate(data, "fantasia", "********");
                // company.branch_activity = `${data.atividade_principal[0].code} - ${data.atividade_principal[0].text}`;
                company.branch_activity = `${Utils.getObjectValueIfNotValidate(data.atividade_principal[0], "code", "*******")} - ${Utils.getObjectValueIfNotValidate(data.atividade_principal[0], "text", "*")}`;
                company.company.opening_date = data.abertura;
                company.billing_total = parseFloat(data.capital_social.replaceAll(".", ""));

                if (Utils.isEmpty(company.address) || company.address.length == 0) company.address = {};

                company.address.zip_code = data.cep.replaceAll(".", "").replaceAll("-", "");
                company.address.street = Utils.getObjectValueIfNotValidate(data, "logradouro", "********");
                company.address.number = Utils.getObjectValueIfNotValidate(data, "numero", "********");
                company.address.district = Utils.getObjectValueIfNotValidate(data, "bairro", "********");
                company.address.state = Utils.getObjectValueIfNotValidate(data, "uf", "********");
                company.address.city = Utils.getObjectValueIfNotValidate(data, "municipio", "********");
                company.address.complement = Utils.getObjectValueIfNotValidate(data, "complemento", "********");

                switch (data.situacao) {
                  case "ATIVA":
                    company.company.situation = "active";
                    break;
                  case "SUSPENSA":
                    company.company.situation = "suspended";
                    break;
                  case "NULA":
                    company.company.situation = "nulled";
                    break;
                  case "INAPTA":
                    company.company.situation = "inapt";
                    break;
                  case "BAIXADA":
                    company.company.situation = "canceled";
                    break;
                }
              }

              $scope.loading.company_info = false;
              $scope.loading.address = false;
            })
            .catch(({ data }) => {
              $scope.loading.company_info = false;
              $scope.loading.address = false;

              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + data,
              });
              console.log(data);
            });
        };

        $scope.addItem = function (list, isCriminalAnnotation, haveVehicle) {
          if (!isCriminalAnnotation) {
            if (haveVehicle) list.push({ deleted: false, vehicles: [{ deleted: false }] });
            else list.push({ deleted: false });
          } else list.push(angular.copy(criminal_annotation_model));
        };

        $scope.addVehicles = (personObject) => {
          console.log(personObject);
          for (let i = 0; i < parseInt(personObject.qttToAddVehicles); i++) personObject.vehicles.push({ deleted: false });
          personObject.qttToAddVehicles = 1;
        };

        $scope.removeVehicles = (personObject, index) => {
          if (!Utils.isEmpty(index)) personObject.vehicles.splice(index, 1);
          else for (let i = 0; i < personObject.qttToAddVehicles; i++) personObject.vehicles.pop();
          personObject.qttToAddVehicles = 1;
        };

        $scope.addPerson = (item) => {
          if (Array.isArray(item)) item.push(getDeletedPersonRecord());
          else item = getDeletedPersonRecord();
        };

        $scope.canDeleteItem = function (list) {
          return true; // (_.where(list, {deleted: false}).length > 1);
        };

        $scope.canShowAddButton = function (list) {
          return _.where(list, { deleted: false }).length == 0;
        };

        $scope.selectPersonType = function (person, person_type) {
          person.cpf_cnpj = null;

          switch (person_type) {
            case "PF": // Pessoa Física
              person.rg = null;
              person.birth_date = null;
              break;
            case "PJ": // Pessoa Jurídica
              break;
          }
        };

        $scope.savePersonRecord = function () {
          if ($scope.objModel.company_reference) {
            angular.forEach($scope.objModel.service_item_reference.companies, function (cpm) {
              if (cpm.id == $scope.objModel.company_reference.id) {
                cpm = _.extend(cpm, $scope.objModel.company_reference);
              }
            });
            $scope.objModel.company_reference = null;
          }

          if ($scope.objModel.vehicle_reference) {
            angular.forEach($scope.objModel.service_item_reference.vehicles, function (vehicle) {
              if (vehicle.plate_number == $scope.objModel.vehicle_reference.plate_number) {
                vehicle = _.extend(vehicle, $scope.objModel.vehicle_reference);
              }
            });
            $scope.objModel.vehicle_reference = null;
          }
        };

        $scope.saveNewRecord = function () {
          $scope.loading_save = true;

          var post_data = angular.copy($scope.objModel);
          
          switch(post_data.service_item_reference.service.report_model) {
            case 'report-advanced':
            case 'report-check-list':
              $(".layout-fields .form-group").removeClass("has-error");

              angular.forEach(post_data.service_item_reference.service.records_layouts, function (layout) {
                angular.forEach(layout.fields, function (field) {
                  if (field.required && !field.hide && Utils.isEmpty(field.value)) {
                    if (!Utils.isEmpty(field.id)) $(".form-group#" + field.id).addClass("has-error");
                    else $(".form-group#" + field.oid.$oid).addClass("has-error");
                  }
    
                  if (field.type == "proceedings-photos") {
                    field.images = [];
                    angular.forEach($scope.proceedings, function (proceeding) {
                      angular.forEach(proceeding.attachments, function (attachment) {
                        if (attachment.selected) {
                          var att = angular.copy(attachment);
                          att.path = att.path.replace(Utils.getBaseUrlApi() + "/", "");
    
                          field.images.push(att);
                        }
                      });
                    });
                  }
                });
              });
    
              if ($(".layout-fields .form-group.has-error").length > 0) {
                toaster.pop({
                  toasterId: 2,
                  type: "warning",
                  timeout: 2000,
                  bodyOutputType: "trustedHtml",
                  body: "<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório!",
                });

                $scope.loading_save = false;

                return false;
              }

              break;
          }

          let post_url = `${Utils.getBaseUrlApi()}/order/${vm.objModel.id}/service/${post_data.service_item_reference.service.id}`;

          if (
            (!$scope.objModel.service_item_reference.service.simplified)
            && 
            (vm.service_selected.service.report_model !== "report-check-list")
            &&
            ($scope.getResearchType() !== 'vehicles')
          ) {
            post_url = `${post_url}/company/${post_data.company_reference.id}`;
          }

          post_url = `${post_url}/record`;

          if (post_data.service_item_reference.service.report_model === "report-advanced") 
            post_url = `${post_url}/advanced`;

          if (!Utils.isEmpty($scope.objModel.id))
            post_url = `${post_url}/${$scope.objModel.id}`;

          if (!Utils.isEmpty(post_data.service_item_reference.companies) && post_data.service_item_reference.companies.length > 0) {
            angular.forEach(post_data.service_item_reference.companies, (cpm) => {
              if (!Utils.isEmpty($scope.objModel.flg_done_all) && $scope.objModel.flg_done_all) {
                cpm.flg_done_atend = true;
              }

              if (!Utils.isEmpty(cpm.criminal_annotations) && cpm.criminal_annotations.length > 0) {
                angular.forEach(cpm.criminal_annotations, (ca) => {
                  ca.has_police_report_bulletin = ca.has_police_report_bulletin === "true";
                  ca.has_inquiry = ca.has_inquiry === "true";
                  ca.has_circumstantial_term = ca.has_circumstantial_term === "true";

                  if (!Utils.isEmpty(ca.police_report_date)) ca.police_report_date = moment(ca.police_report_date, "DD/MM/YYYY").format("YYYY-MM-DD");
                });
              }
            });
          }

          if (!Utils.isEmpty(post_data.service_item_reference.vehicles) && post_data.service_item_reference.vehicles.length > 0) {
            angular.forEach(post_data.service_item_reference.vehicles, (vehicle) => {
              if (!Utils.isEmpty($scope.objModel.flg_done_all) && $scope.objModel.flg_done_all) {
                vehicle.flg_done_atend = true;
              }
            });
          }

          if (!Utils.isEmpty(post_data.values_fields) && post_data.values_fields.length > 0) {
            angular.forEach(post_data.values_fields, (vf) => {
              angular.forEach(vf.fields, (field) => {
                if (!Utils.isEmpty(field.criminal_annotations) && field.criminal_annotations.length > 0) {
                  angular.forEach(field.criminal_annotations, (ca) => {
                    ca.has_police_report_bulletin = ca.has_police_report_bulletin === "true";
                    ca.has_inquiry = ca.has_inquiry === "true";
                    ca.has_circumstantial_term = ca.has_circumstantial_term === "true";
                  });
                }
              });
            });
          }

          $http({
            method: Utils.isEmpty($scope.objModel.id) ? "POST" : "PUT",
            url: post_url,
            data: JSON.stringify(post_data),
          }).then(
            function successCallback(response) {
              $scope.objModel = null;
              vm.record_edit = null;
              $uibModalInstance.close("closed");
              toaster.pop({
                type: "success",
                timeout: 2000,
                body: "Registro incluído com sucesso!",
              });
              getDataById();
              vm.loadRecords(1, 10);
              $scope.loading_save = false;
            },
            function errorCallback(response) {
              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + response.data,
              });
              $scope.loading_save = false;
            }
          );
        };

        $scope.webcam.success = function (image, type) {
          $scope.objModel.attachment = {};
          $scope.objModel.attachment.type = type.substring(type.indexOf("/") + 1, type.length);
          $scope.objModel.attachment.name = "Captura_de_Camera_" + Utils.generateRandomHash(10) + "." + $scope.objModel.attachment.type;
          $scope.objModel.attachment.path = "data:" + type + ";base64," + image;
          $scope.objModel.attachment.size = Utils.calcBase64SizeInKBytes($scope.objModel.attachment.path);
          $scope.objModel.attachment.deleted = false;

          if ($scope.objModel.attachment.size < 1024) $scope.objModel.attachment.size = Utils.numberFormat($scope.objModel.attachment.size, 2, ",", ".") + " KB";
          else if ($scope.objModel.attachment.size > 1024) $scope.objModel.attachment.size = Utils.numberFormat($scope.objModel.attachment.size, 2, ",", ".") + " MB";

          $scope.show_webcam = false;
        };

        $scope.makeSnapshot = function () {
          $scope.webcam.makeSnapshot();
        };

        $scope.turnOnWebCam = function () {
          $scope.show_webcam = true;
        };

        $scope.turnOffWebCam = function () {
          if ($scope.webcam && $scope.webcam.isTurnOn === true) $scope.webcam.turnOff();
          $scope.show_webcam = false;
        };

        $scope.cancelNewRecord = function () {
          $scope.objModel = null;
          vm.record_edit = null;
          getDataById();
          $uibModalInstance.close({});
        };

        $scope.closeModal = function () {
          $uibModalInstance.close({});
        };

        $scope.openSubModal = function (modal_name, size) {
          $scope.closeModal();

          if (Utils.isEmpty(size)) size = "lg";

          var modal_instance = $uibModal.open({
            size: size,
            backdrop: false,
            templateUrl: "/" + modal_name + ".html",
            controller: SubModalInstanceCtrl,
          });

          SubModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
          function SubModalInstanceCtrl($subScope, $rootScope, $uibModalInstance) {
            $subScope.notification_data = {
              user_generator: vm.currentUser,
              customer_related: vm.objModel.customer,
              order_related: vm.objModel,
              person_related: Utils.isEmpty(objModel.company_reference.person) ? objModel.company_reference : objModel.company_reference.person,
              profile_can_view: "customer",
              notification_type: "inconsistent_data",
            };

            $subScope.closeSubModal = function () {
              $uibModalInstance.close({});
            };

            $subScope.save = function () {
              $subScope.loading_save = true;

              $http({
                method: "POST",
                url: Utils.getBaseUrlApi() + "/notification",
                data: JSON.stringify($subScope.notification_data),
              }).then(
                function successCallback(response) {
                  $subScope.notification_data = null;
                  $uibModalInstance.close("closed");
                  toaster.pop({
                    type: "success",
                    timeout: 2000,
                    body: "Notificação enviada para o cliente com sucesso!",
                  });
                  vm.loadRecords(1, 10);
                  $subScope.loading_save = false;
                },
                function errorCallback(response) {
                  toaster.pop({
                    type: "error",
                    timeout: 2000,
                    bodyOutputType: "trustedHtml",
                    body: "<strong>Desculpe!</strong><br/>" + response.data,
                  });
                  $subScope.loading_save = false;
                }
              );
            };
          }
        };

        $scope.toggleSelectImage = function (image) {
          image.selected = !image.selected;
        };

        $scope.onCriminalArticleChanged = function (ca) {
          ca.criticality_level = ca.criminal_article.criticality_level;
        };

        //Anexos
        $scope.removeAttachment = function (index, attachments) {
          for (let i = 0; i < attachments.length; i++) {
            if (i == index) attachments.splice(index, 1);
          }
        };

        $scope.addAttachment = function () {
          if (!Utils.isEmpty($scope.objModel.attachment.name) && !Utils.isEmpty($scope.objModel.attachment.description)) {
            if (Utils.isEmpty($scope.objModel.attachments)) $scope.objModel.attachments = [];
            $("#subtitle").removeClass("has-error");
            $scope.objModel.attachments.push(angular.copy($scope.objModel.attachment));
            $scope.objModel.attachment = null;
          } else {
            $("#subtitle").addClass("has-error");
            toaster.pop({
              type: "error",
              timeout: 2000,
              bodyOutputType: "trustedHtml",
              body: "Coloque uma foto e a legenda para poder incluir um anexo.",
            });
          }
        };

        //Certidões by InfoSimples
        $scope.getFileByInfoSimples = function (record, destination_model, type_request) {
          $scope.loading[type_request] = true;

          let params = [];

          let service = null;
          switch (type_request) {
            case "receita_federal":
              if (!Utils.isEmpty(record.company_reference) && record.company_reference.person_type == "PJ") {
                params.push({
                  key: "cnpj",
                  value: record.company_reference.cpf_cnpj,
                });
              } 
              else {
                params.push({
                  key: "cpf",
                  value: record.company_reference.cpf_cnpj,
                });
              }
              service = InfoSimplesService.getByReceitaFederal(params);
              break;
            case "caixa_economica":
              if (!Utils.isEmpty(record.company_reference) && record.company_reference.person_type == "PJ") {
                params.push({
                  key: "cnpj",
                  value: record.company_reference.cpf_cnpj,
                });
              } 
              else {
                params.push({
                  key: "cpf",
                  value: record.company_reference.cpf_cnpj,
                });
              }
              service = InfoSimplesService.getByCaixaEconomicaFederal(params);
              break;
            case "tribunal_superior_trabalho":
              service = InfoSimplesService.getByTribunalSuperiorTrabalho(params);
              break;
            case "cadin_estadual":
              if (!Utils.isEmpty(record.company_reference) && record.company_reference.person_type == "PJ") {
                params.push({
                  key: "cnpj",
                  value: record.company_reference.cpf_cnpj,
                });
              } 
              else {
                params.push({
                  key: "cpf",
                  value: record.company_reference.cpf_cnpj,
                });
              }
              service = InfoSimplesService.getByCadinEstadual(params);
              break;
            case "cadin_municipal":
              if (!Utils.isEmpty(record.company_reference) && record.company_reference.person_type == "PJ") {
                params.push({
                  key: "cnpj",
                  value: record.company_reference.cpf_cnpj,
                });
              } 
              else {
                params.push({
                  key: "cpf",
                  value: record.company_reference.cpf_cnpj,
                });
              }
              service = InfoSimplesService.getByCadinMunicipal(params);
              break;
          }

          service
            .then(({ data }) => {
              let name = data.file_path.split("/");

              $scope.objModel[destination_model] = {
                path: data.file_path,
                changed: true,
                deleted: false,
                format: "real_path",
                name: name[1],
                type: data.file_path.slice(-3),
                size: "0",
              };
              $scope.loading[type_request] = false;
              toaster.pop({
                type: "success",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "Arquivo Baixado com sucesso!!",
              });
            })
            .catch(({ data }) => {
              $scope.loading[type_request] = false;
              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + data,
              });
              console.log(data);
            });
        };

        $scope.downloadReceipts = function (file_path) {
          let receipts_url = Utils.getBaseUrlApi() + "/" + file_path;
          window.open(receipts_url, "_blank");
        };

        //Diligencias
        $scope.addImages = (attachment, proceeding, escopo) => {
          // Verificar qual imagem foi selecionada
          // Retornar o botão para primary caso o botão esteja em secondary
          // Retornar o botão para secondary caso o botão esteja em primary
          // Adicionas os dados da imagem selecionada para o ng-Model/Array
          // Remover os dados da imagem selecionada.

          if (Utils.isEmpty(attachment.selected) || attachment.selected == false) {
            attachment.selected = true;
            if (Utils.isEmpty(escopo.proceedings)) {
              escopo.proceedings = [];
            }
            escopo.proceedings.push({
              attachment: attachment,
              proceeding: proceeding,
            });
          }
        };

        $scope.removeImage = (proceeding, escopo) => {
          angular.forEach(escopo.proceedings, (scopeProceeding, indexProceeding) => {
            if (proceeding.attachment.path == scopeProceeding.attachment.path) {
              escopo.proceedings.splice(indexProceeding, 1);
            }
          });

          angular.forEach($scope.proceedings, (scopeProceeding) => {
            angular.forEach(scopeProceeding.attachments, (attProceeding) => {
              if (proceeding.attachment.path == attProceeding.path) {
                attProceeding.selected = false;
              }
            });
          });
        };

        $scope.openImageModal = (modal_name, size, itemImages) => {
          if (Utils.isEmpty(size)) size = "lg";

          var modal_instance = $uibModal.open({
            size: size,
            backdrop: false,
            templateUrl: "/" + modal_name + ".html",
            controller: openImageModalCtrl,
          });

          openImageModalCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
          function openImageModalCtrl($subScope, $rootScope, $uibModalInstance) {
            $subScope.closeImageModalCtrl = function () {
              $uibModalInstance.close({});
            };

            $subScope.itemImages = itemImages;
          }
        };

        $scope.whichSelected = (proceeding, escopo) => {
          if (!Utils.isEmpty(proceeding.attachments)) {
            angular.forEach(proceeding.attachments, (valueProceeding) => {
              if (!Utils.isEmpty(escopo.proceedings)) {
                angular.forEach(escopo.proceedings, (valueProceedings) => {
                  if (valueProceeding.path == valueProceedings.attachment.path) {
                    valueProceeding.selected = true;
                  }
                });
              }
            });
          }
        };

        $scope.loadProceedings = () => {
          try {
            var req_url = Utils.getBaseUrlApi();
            req_url += "/order/" + vm.objModel.id;
            req_url += "/service/" + $scope.objModel.service_item_reference.service.id;
            req_url += "/company/" + (!Utils.isEmpty($scope.objModel.company_reference) ? $scope.objModel.company_reference.id : objModel.company_reference.id);
            req_url += "/proceedings";
            $http({
              method: "GET",
              url: req_url,
            }).then(
              function successCallback(response) {
                angular.forEach(response.data, function (proceeding) {
                  angular.forEach(proceeding.attachments, function (image) {
                    image.path = Utils.getBaseUrlApi() + "/" + image.path;

                    if (!Utils.isEmpty($scope.objModel.id)) {
                      angular.forEach($scope.objModel.service_item_reference.service.records_layouts, function (layout) {
                        angular.forEach(layout.fields, function (field) {
                          if (field.type == "proceedings-photos") {
                            image.selected = !Utils.isEmpty(_.findWhere(field.images, { id: image.id }));
                          }
                        });
                      });
                    } else {
                      image.selected = false;
                    }
                  });
                });
                $scope.proceedings = response.data;
              },
              function errorCallback(response) {
                console.log(response);
              }
            );
          } catch (e) {}
        };

        $scope.handleExpandAllVehicles = (person) => {
          if (!Utils.isEmpty(person.vehicles) && person.vehicles.length > 0) {
            person.vehicles = person.vehicles.map((vehicle) => {
              vehicle.show = !vehicle.show;
              return vehicle;
            });
          }
          person.expandAllVehicles = !person.expandAllVehicles;
        };

        const getDeletedPersonRecord = () => {
          return { deleted: false, expandAllVehicles: false, qttToAddVehicles: 1, vehicles: [{ deleted: false }], certificates: [{ deleted: false }], properties: [{ deleted: false }], companies: [{ deleted: false, vehicles: [{ deleted: false }] }] };
        };

        const putDeletedWithMapArray = (array) => {
          return array.map((item) => {
            item.show = false;
            item.deleted = false;
            if (!Utils.isEmpty(item.type) && item.type != "outros") $scope.loadVehicle(item);
            if (!Utils.isEmpty(item.extension)) item.type = item.extension;

            return modifyOrderRecord(item);
          });
        };

        const modifyOrderRecord = (OrderRecord) => {
          OrderRecord.expandAllVehicles = false;
          OrderRecord.qttToAddVehicles = 1;
          Object.keys(OrderRecord).forEach((key) => {
            try {
              if (Array.isArray(OrderRecord[key]) && OrderRecord[key].length > 0) {
                OrderRecord[key] = putDeletedWithMapArray(OrderRecord[key]);
              } else if (typeof OrderRecord[key] == "object" && (key === "wife" || key === "ex_wife")) {
                // Objeto de pessoa (wife - ex_wife)
                if (!Utils.isEmpty(OrderRecord[key]) && !Utils.isEmpty(OrderRecord[key].person)) OrderRecord[key] = modifyOrderRecord(OrderRecord[key]);
              } else if (key.includes("path") && !Utils.isEmpty(OrderRecord[key])) {
                // Arquivos com path alterando o type
                OrderRecord[key].type = OrderRecord[key].extension;
              } else if (key == "proceedings") {
                OrderRecord.proceedings = OrderRecord.proceedings.map((item) => {
                  item.attachment.selected = true;
                  return item;
                });
              }
            } catch (e) {
              console.log("ERRO");
              console.log(OrderRecord[key]);
              throw e;
            }
          });
          return OrderRecord;
        };

        $scope.loadTabelaReferencia();

        $scope.loadPersonData = (person) => {
          if (!Utils.isEmpty($scope.objModel.company_reference.vehicles) && $scope.objModel.company_reference.vehicles.length > 0) {
            angular.forEach($scope.objModel.company_reference.vehicles, (vehicle) => {
              if (!Utils.isEmpty(vehicle.type)) $scope.loadVehicleBrands(vehicle);
            })
          }
        }

        switch (vm.modal_name) {
          case "newCompanyRecordModal":
            $scope.objModel.persons = [
              {
                deleted: false,
              },
            ];
            break;
          case "newRecordSimpleModal":
          case "newRecordModal":
          case "reportModal":
            break;
        }

        if (!Utils.isEmpty(vm.company_selected)) {
          $scope.objModel.company_reference = angular.copy(vm.company_selected);

          switch ($scope.objModel.company_reference.person_type) {
            case "PF":
              $scope.objModel.company_reference.label = $scope.objModel.company_reference.name;
              break;
            case "PJ":
              if (!Utils.isEmpty($scope.objModel.company_reference.company_name)) $scope.objModel.company_reference.label = $scope.objModel.company_reference.company_name;
              else $scope.objModel.company_reference.label = $scope.objModel.company_reference.fantasy_name;
              break;
          }
          $scope.loadProceedings();
        }

        let criminal_annotation_model = {
          has_police_report_bulletin: "false",
          has_circumstantial_term: "false",
          has_inquiry: "false",
          deleted: false,
        };

        if ($scope.objModel.service_item_reference.service.simplified) {
          angular.forEach($scope.objModel.service_item_reference.companies, function (company) {
            company.label = company.person_type == "PJ" ? (!Utils.isEmpty(company.company_name) ? company.company_name : company.fantasy_name) : company.name;

            if (Utils.isEmpty(vm.record_edit)) {
              company.accident_report_able = true;
              company.criminal_able = true;
              company.finance_able = true;
              company.vehicle_able = false;
              company.criminal_annotations = [angular.copy(criminal_annotation_model)];
              company.vehicles = [{deleted: false}];
            } 
            else {
              var prv = _.filter(vm.record_edit.persons, (el) => (el.person.id == company.id ? el : null));
              if (prv != null && prv.length > 0) {
                let _id = angular.copy(company.id);
                company = _.extend(company, prv[0]);
                company.id = angular.copy(_id);

                if (company.criminal_annotations.length === 0) company.criminal_annotations = [angular.copy(criminal_annotation_model)];
                else {
                  angular.forEach(company.criminal_annotations, (ca) => {
                    ca.has_police_report_bulletin = ca.has_police_report_bulletin.toString();
                    ca.has_circumstantial_term = ca.has_circumstantial_term.toString();
                    ca.has_inquiry = ca.has_inquiry.toString();
                    ca.deleted = false;
                  });
                }

                if (company.vehicles.length === 0) company.vehicles = [{deleted: false}];
                else angular.forEach(company.vehicles, (ca) => { ca.deleted = false; });
              }
            }
          });
        } 
        else if (Utils.isEmpty(vm.record_edit)) {
          angular.forEach($scope.objModel.service_item_reference.service.records_layouts, function (layout) {
            angular.forEach(layout.fields, function (field) {
              if (field.search_type && field.search_type === 'criminal')
                field.criminal_annotations = [angular.copy(criminal_annotation_model)];
              if (!Utils.isEmpty(field.default_value)) {
                var reference_field = field.default_value.replace("|--person.", "").replace("--|", "");
                field.value = $scope.objModel.company_reference[reference_field];
              }
            });
          });
        }

        if (!Utils.isEmpty(vm.record_edit)) {
          $scope.objModel.id = vm.record_edit.id;
          $scope.objModel = _.extend($scope.objModel, vm.record_edit);

          if ($scope.objModel.service_item_reference.service.report_model === "report-advanced") {
            $scope.objModel = modifyOrderRecord($scope.objModel);
            if (Utils.isEmpty($scope.objModel.wife)) {
              $scope.objModel.wife = getDeletedPersonRecord();
            }
            if (Utils.isEmpty($scope.objModel.ex_wife)) {
              $scope.objModel.ex_wife = getDeletedPersonRecord();
            }
            console.log($scope.objModel);
          } else if ($scope.objModel.service_item_reference.service.report_model === "report-check-list") {
            if (!Utils.isEmpty($scope.objModel.attachments)) {
              $scope.objModel.attachments = putDeletedWithMapArray($scope.objModel.attachments);
            }
          }
        } 
        else if ($scope.objModel.service_item_reference.service.report_model === "report-advanced") {
          $scope.objModel.wife = getDeletedPersonRecord();
          $scope.objModel.ex_wife = getDeletedPersonRecord();
          $scope.objModel.childrens = [getDeletedPersonRecord()];
          $scope.objModel.brothers = [getDeletedPersonRecord()];
          $scope.objModel.phones = [{ deleted: false }];
          $scope.objModel.vehicles = [{ deleted: false }];
          $scope.objModel.companies = [{ deleted: false, vehicles: [{ deleted: false }] }];
          $scope.objModel.certificates = [{ deleted: false }];
          $scope.objModel.properties = [{ deleted: false }];
          $scope.objModel.criminal_annotations = [{ deleted: false }];
        } 
        else if ($scope.objModel.service_item_reference.service.report_model === "report-check-list") {
          $scope.objModel.service_item_reference.service.records_layouts = $scope.objModel.service_item_reference.service.records_layouts.map((item) => {
            item.fields = item.fields.map((itemFields) => {
              itemFields.value = null;
              return itemFields;
            });
            return item;
          });
        }

        if (!$scope.objModel.service_item_reference.service.simplified && !Utils.isEmpty(vm.record_edit)) {
          if ($scope.getResearchType() === 'vehicles') {
            $scope.objModel.service_item_reference.vehicles = angular.copy(vm.record_edit.vehicles);;
          }
          
          $scope.objModel.service_item_reference.service.records_layouts = [];
          angular.forEach(vm.record_edit.values_fields, function (value_field) {
            angular.forEach(value_field.layout.fields, function (layout_field) {
              layout_field = _.extend(layout_field, _.findWhere(value_field.fields, { id: layout_field.oid["$oid"] }));
              if (layout_field.search_type && layout_field.search_type === 'criminal') {
                angular.forEach(layout_field.criminal_annotations, (ca) => { 
                  ca.has_police_report_bulletin = ca.has_police_report_bulletin.toString();
                  ca.has_circumstantial_term = ca.has_circumstantial_term.toString();
                  ca.has_inquiry = ca.has_inquiry.toString();
                  ca.deleted = false; 
                });
              }
            });
            $scope.objModel.service_item_reference.service.records_layouts.push(value_field.layout);
          });
        }

        if ($scope.objModel.service_item_reference.service.report_model === "report-check-list") {
          $scope.objModel.customer = angular.copy(vm.objModel.customer);
        }

        setTimeout(function () {
          $(".btn-upload").change(function () {
            var file = this.files[0];
            var reader = new FileReader();

            if (Utils.isEmpty($scope.objModel.attachment)) $scope.objModel.attachment = {};

            var type = file.type.substring(file.type.indexOf("/") + 1, file.type.length);
            if (Utils.isEmpty(type)) {
              type = file.name.substring(file.name.lastIndexOf(".") + 1, file.name.length);
            }

            $scope.objModel.attachment.name = file.name;
            $scope.objModel.attachment.type = type;
            $scope.objModel.attachment.size = file.size / 1024;

            if ($scope.objModel.attachment.size < 1024) $scope.objModel.attachment.size = Utils.numberFormat($scope.objModel.attachment.size, 2, ",", ".") + " KB";
            else if ($scope.objModel.attachment.size > 1024) $scope.objModel.attachment.size = Utils.numberFormat($scope.objModel.attachment.size, 2, ",", ".") + " MB";

            reader.onload = function (e) {
              var path = e.target.result;

              $scope.objModel.attachment.path = path;
              $scope.objModel.attachment.deleted = false;

              setTimeout(function () {
                $scope.$apply();
              }, 1);
            };

            if (!Utils.isEmpty(file)) reader.readAsDataURL(file);
          });

          // tratar upload de arquivo aqui...
          $(".btn-upload-company").change(function () {
            // defining object data...
            var model = $(this).data().model;
            var attachment_field = $(this).data().fileField;

            $scope.active_item_upload = null;
            if (model.split(".").length > 1) {
              model = model.split(".");
              var obj_model_name = model[0];
              var sub_field = model[1];

              if (model[1].indexOf("[") !== -1) {
                var list_name = model[1].substring(0, model[1].indexOf("["));
                var list_index = /[0-9]/.exec(model[1])[0];

                if (Utils.isEmpty($scope[obj_model_name][list_name][list_index][attachment_field])) $scope[obj_model_name][list_name][list_index][attachment_field] = {};

                $scope.active_item_upload = $scope[obj_model_name][list_name][list_index][attachment_field];
              } else {
                if (Utils.isEmpty($scope[obj_model_name][sub_field][attachment_field])) $scope[obj_model_name][sub_field][attachment_field] = {};

                $scope.active_item_upload = $scope[obj_model_name][sub_field][attachment_field];
              }
            } else {
              if (Utils.isEmpty($scope[model][attachment_field])) $scope[model][attachment_field] = {};

              $scope.active_item_upload = $scope[model][attachment_field];
            }

            if (Utils.isEmpty($scope.active_item_upload)) $scope.active_item_upload = {};

            // reading file...
            var file = this.files[0];

            // getting file type...
            var type = file.type.substring(file.type.indexOf("/") + 1, file.type.length);
            if (Utils.isEmpty(type)) {
              type = file.name.substring(file.name.lastIndexOf(".") + 1, file.name.length);
            }
            $scope.active_item_upload.type = type;

            // getting file name...
            $scope.active_item_upload.name = file.name;

            // defining file size...
            $scope.active_item_upload.size = file.size / 1024;
            if ($scope.active_item_upload.size < 1024) $scope.active_item_upload.size = Utils.numberFormat($scope.active_item_upload.size, 2, ",", ".") + " KB";
            else if ($scope.active_item_upload.size > 1024) $scope.active_item_upload.size = Utils.numberFormat($scope.active_item_upload.size, 2, ",", ".") + " MB";

            // reading file binary data...
            var reader = new FileReader();
            reader.onload = (e) => {
              $scope.active_item_upload.path = e.target.result;
              $scope.active_item_upload.changed = true;
              $scope.active_item_upload.deleted = false;
              $scope.active_item_upload.format = "base64";
              setTimeout(() => {
                $scope.$apply();
              }, 1);
            };

            if (!Utils.isEmpty(file)) reader.readAsDataURL(file);
          });
        }, 10);
      }
    };

    vm.confirmDelete = function (record) {
      vm.loading.delete = true;

      var req_url = Utils.getBaseUrlApi() + "/record/" + record.id;

      $http({
        method: "DELETE",
        url: req_url,
      }).then(
        function successCallback(response) {
          toaster.pop({
            type: "success",
            timeout: 1000,
            bodyOutputType: "trustedHtml",
            body: "<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...",
            onHideCallback: function () {
              vm.loading.delete = false;
              vm.loadRecords(1, 10);
            },
          });
        },
        function errorCallback(response) {
          vm.loading.delete = false;
          toaster.pop({
            type: "error",
            timeout: 2000,
            bodyOutputType: "trustedHtml",
            body: "<strong>Desculpe!</strong><br/>" + response.data,
          });
        }
      );
    };

    vm.updateOrderStatus = function (new_status) {
      vm.loading.startStop = true;

      $http({
        method: "PUT",
        url: Utils.getBaseUrlApi() + "/order/" + vm.objModel.id + "/" + new_status,
        data: JSON.stringify({ user_finished: vm.currentUser }),
      }).then(
        function successCallback(response) {
          if (new_status == "start") vm.objModel.status = "in_progress";
          else if (new_status == "stop") vm.objModel.status = "done";

          toaster.pop({
            type: "success",
            timeout: 1000,
            bodyOutputType: "trustedHtml",
            body: "<strong>Operação realizada</strong><br/>Status alterado com sucesso!",
          });
        },
        function errorCallback(response) {
          vm.loading.startStop = false;
          toaster.pop({
            type: "error",
            timeout: 2000,
            bodyOutputType: "trustedHtml",
            body: "<strong>Desculpe!</strong><br/>" + response.data,
          });
        }
      );
    };

    vm.getStatusLabel = function () {
      var status_label = "";
      if (!Utils.isEmpty(vm.objModel)) {
        switch (vm.objModel.status) {
          case "pending":
            status_label = "Pendente";
            break;
          case "waiting":
            status_label = "Aguardando Atendimento";
            break;
          case "in_progress":
            status_label = "Em Atendimento";
            break;
          case "done":
            status_label = "Concluído";
            break;
        }
      }
      return status_label;
    };

    vm.openChangeServiceModal = function () {
      var modal_instance = $uibModal.open({
        backdrop: false,
        size: "lg",
        templateUrl: "/changeServiceModal.html",
        controller: ModalInstanceCtrl,
      });

      ModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
      function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
        $scope.objModel = {};
        $scope.objModel.order = vm.objModel;
        $scope.objModel.new_order = angular.copy($scope.objModel.order);

        $scope.orderImport = () => {
          $http({
            method: "POST",
            url: Utils.getBaseUrlApi() + "/order/import",
            data: JSON.stringify($scope.objModel),
          }).then(
            function successCallback(response) {
              toaster.pop({
                type: "success",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "Dados importados com sucesso",
              });
            },
            function errorCallback(response) {
              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + response.data,
              });
            }
          );
        };

        $scope.openSecondModal = function (modal_name, item, new_order) {
          var modal_instance = $uibModal.open({
            backdrop: false,
            size: "lg",
            templateUrl: "/" + modal_name + ".html",
            controller: ModalInstanceCtrl,
          });

          ModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
          function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
            $scope.filter.limit = 5;
            $scope.service = item;
            $scope.order_id = vm.objModel.id;

            $scope.getServices = function (offset) {
              var req_url = Utils.getBaseUrlApi() + "/services";
              req_url += "?offset=" + offset + "&limit=" + parseInt($scope.filter.limit);

              if (!Utils.isEmpty($scope.filter.value)) req_url += "&filter=" + $scope.filter.value;

              if (!Utils.isEmpty(vm.currentUser.customer)) req_url += "&customer_related_id=" + vm.currentUser.customer.id;
              else if (!Utils.isEmpty(vm.objModel.customer)) req_url += "&customer_related_id=" + vm.objModel.customer.id;

              $scope.services = {};

              $http({
                method: "GET",
                url: req_url,
              }).then(
                function successCallback(response) {
                  $scope.services = response.data;
                },
                function errorCallback(response) {
                  $scope.services = null;
                  toaster.pop({
                    type: "error",
                    timeout: 2000,
                    bodyOutputType: "trustedHtml",
                    body: "<strong>Desculpe!</strong><br/>" + response.data,
                  });
                }
              );
            };

            $scope.closeModal = function () {
              $uibModalInstance.close({});
            };

            $scope.selectService = function (items, item_selected) {
              angular.forEach(items, function (item) {
                item.selected = false;
              });
              item_selected.selected = true;
              $scope.selected_item = angular.copy(item_selected);
            };

            $scope.confirmSelectService = (selected_item) => {
              $scope.service.new_service = {
                delivery_time: selected_item.delivery_time,
                price: selected_item.default_price,
                service: angular.copy(selected_item),
                quantity: $scope.service.quantity,
                companies: angular.copy($scope.service.companies),
                status: $scope.service.status,
                delete: false,
              };
              angular.forEach(new_order.services, (service, idx_service) => {
                if ($scope.service.id === service.id) new_order.services[idx_service] = $scope.service.new_service;
              });
              $scope.closeModal();
            };
          }
        };

        $scope.closeModal = function () {
          $uibModalInstance.close({});
        };
      }
    };

    vm.openConfigurationsModal = function () {
      var modal_instance = $uibModal.open({
        backdrop: false,
        size: "lg",
        templateUrl: "/configurationsAPP.html",
        controller: ModalInstanceCtrl,
      });

      ModalInstanceCtrl.$inject = ["$scope", "$rootScope", "$uibModalInstance"];
      function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
        $scope.objModel = {
          service_item_reference: vm.service_selected,
        };

        $scope.order = vm.objModel;
        $scope.order.user_update = vm.currentUser;

        $scope.saveConfigurationsAPP = function () {
          $scope.order.services = $scope.order.services.map((service) => {
            if (service.id == $scope.objModel.service_item_reference.id) {
              service = $scope.objModel.service_item_reference;
            }
            return service;
          });
          $http({
            method: "PUT",
            url: Utils.getBaseUrlApi() + "/order",
            data: JSON.stringify($scope.order),
          }).then(
            function successCallback(response) {
              var success_message = "<strong>Operação realizada</strong><br/>" + "Configurações " + (response.status == 201 ? "incluído" : "atualizado") + " com sucesso!<br/>";
              toaster.pop({
                type: "success",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: success_message,
              });
              if ($scope.order.services.length > 1) getDataById();
              $scope.closeModal();
            },
            function errorCallback(response) {
              toaster.pop({
                type: "error",
                timeout: 2000,
                bodyOutputType: "trustedHtml",
                body: "<strong>Desculpe!</strong><br/>" + response.data,
              });
            }
          );
        };

        $scope.closeModal = function () {
          $uibModalInstance.close({});
        };
      }
    };

    if (!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id)) getDataById();
    else $state.go("app.order-list");
  }
})();
// order.controller.js
(function() {
    'use strict';

    angular
        .module('app.gerenciamento')
        .controller('OrderController', Controller);

    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster', '$ngConfirm', 'PersonsService'];
    
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster, $ngConfirm, PersonsService) {
        var vm = this;

        activate();

        function activate() {
            vm.currentUser = $rootScope.globals.currentUser;
            
            vm.loading = false;
            vm.objModel = {
                is_recurrent: 'false',
                is_high_priority: 'false',
                priority_level: 'normal',
                status: "pending",
                valor_total_os: 0,
                vlr_total_costs_os: 0,
                creator: $rootScope.globals.currentUser,
            };
            vm.objModelItemService = {};
            vm.limit_options = ["6","12","30","50","100"];
            vm.filter = {
                dta_from: null,
                dta_to: null,
                value: '',
                limit: "6"
            };
            vm.dpOptions = {
                formatYear: 'yy',
                startingDay: 1
            };

            if(!Utils.isEmpty(vm.currentUser.customer)) {
                vm.objModel.requested_at = moment().toDate();
                vm.objModel.requester_name = vm.currentUser.name;
                vm.objModel.customer = vm.currentUser.customer;

                getBusinessUnits();

                if(vm.objModel.customer.person_type == 'PJ') {
                    if(!Utils.isEmpty(vm.objModel.customer.company_name))
                        vm.objModel.customer.label = vm.objModel.customer.company_name;
                    else
                        vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                }
                else
                    vm.objModel.customer.label = vm.objModel.customer.name;

                vm.filter.customer = vm.currentUser.customer;
                if(vm.filter.customer.person_type == 'PJ') {
                    if(!Utils.isEmpty(vm.filter.customer.company_name))
                        vm.filter.customer.label = vm.filter.customer.company_name;
                    else
                        vm.filter.customer.label = vm.filter.customer.fantasy_name;
                }
                else
                    vm.filter.customer.label = vm.filter.customer.name;
            }
        }

        function getDataById() {
            $http({
                    method: "GET",
                    url: Utils.getBaseUrlApi()+'/order/'+ Utils.getUrlVars().id
                }).then(
                    function successCallback(response) {
                        if(response.data.customer.person_type == 'PJ') {
                            if(!Utils.isEmpty(response.data.customer.company_name))
                                response.data.customer.label = response.data.customer.company_name;
                            else
                                response.data.customer.label = response.data.customer.fantasy_name;
                        }
                        else
                            response.data.customer.label = response.data.customer.name;

                        if(!Utils.isEmpty(response.data.services)){
                            angular.forEach(response.data.services, function(service_item){
                                service_item.delete = false;

                                if (!Utils.isEmpty(service_item.vehicles)) {
                                    angular.forEach(service_item.vehicles, function(vehicle){
                                        vehicle.delete = false;
                                    });
                                }
                            });
                        }

                        if(!Utils.isEmpty(response.data.agents)){
                            angular.forEach(response.data.agents, function(agent){
                                agent.delete = false;
                            });
                        }

                        if(!Utils.isEmpty(response.data.costs)){
                            angular.forEach(response.data.costs, function(cost){
                                cost.delete = false;
                            });
                        }

                        vm.objModel = response.data;

                        if(!Utils.isEmpty(vm.objModel.requested_at))
                            vm.objModel.requested_at = moment(vm.objModel.requested_at, "DD/MM/YYYY").toDate();

                        vm.calculateTotalOS();
                        vm.calculateTotalCostOS();
                        vm.getBusinessUnits();
                    },
                    function errorCallback(response) {
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
        }

        function getBusinessUnits() {
            var req_url = `${Utils.getBaseUrlApi()}/business-units?no-limit=true`;
                req_url += `&customer_related_id=${vm.objModel.customer.id}`;

            vm.business_units = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.business_units = response.data;
                },
                function errorCallback(response) {
                    vm.business_units = null;
                }
            );
        }

        vm.getBusinessUnits = getBusinessUnits;

        vm.getServiceResearchType = (service) => {
            const attributes = service.attributes || [];
            
            for (const attribute of attributes) {
                if (attribute.name === "research-type") {
                    return attribute.value;
                }
            }
            
            return undefined;
        }

        vm.canEditOS = function() {
            return ($.inArray($rootScope.globals.currentUser.profile, ['master','admin']) != -1);
        }

        vm.getShortId = function(item) {
            return item.id.substr(item.id.length-12, 12);
        }

        vm.openDatepicker = function($event, model) {
            $event.preventDefault();
            $event.stopPropagation();
            vm['dp_'+ model +'_opened'] = true;
        }

        vm.addService = function() {
            if(!Utils.validateFields(vm, '#servico-add-form')){
                if(Utils.isEmpty(vm.objModel.services))
                    vm.objModel.services = [];

                if(_.filter(vm.objModel.services, function(item){if(item.service.id == vm.objModelItemService.service.id){return item;}else{return null;}}).length > 0) {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>Este serviço já foi adicionado na lista.'
                    });
                }
                else {
                    vm.objModelItemService.status = 'pending';
                    vm.objModelItemService.delete = false;
                    vm.objModel.services.push(angular.copy(vm.objModelItemService));
                }

                vm.objModelItemService = {};
                vm.calculateTotalOS();
            }
        }

        vm.addCost = function() {
            if(!Utils.validateFields(vm, '#despesa-add-form')){
                if(Utils.isEmpty(vm.objModel.costs))
                    vm.objModel.costs = [];

                vm.objModelCost.user_input = $rootScope.globals.currentUser;
                vm.objModelCost.delete = false;
                vm.objModel.costs.push(angular.copy(vm.objModelCost));

                vm.objModelCost = {};
                vm.calculateTotalCostOS();
            }
        }

        vm.getAll = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/orders';
                req_url += '?offset='+ offset +'&limit='+ parseInt(vm.filter.limit);

            if(!Utils.isEmpty(vm.filter.dta_from) && !Utils.isEmpty(vm.filter.dta_to)){
                var dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
                    dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');

                var dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
                    dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
                
                req_url += '&dta_from='+ dta_from;
                req_url += '&dta_to='+ dta_to;
            }

            if ($rootScope.globals.currentUser.profile === 'filial') {
                req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
            }

            if(!Utils.isEmpty(vm.filter.customer)){
                req_url += '&customer_id='+ vm.filter.customer.id;
            }

            if(!Utils.isEmpty(vm.filter.creator)){
                req_url += '&creator_id='+ vm.filter.creator.id;
            }

            if(vm.currentUser.profile == 'analyst'){
                req_url += '&agent_id='+ vm.currentUser.id;
            }

            if(!Utils.isEmpty(vm.filter.status)){
                req_url += '&status='+ vm.filter.status;
            }
            else if(vm.currentUser.profile === 'master') {
                req_url += '&status=ne__done';
            }

            vm.items = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    vm.items = response.data;
                },
                function errorCallback(response) {
                    vm.items = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        vm.clearFilter = function() {
            vm.filter = {
                dta_from: null,
                dta_to: null,
                value: '',
                limit: "5"
            };
            vm.items = null;
        }

        vm.selectPersonType = function() {
            vm.objModel.cpf_cnpj = null;
            if(vm.objModel.person_type == 'PJ'){
                vm.objModel.name = null;
            }
            else if(vm.objModel.person_type == 'PF') {
                vm.objModel.company_name = null;
                vm.objModel.fantasy_name = null;
                vm.objModel.branch_activity = null;
            }
        }

        vm.openModal = function(modal_name, item, size){
            if(Utils.isEmpty(size))
                size = 'lg';

            vm.service_selected = item;
            var modal_instance = $uibModal.open({ 
                size: size,
                backdrop: false,
                templateUrl: '/'+ modal_name +'.html',
                controller: ModalInstanceCtrl
            });

            ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
            function ModalInstanceCtrl($scope, $uibModalInstance) {
                $scope.service_selected = vm.service_selected;
                console.log($scope.service_selected)                
                $scope.new_cliente = false;
                $scope.loading = {
                    address: false,
                    person_data: false
                };
                $scope.objModelPerson = {
                    person_type: 'PF',
                    adresses: [{}],
                    phones: [{}],
                    emails: [{}]
                };
                $scope.objModel = item;

                if(!Utils.isEmpty(vm.currentUser.customer))
                    $scope.objModelPerson.customer_related = vm.currentUser.customer;

                $scope.limit_options = ["5","10","30","50","100"];
                $scope.filter = {
                    value: '',
                    limit: "5"
                };

                $scope.getBusinessUnits = vm.getBusinessUnits;

                $scope.confirmExistsPerson = function(person, index, add_to_list) {
                    $scope.loading.person_data = true;

                    let customer_id = null;
                    
                    if(vm.objModel.customer)
                        customer_id = vm.objModel.customer.id;

                    PersonsService.validate(person.cpf_cnpj, customer_id)
                        .then(({ data }) => {
                            $scope.loading.person_data = false;
                        })
                        .catch(({status, data}) => {
                            if(status === 406 || status === 409) {
                                person = _.extend(person, data.person);
                            
                                let buttons = {};

                                switch(status) {
                                    case 406: // Not Acceptable
                                        buttons.ok = {
                                            text: 'OK',
                                            btnClass: 'btn-primary',
                                            keys: ['enter']
                                        };
                                        if (!Utils.isEmpty(add_to_list) && add_to_list === true) {
                                            $scope.addCompanyService(person, true, 406);
                                            setTimeout(() => {
                                                $scope.$apply();
                                            }, 5);
                                        }
                                        break;
                                    case 409: // Conflict
                                        buttons.continue = {
                                            text: 'Continuar assim mesmo',
                                            btnClass: 'btn-danger',
                                            action: (scope, button) => {
                                                if (!Utils.isEmpty(index)) {
                                                    scope.new_persons[index].error = '';
                                                    scope.new_persons[index].step_validation = true;
                                                    scope.new_persons[index].validation = { status_code: 409 };
                                                }
                                                else if (!Utils.isEmpty(add_to_list) && add_to_list === true) {
                                                    $scope.addCompanyService(person, true, 409);
                                                    setTimeout(() => {
                                                        $scope.$apply();
                                                    }, 5);
                                                }
                                            }
                                        };
                                        buttons.report_preview = {
                                            text: 'Visualizar relatório',
                                            btnClass: 'btn-primary',
                                            action: (scope, button) => {
                                                vm.person_data = data.person;
                                                vm.record_data = data.record;

                                                vm.openModal('reportModal');
                                                
                                                if (!Utils.isEmpty(index))
                                                    scope.new_persons[index] = angular.copy($scope.objModelPerson);
                                                
                                                setTimeout(() => {
                                                    $scope.$apply();
                                                }, 5);
                                            }
                                        };
                                        buttons.cancel = {
                                            text: 'Cancelar',
                                            btnClass: 'btn-default',
                                            action: (scope, button) => {
                                                scope.new_persons[index] = angular.copy($scope.objModelPerson);
                                                setTimeout(() => {
                                                    $scope.$apply();
                                                }, 5);
                                            }
                                        };
                                        break;
                                }

                                $ngConfirm({
                                    title: 'Atenção!',
                                    content: data.message,
                                    scope: $scope,
                                    theme: 'supervan',
                                    buttons: buttons
                                });
                                $scope.loading.person_data = false;
                            }
                            else {
                                $scope.loading.person_data = false;
                            }
                        });

                }

                $scope.clearNewPersonForm = function(person_index) {
                    $scope.new_persons[person_index] = angular.copy($scope.objModelPerson);
                }

                $scope.initNewPersonsForm = function() {
                    $scope.new_persons = [];
                    $scope.addNewPersonForm();
                }

                $scope.addNewPersonForm = function() {
                    $scope.new_persons.push(angular.copy($scope.objModelPerson));
                }

                $scope.removePersonForm = function(person) {
                    $scope.new_persons = _.without($scope.new_persons, person);
                }

                $scope.consultAddressByCEP = function() {
                    $scope.loading.address = true;

                    Utils.getAddressByCEP($scope.objModelPerson.adresses[0].zip_code,
                        function successCallback(response) {
                            if(!response.data.erro) {
                                $scope.objModelPerson.adresses[0] = _.extend($scope.objModelPerson.adresses[0], {
                                    street: response.data.logradouro,
                                    district: response.data.bairro,
                                    city: response.data.localidade,
                                    state: response.data.uf
                                });
                                $scope.loading.address = false;
                            }
                            else {
                                toaster.pop({
                                    type: 'error', 
                                    timeout: 2000, 
                                    bodyOutputType: 'trustedHtml',
                                    body: '<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!'
                                });
                                $scope.loading.address = false;
                            }
                        },
                        function errorCallback(response){
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>Nenhum endereço encontrado com o CEP informado!'
                            });
                        }
                    );
                    // $scope = _.extend(Utils.getAddressByCEP($scope.zip_code));
                }

                $scope.getServicos = function(offset) {
                    var req_url = Utils.getBaseUrlApi()+'/services';
                        req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += '&filter='+ $scope.filter.value;

                    if(!Utils.isEmpty(vm.currentUser.customer))
                        req_url += '&customer_related_id='+ vm.currentUser.customer.id;
                    else if(!Utils.isEmpty(vm.objModel.customer))
                        req_url += '&customer_related_id='+ vm.objModel.customer.id;

                    $scope.servicos = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            $scope.servicos = response.data;
                        },
                        function errorCallback(response) {
                            $scope.servicos = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }

                $scope.getUsuarios = function(offset, profile) {
                    var req_url = Utils.getBaseUrlApi()+'/users';
                        req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += '&filter='+ $scope.filter.value;

                    if(!Utils.isEmpty(vm.currentUser.customer))
                        req_url += '&customer_related_id='+ vm.currentUser.customer.id;
                    
                    if(!Utils.isEmpty(profile))
                        req_url += '&profile='+ profile;

                    $scope.usuarios = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            $scope.usuarios = response.data;
                        },
                        function errorCallback(response) {
                            $scope.usuarios = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }

                $scope.getClientesEmpresas = function(offset) {
                    var req_url = Utils.getBaseUrlApi()+'/persons';
                        req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

                    if(!Utils.isEmpty($scope.filter.value))
                        req_url += '&filter='+ $scope.filter.value;

                    if(!Utils.isEmpty(vm.currentUser.customer))
                        req_url += '&customer_related_id='+ vm.currentUser.customer.id;
                    
                    if ($rootScope.globals.currentUser.profile === 'filial') {
                        req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
                    }

                    $scope.clientesEmpresas = {};

                    $http({
                        method: "GET",
                        url: req_url
                    }).then(
                        function successCallback(response) {
                            if(!Utils.isEmpty(vm.service_selected)) {
                                angular.forEach(response.data.records, function(item){
                                    if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                        item.selected = true;
                                });
                            }
                            $scope.clientesEmpresas = response.data;
                        },
                        function errorCallback(response) {
                            $scope.clientesEmpresas = null;
                            toaster.pop({
                                type: 'error', 
                                timeout: 2000, 
                                bodyOutputType: 'trustedHtml',
                                body: '<strong>Desculpe!</strong><br/>'+ response.data
                            });
                        }
                    );
                }

                $scope.selectItem = function(items, item_selected) {
                    angular.forEach(items, function(item) {
                        item.selected = false;
                    });
                    item_selected.selected = true;
                    $scope.selected_item = angular.copy(item_selected);
                }

                $scope.confirmSelectItem = function(model) {
                    switch(model) {
                        case 'agent':
                            if(Utils.isEmpty(vm.objModel.agents))
                                vm.objModel.agents = [];

                            if(!Utils.isEmpty(_.findWhere(vm.objModel.agents, {id: $scope.selected_item.id}))) {
                                alert('Desculpe! Esse agente já foi adicionado na lista.');
                            }
                            else {
                                var objAdd = angular.copy($scope.selected_item);
                                    objAdd.delete = false;
                                vm.objModel.agents.push(objAdd);
                            }
                            break;
                        case 'customer':
                            vm.objModel.customer = angular.copy($scope.selected_item);
                            if(vm.objModel.customer.person_type == 'PJ') {
                                if(!Utils.isEmpty(vm.objModel.customer.company_name))
                                    vm.objModel.customer.label = vm.objModel.customer.company_name;
                                else
                                    vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                            }
                            else
                                vm.objModel.customer.label = vm.objModel.customer.name;
                            
                            $scope.getBusinessUnits();
                            break;
                        case 'service':
                            vm.objModelItemService.delivery_time = $scope.selected_item.delivery_time;
                            vm.objModelItemService.price = $scope.selected_item.default_price;
                            vm.objModelItemService.service = angular.copy($scope.selected_item);
                            break;
                        case 'filter.customer':
                            vm.filter.customer = angular.copy($scope.selected_item);
                            if(vm.filter.customer.person_type == 'PJ') {
                                if(!Utils.isEmpty(vm.filter.customer.company_name))
                                    vm.filter.customer.label = vm.filter.customer.company_name;
                                else
                                    vm.filter.customer.label = vm.filter.customer.fantasy_name;
                            }
                            else
                                vm.filter.customer.label = vm.filter.customer.name;
                            break;
                        case 'filter.creator':
                            vm.filter.creator = angular.copy($scope.selected_item);
                            break;
                    }

                    $uibModalInstance.close('closed');
                }

                $scope.addCompanyService = function(company, skip_validation, status_code) {
                    company.selected = true;
                    if(Utils.isEmpty(vm.service_selected.companies))
                        vm.service_selected.companies = [];
                    
                    if(Utils.isEmpty(skip_validation) || skip_validation === false) {
                        $scope.confirmExistsPerson(company, null, true);
                        return false;
                    }
                    else if(!Utils.isEmpty(status_code)) {
                        company.validation = { status_code: status_code };
                    }

                    if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: company.id}))) {
                        alert('Desculpe! Esta empresa já foi adicionada na lista.');
                    }

                    vm.service_selected.companies.push(company);
                    
                    vm.service_selected.quantity = vm.service_selected.companies.length;
                }

                $scope.removeCompanyService = function(company) {
                    vm.service_selected.companies = _.without(vm.service_selected.companies, company);
                    angular.forEach($scope.clientesEmpresas.records, function(item){
                        if(item.id == company.id)
                            item.selected = false;
                    });

                    vm.service_selected.quantity = vm.service_selected.companies.length;
                }

                $scope.cancelSelection = function(){
                    $scope.service_selected = null;
                    $scope.objModelPerson = null;
                    $scope.new_cliente = false;
                    $scope.closeModal();
                }

                $scope.saveClienteEmpresa = function(form_type) {
                    var invalid_fields = false;

                    if(form_type == 'service_person') {
                        $.each($scope.new_persons, function(i, person){
                            if(Utils.validateFields(person, ('.person-'+i), 'person.')){
                                invalid_fields = true;
                                return false;
                            }
                        });
                    }
                    else
                        invalid_fields = Utils.validateFields($scope, '#form-person');

                    if(!invalid_fields) {
                        $scope.loading = true;

                        $http({
                            method: "POST",
                            url: Utils.getBaseUrlApi() + ((form_type == 'service_person') ? '/persons' : '/person'),
                            data: JSON.stringify((form_type == 'service_person') ? $scope.new_persons : $scope.objModelPerson)
                        }).then(
                            function successCallback(response) {
                                switch(form_type) {
                                    case 'customer': {
                                        $scope.objModelPerson.id = response.data;

                                        vm.objModel.customer = angular.copy($scope.objModelPerson);
                                        if(vm.objModel.customer.person_type == 'PJ') {
                                            if(!Utils.isEmpty(vm.objModel.customer.company_name))
                                                vm.objModel.customer.label = vm.objModel.customer.company_name;
                                            else
                                                vm.objModel.customer.label = vm.objModel.customer.fantasy_name;
                                        }
                                        else
                                            vm.objModel.customer.label = vm.objModel.customer.name;

                                        $scope.cancelSelection();
                                        
                                        break;
                                    }
                                    case 'service_person': {                                       
                                        var has_errors = false;
                                        
                                        angular.forEach($scope.new_persons, function(item, index) {
                                            if(!Utils.isEmpty(response.data[index].error)){
                                                if(Utils.isEmpty(response.data[index].skip_error) || !response.data[index].skip_error) {
                                                    item.orders = response.data[index].orders;
                                                    item.error = response.data[index].error;
                                                    has_errors = true;
                                                }
                                            }
                                            else {
                                                item.id = response.data[index].id;
                                                $scope.addCompanyService(angular.copy(item), true);
                                                $scope.new_persons = _.without($scope.new_persons, item);
                                            }
                                        });

                                        if(!has_errors) {
                                            $scope.new_cliente = false;
                                            // $scope.getClientesEmpresas(1);
                                            $scope.objModelPerson = {
                                                person_type: 'PF',
                                                adresses: [{}],
                                                phones: [{}],
                                                emails: [{}]
                                            };
                                        }
                                        break;
                                    }
                                }
                            },
                            function errorCallback(response) {
                                $scope.loading = {};
                            }
                        );
                    }
                }

                $scope.enableUploaField = function() {
                    setTimeout(function(){
                        $(".btn-upload").change(function(){
                            var file = this.files[0];
                            var reader = new FileReader();
                            
                            $scope.fileField = $(this).data().fileField;                           

                            if(Utils.isEmpty($scope.objModelPerson[$scope.fileField]))
                                $scope.objModelPerson[$scope.fileField] = {};

                            var type = file.type.substring(file.type.indexOf('/')+1, file.type.length);
                            if(Utils.isEmpty(type) || type === 'plain'){
                                type = file.name.substring((file.name.lastIndexOf('.')+1), file.name.length);
                            }

                            $scope.objModelPerson[$scope.fileField].name = file.name;
                            $scope.objModelPerson[$scope.fileField].type = type;
                            $scope.objModelPerson[$scope.fileField].size = (file.size / 1024);

                            if($scope.objModelPerson[$scope.fileField].size < 1024)
                                $scope.objModelPerson[$scope.fileField].size = Utils.numberFormat($scope.objModelPerson[$scope.fileField].size, 2, ',', '.') + ' KB';
                            else if($scope.objModelPerson[$scope.fileField].size > 1024)
                                $scope.objModelPerson[$scope.fileField].size = Utils.numberFormat($scope.objModelPerson[$scope.fileField].size, 2, ',', '.') + ' MB';

                            reader.onload = function (e) {
                                $scope.objModelPerson[$scope.fileField].path = e.target.result;
                                                               
                                if(!Utils.isEmpty($scope.objModelPerson.csv_person_file)) {
                                    $scope.loading_import = true;

                                    var post_data = {
                                        file: $scope.objModelPerson.csv_person_file,
                                        uf_exception: $scope.service_selected.service.uf_exception,
                                        uf_operation: $scope.service_selected.service.uf_operation

                                    };
                                    
                                    post_data.customer_related = vm.objModel.customer;

                                    let req_url = `${Utils.getBaseUrlApi()}/person/import/file`;

                                    if ($scope.objModelPerson[$scope.fileField].type === 'txt')
                                        req_url += '/bradesco';

                                    $http({
                                        method: "POST",
                                        url: req_url,
                                        data: JSON.stringify(post_data)
                                    }).then(
                                        function successCallback(response) {
                                            // $scope.getClientesEmpresas(1);
                                            angular.forEach(response.data, function(person){
                                                $scope.addCompanyService(person, true);
                                            });
                                            $scope.loading_import = false;
                                        },
                                        function errorCallback(response) {
                                            $scope.loading_import = false;
                                            toaster.pop({
                                                toasterId: 2,
                                                type: (response.status == 406) ? 'warning' : 'error', 
                                                timeout: 2000, 
                                                bodyOutputType: 'trustedHtml',
                                                body: '<strong>Atenção!</strong><br/>'+ response.data +'!'
                                            });
                                        }
                                    );
                                }
                            }

                            if(!Utils.isEmpty(file))
                                reader.readAsDataURL(file);
                        });
                    }, 10);
                }

                $scope.enableUploaField();

                if(!Utils.isEmpty(vm.record_data)) {
                    var report_url = `${Utils.getBaseUrlReports()}`;
                        report_url += '?restrict-use-type='+ ((vm.record_data.service.simplified) ? 'text' : 'icon');
                        report_url += '&format=A4';
                        report_url += '&template='+ vm.record_data.service.report_model;
                        report_url += '&order_id='+ vm.record_data.order.id;
                        report_url += '&service_id='+ vm.record_data.service.id;
                        report_url += '&person_id='+ vm.person_data.id;
                }

                $scope.showPDFReport = function() {
                    new PDFObject({
                        url: report_url, 
                        id: 'report-container',
                        height: '600px'
                    }).embed('report-container');
                }

                $scope.downloadArquivo = function() {
                    report_url += '&filename=' + $scope.nome_arquivo_download;
                    window.open(report_url, '_blank');
                }

                $scope.closeModal = () => {
                    $uibModalInstance.close('closed');
                }

                $scope.addItem = () => {
                    if(Utils.isEmpty($scope.objModel.vehicles)) {
                        $scope.objModel.vehicles = [];
                    }
                    $scope.objModel.vehicles.push({ delete: false });
                    vm.service_selected.quantity = vm.service_selected.vehicles.filter(vehicle => !vehicle.delete).length;
                }

                $scope.removeItem = (item) => {
                    item.delete = true;
                    vm.service_selected.quantity = vm.service_selected.vehicles.filter(vehicle => !vehicle.delete).length;
                }
            }
        }

        vm.calculateTotalOS = function(model) {
            if(Utils.isEmpty(model))
                model = vm.objModel;

            model.valor_total_os = 0;

            angular.forEach(model.services, function(service){
                model.valor_total_os += (service.quantity * service.price);
            });

            if(!Utils.isEmpty(model))
                return model.valor_total_os;
        }

        vm.calculateTotalCostOS = function(){
            vm.objModel.vlr_total_costs_os = 0;
            if(!Utils.isEmpty(vm.objModel.costs)) {
                angular.forEach(vm.objModel.costs, function(cost){
                    vm.objModel.vlr_total_costs_os += cost.value;
                });
            }
        }

        vm.save = function() {
            var is_empty_form = (Utils.validateFields(vm, 'form[role="form"]') == true),
                is_empty_table = (Utils.validateFields(vm, '#servicos-contratados') == true);
            
            if(!is_empty_form && !is_empty_table) {
                vm.loading = true;

                vm.objModel.user_update = vm.currentUser;

                $http({
                    method: Utils.isEmpty(vm.objModel.id) ? "POST" : "PUT",
                    url: Utils.getBaseUrlApi()+'/order',
                    data: JSON.stringify(vm.objModel)
                }).then(
                    function successCallback(response) {
                        activate();

                        var success_message = '<strong>Operação realizada</strong><br/>'+
                                              'Registro '+ ((response.status == 201) ? 'incluído' : 'atualizado') +' com sucesso!<br/>';
                        toaster.pop({
                            type: 'success',
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: success_message,
                            onHideCallback: function() {
                                $state.go('app.order-list');
                            }
                        });
                    },
                    function errorCallback(response) {
                        vm.loading = false;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+response.data
                        });
                    }
                );
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atenção!</strong><br/>Os campos marcados em vermelho são de preenchimento obrigatório.'
                });
            }
        }

        vm.confirmDelete = function() {
            vm.loading = true;

            var post_data = {};

            if(!Utils.isEmpty(vm.objModel.id) && !Utils.isEmpty(vm.currentUser.customer))
                post_data.user_delete = vm.currentUser;

            $http({
                method: "DELETE",
                url: Utils.getBaseUrlApi()+'/order/'+ Utils.getUrlVars().id,
                data: JSON.stringify(post_data)
            }).then(
                function successCallback(response) {
                    toaster.pop({
                        type: 'success',
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Operação realizada</strong><br/>Registro exclúido com sucesso!<br/>Aguarde, você será redirecionado...',
                        onHideCallback: function() {
                            $state.go('app.order-list');
                        }
                    });
                },
                function errorCallback(response) {
                    vm.loading = false;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+response.data
                    });
                }
            );
        }

        vm.changePriorityLevel = (level) => {
            vm.objModel.priority_level = level;
            vm.objModel.is_high_priority = (level === 'highest').toString();
        }

        if(!Utils.isEmpty(Utils.getUrlVars()) && !Utils.isEmpty(Utils.getUrlVars().id))
            getDataById();
    }
})();
(function (){
    'use Strict'
    angular
        .module('app.gerenciamento')
        .factory('WebcamService', WebcamService);

    WebcamService.$inject = [];

    function WebcamService () {
        var _video = null;
        var _stream = null;
        var webcam = {
            isTurnOn: false,
            patData: null,
            patOpts: {
                x: 0, 
                y: 0, 
                w: 25, 
                h: 25},
            channel: { },
            webcamError: false
        };

        var getVideoData = function getVideoData(x, y, w, h) {
            var hiddenCanvas = document.createElement('canvas');
                hiddenCanvas.width = _video.width;
                hiddenCanvas.height = _video.height;
            
            var context = hiddenCanvas.getContext('2d');
                context.drawImage(_video, 0, 0, _video.width, _video.height);
            
            return context.getImageData(x, y, w, h);
        };

        var sendSnapshotToServer = function sendSnapshotToServer(imgBase64) {
            webcam.snapshotData = imgBase64;
        };

        webcam.makeSnapshot = function() {
            if (_video) {
                var patCanvas = document.querySelector('#snapshot');
                if (!patCanvas) return;

                patCanvas.width = _video.width;
                patCanvas.height = _video.height;
                var ctxPat = patCanvas.getContext('2d');

                var idata = getVideoData(webcam.patOpts.x, webcam.patOpts.y, webcam.patOpts.w, webcam.patOpts.h);
                ctxPat.putImageData(idata, 0, 0);

                sendSnapshotToServer(patCanvas.toDataURL());

                webcam.patData = idata;

                webcam.success(webcam.snapshotData.substr(webcam.snapshotData.indexOf('base64,') + 'base64,'.length), 'image/png');
                webcam.turnOff();
            }
        };

        webcam.onSuccess = function () {
            _video = webcam.channel.video;
            webcam.patOpts.w = _video.width;
            webcam.patOpts.h = _video.height;
            webcam.isTurnOn = true;
        };

        webcam.onStream = function (stream) {
            activeStream = stream;
            return activeStream;
        };

        webcam.downloadSnapshot = function downloadSnapshot(dataURL) {
            window.location.href = dataURL;
        };

        webcam.onError = function (err) {
            webcam.webcamError = err;
        };

        webcam.turnOff = function () {
            webcam.isTurnOn = false;
            if (activeStream && activeStream.getVideoTracks) {
                const checker = typeof activeStream.getVideoTracks === 'function';
                if (checker) {
                    return activeStream.getVideoTracks()[0].stop();
                }
                return false;
            }
            return false;
        };

        var service = {
            webcam: webcam
        };
        
        return service;
    }
})();
(function() {
    'use strict';

    angular
        .module('app.loadingbar')
        .config(loadingbarConfig)
        ;
    loadingbarConfig.$inject = ['cfpLoadingBarProvider'];
    function loadingbarConfig(cfpLoadingBarProvider){
      cfpLoadingBarProvider.includeBar = true;
      cfpLoadingBarProvider.includeSpinner = false;
      cfpLoadingBarProvider.latencyThreshold = 500;
      cfpLoadingBarProvider.parentSelector = '.wrapper > section';
    }
})();
(function() {
    'use strict';

    angular
        .module('app.loadingbar')
        .run(loadingbarRun)
        ;
    loadingbarRun.$inject = ['$rootScope', '$timeout', 'cfpLoadingBar'];
    function loadingbarRun($rootScope, $timeout, cfpLoadingBar){

      // Loading bar transition
      // ----------------------------------- 
      var thBar;
      $rootScope.$on('$stateChangeStart', function() {
          if($('.wrapper > section').length) // check if bar container exists
            thBar = $timeout(function() {
              cfpLoadingBar.start();
            }, 0); // sets a latency Threshold
      });
      $rootScope.$on('$stateChangeSuccess', function(event) {
          event.targetScope.$watch('$viewContentLoaded', function () {
            $timeout.cancel(thBar);
            cfpLoadingBar.complete();
          });
      });

    }

})();
(function() {
    'use strict';

    angular
        .module('app.preloader')
        .directive('preloader', preloader);

    preloader.$inject = ['$animate', '$timeout', '$q'];
    function preloader ($animate, $timeout, $q) {

        var directive = {
            restrict: 'EAC',
            template: 
              '<div class="preloader-progress">' +
                  '<div class="preloader-progress-bar" ' +
                       'ng-style="{width: loadCounter + \'%\'}"></div>' +
              '</div>'
            ,
            link: link
        };
        return directive;

        ///////

        function link(scope, el) {

          scope.loadCounter = 0;

          var counter  = 0,
              timeout;

          // disables scrollbar
          angular.element('body').css('overflow', 'hidden');
          // ensure class is present for styling
          el.addClass('preloader');

          appReady().then(endCounter);

          timeout = $timeout(startCounter);

          ///////

          function startCounter() {

            var remaining = 100 - counter;
            counter = counter + (0.015 * Math.pow(1 - Math.sqrt(remaining), 2));

            scope.loadCounter = parseInt(counter, 10);

            timeout = $timeout(startCounter, 20);
          }

          function endCounter() {

            $timeout.cancel(timeout);

            scope.loadCounter = 100;

            $timeout(function(){
              // animate preloader hiding
              $animate.addClass(el, 'preloader-hidden');
              // retore scrollbar
              angular.element('body').css('overflow', '');
            }, 300);
          }

          function appReady() {
            var deferred = $q.defer();
            var viewsLoaded = 0;
            // if this doesn't sync with the real app ready
            // a custom event must be used instead
            var off = scope.$on('$viewContentLoaded', function () {
              viewsLoaded ++;
              // we know there are at least two views to be loaded 
              // before the app is ready (1-index.html 2-app*.html)
              if ( viewsLoaded === 2) {
                // with resolve this fires only once
                $timeout(function(){
                  deferred.resolve();
                }, 3000);

                off();
              }

            });

            return deferred.promise;
          }

        } //link
    }

})();
/**=========================================================
 * Module: navbar-search.js
 * Navbar search toggler * Auto dismiss on ESC key
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.navbar')
        .directive('searchOpen', searchOpen)
        .directive('searchDismiss', searchDismiss);

    //
    // directives definition
    // 
    
    function searchOpen () {
        var directive = {
            controller: searchOpenController,
            restrict: 'A'
        };
        return directive;

    }

    function searchDismiss () {
        var directive = {
            controller: searchDismissController,
            restrict: 'A'
        };
        return directive;
        
    }

    //
    // Contrller definition
    // 
    
    searchOpenController.$inject = ['$scope', '$element', 'NavSearch'];
    function searchOpenController ($scope, $element, NavSearch) {
      $element
        .on('click', function (e) { e.stopPropagation(); })
        .on('click', NavSearch.toggle);
    }

    searchDismissController.$inject = ['$scope', '$element', 'NavSearch'];
    function searchDismissController ($scope, $element, NavSearch) {
      
      var inputSelector = '.navbar-form input[type="text"]';

      $(inputSelector)
        .on('click', function (e) { e.stopPropagation(); })
        .on('keyup', function(e) {
          if (e.keyCode === 27) // ESC
            NavSearch.dismiss();
        });
        
      // click anywhere closes the search
      $(document).on('click', NavSearch.dismiss);
      // dismissable options
      $element
        .on('click', function (e) { e.stopPropagation(); })
        .on('click', NavSearch.dismiss);
    }

})();


/**=========================================================
 * Module: nav-search.js
 * Services to share navbar search functions
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.navbar')
        .service('NavSearch', NavSearch);

    function NavSearch() {
        this.toggle = toggle;
        this.dismiss = dismiss;

        ////////////////

        var navbarFormSelector = 'form.navbar-form';

        function toggle() {
          var navbarForm = $(navbarFormSelector);

          navbarForm.toggleClass('open');

          var isOpen = navbarForm.hasClass('open');

          navbarForm.find('input')[isOpen ? 'focus' : 'blur']();
        }

        function dismiss() {
          $(navbarFormSelector)
            .removeClass('open') // Close control
            .find('input[type="text"]').blur() // remove focus
            // .val('') // Empty input
            ;
        }
    }
})();

// navbar.notifications.controller.js
(function() {
	'use strict';

	angular
		.module('app.navbar')
		.controller('NotificationsController', NotificationsController);

	NotificationsController.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster'];
	function NotificationsController($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster) {

		activate();

		////////////////

		function activate() {
		  $scope.user = $rootScope.globals.currentUser;
		}

		function getOrderShortId(order) {
			return order.id.substr(order.id.length-12, 12);
		}

		$scope.getNotifications = function() {
			var req_url = Utils.getBaseUrlApi();
			
			if($scope.user.customer) {
				req_url += '/notifications/customer';
				req_url += '?customer_id=' + $scope.user.customer.id;
			}
			else
				req_url += '/notifications/master';

			$scope.notifications = {};

			$http({
				method: "GET",
				url: req_url
			}).then(
				function successCallback(response) {
					toaster.pop({
						toasterId: 'notifications',
						type: 'warning', 
						timeout: 2000, 
						bodyOutputType: 'trustedHtml',
						body: 'Você possúi novos alertas!'
					});

					$scope.notifications = response.data;

					angular.forEach($scope.notifications, function(notification) {
						switch(notification.notification_type) {
							case 'os_opened':
								notification.type = 'Nova Ordem de Serviço';
								notification.label = notification.user_generator.name +' (';
								switch(notification.user_generator.customer.person_type) {
									case 'PF':
										notification.label += notification.user_generator.customer.name;
										break;
									case 'PJ':
										notification.label += notification.user_generator.customer.fantasy_name;
										break;
								}
								notification.label += ') abriu uma nova Ordem de Serviço';
								break;
							case 'os_updated':
								notification.type = 'Ordem de Serviço Alterada';
								notification.label = notification.user_generator.name +' (';
								switch(notification.user_generator.customer.person_type) {
									case 'PF':
										notification.label += notification.user_generator.customer.name;
										break;
									case 'PJ':
										notification.label += notification.user_generator.customer.fantasy_name;
										break;
								}
								notification.label += ') alterou os dados da Ordem de Serviço #'+ getOrderShortId(notification.order_related);

								break;
							case 'os_finished':
								notification.type = 'Ordem de Serviço Finalizada';
								notification.label = 'A Ordem de Serviço #'+ getOrderShortId(notification.order_related) +' foi finalizada';
								break;
							case 'os_parcial':
								notification.type = 'Ordem de Serviço Atualizada';
								notification.label = 'A Ordem de Serviço #'+ getOrderShortId(notification.order_related) +' possui atendimento parcial';
								break;
							case 'os_canceled':
								notification.type = 'Ordem de Serviço Cancelada';
								notification.label = notification.user_generator.name +' (';
								switch(notification.user_generator.customer.person_type) {
									case 'PF':
										notification.label += notification.user_generator.customer.name;
										break;
									case 'PJ':
										notification.label += notification.user_generator.customer.fantasy_name;
										break;
								}
								notification.label += ') cancelou a Ordem de Serviço';
								break;
							case 'inconsistent_data':
								notification.type = 'Dados Inconsistentes';

								var name = notification.person_related.name;
								
								if(notification.person_related.person_type == 'PJ'){
									name = notification.person_related.fantasy_name;

									if(Utils.isEmpty(notification.person_related.fantasy_name))
										name = notification.person_related.company_name;
								}

								notification.label = 'Os dados do (a) '+ name +' são inválidos ou ';
								notification.label += 'estão incompletos na Ordem de Serviço #'+ getOrderShortId(notification.order_related);
								break;
							case 'inconsistent_data_callback':
								notification.type = 'Dados Atualizados';

								notification.label = notification.user_generator.name +' (';
								switch(notification.user_generator.customer.person_type) {
									case 'PF':
										notification.label += notification.user_generator.customer.name;
										break;
									case 'PJ':
										notification.label += notification.user_generator.customer.fantasy_name;
										break;
								}
								notification.label += ') atualizou os dados do(a) ';
								switch(notification.person_related.person_type) {
									case 'PF':
										notification.label += notification.person_related.name;
										break;
									case 'PJ':
										notification.label += notification.person_related.fantasy_name;
										break;
								}
								notification.label += ' na Ordem de Serviço #'+ getOrderShortId(notification.order_related);
								break;
						}
					});
				},
				function errorCallback(response) {
					$scope.notifications = null;
				}
			);
		}

		$scope.updateNotificationReaded = function(notification) {
			if(notification.notification_type == 'inconsistent_data') {
				$scope.selected_notification = notification;
				$scope.openModal('responseInconsistentDataModal');
			}
			else {
				$http({
					method: "PUT",
					url: Utils.getBaseUrlApi()+'/notification/'+ notification.id +'/readed',
					data: JSON.stringify({
						user_read: $scope.user
					})
				}).then(
					function successCallback(response) {
						// $scope.getNotifications();
						$state.go('app.order-records', {id: notification.order_related.id});
					},
					function errorCallback(response) {
						toaster.pop({
							type: 'error', 
							timeout: 2000, 
							bodyOutputType: 'trustedHtml',
							body: '<strong>Desculpe!</strong><br/>'+response.data
						});
					}
				);
			}
		}

		$scope.openModal = function(modal_name, size){
			if(Utils.isEmpty(size))
				size = 'lg';

			var modal_instance = $uibModal.open({ 
				size: size,
				backdrop: false,
				templateUrl: '/'+ modal_name +'.html',
				controller: ModalInstanceCtrl
			});

			ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
			function ModalInstanceCtrl($subScope, $rootScope, $uibModalInstance) {
				$subScope.selected_notification = $scope.selected_notification;
				$subScope.loading_save = false;

				$subScope.closeModal = function() {
					$uibModalInstance.close({});
				}

				$subScope.save = function() {
					$subScope.loading_save = true;
					$http({
						method: "PUT",
						url: Utils.getBaseUrlApi()+'/notification/'+ $subScope.selected_notification.id +'/inconsistency/update/data',
						data: JSON.stringify({
							user_read: $scope.user,
							notification: $subScope.selected_notification
						})
					}).then(
						function successCallback(response) {
							$subScope.loading_save = false;
							$subScope.closeModal();
							// $scope.getNotifications();
						},
						function errorCallback(response) {
							$subScope.loading_save = false;
							toaster.pop({
								type: 'error', 
								timeout: 2000, 
								bodyOutputType: 'trustedHtml',
								body: '<strong>Desculpe!</strong><br/>'+response.data
							});
						}
					);
				}
			}
		};

		// $scope.getNotifications();

		setInterval(function(){
			// $scope.getNotifications();
		}, (5 * 1000));
	}
})();
/**=========================================================
 * Module: access-login.js
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.pages')
        .controller('LoginFormController', LoginFormController);

    LoginFormController.$inject = ['$http', '$state', '$scope', 'Utils', 'AuthenticationService', 'UsersService'];
    function LoginFormController($http, $state, $scope, Utils, AuthenticationService, UsersService) {
      var vm = $scope;

      AuthenticationService.clearCredentials();

      // bind here all data from the form
      vm.account = {};
      // place the message if something goes wrong
      vm.authMsg = '';

      vm.loading = false;

      vm.login = function() {
        vm.authMsg = '';

        if(vm.loginForm.$valid) {
          vm.loading = !vm.loading;

          AuthenticationService.doLogin(
            vm.account.login, 
            vm.account.password,
            function(response) {
              AuthenticationService.setCredentials(response.data);

              vm.account.id = response.data.id;
              vm.account.profile = response.data.profile;
              vm.account.change_password = response.data.change_password;

              let expires_at = moment(response.data.password_expires_at, 'DD/MM/YYYY HH:mm:ss');

              if (expires_at.diff(moment(), 'days') < 0) {
                vm.account.change_password = true;
              }
              
              if(!vm.account.change_password){
                $state.go('app.dashboard');
              }
            },
            function(response) {
              vm.loading = !vm.loading;
              vm.authMsg = response.data;
            }
          );
        }
        else {
          // set as dirty if the user click directly to login so we show the validation messages
          /*jshint -W106*/
          vm.loginForm.account_email.$dirty = true;
          vm.loginForm.account_password.$dirty = true;
        }
      };

      vm.updatePassword = function() {
        vm.loading_password = true;
        if(!Utils.isEmpty(vm.account.update_password) && !Utils.isEmpty(vm.account.check_password) && vm.account.update_password == vm.account.check_password){
          let payload = {
            password: vm.account.update_password
          }
          UsersService.updatePassword(vm.account.id, payload)
            .then((data) => { 
              vm.loading_password = false;
              $state.go('app.dashboard');
            })
            .catch((data) => {
              vm.loading_password = false;
              vm.authMsg = 'Desculpe! Troca de senha inválida!'
            })
        }
        else {
          vm.loading_password = false;
          vm.authMsg = 'Desculpe! As senhas não coincidem!'
        }
      };
    }
})();

(function(){
	'use strict';

	angular
		.module('app.pages')
		.factory('AuthenticationService', AuthenticationService);

	AuthenticationService.$inject = ['$http', '$cookies', '$rootScope', '$timeout', 'Utils'];
	function AuthenticationService($http, $cookies, $rootScope, $timeout, Utils) {
		var service = {};
				service.doLogin = doLogin;
				service.setCredentials = setCredentials;
				service.clearCredentials = clearCredentials;

		return service;

		// Base64 encoding service used by AuthenticationService
		var Base64 = {
			keyStr: 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=',
			encode: function (input) {
				var output = "";
				var chr1, chr2, chr3 = "";
				var enc1, enc2, enc3, enc4 = "";
				var i = 0;
				do {
					chr1 = input.charCodeAt(i++);
					chr2 = input.charCodeAt(i++);
					chr3 = input.charCodeAt(i++);
					enc1 = chr1 >> 2;
					enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
					enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
					enc4 = chr3 & 63;
					if (isNaN(chr2)) {
						enc3 = enc4 = 64;
					} else if (isNaN(chr3)) {
						enc4 = 64;
					}
					output = output +
					this.keyStr.charAt(enc1) +
					this.keyStr.charAt(enc2) +
					this.keyStr.charAt(enc3) +
					this.keyStr.charAt(enc4);
					chr1 = chr2 = chr3 = "";
					enc1 = enc2 = enc3 = enc4 = "";
				} while (i < input.length);
				return output;
			},
			decode: function (input) {
				var output = "";
				var chr1, chr2, chr3 = "";
				var enc1, enc2, enc3, enc4 = "";
				var i = 0;
				var base64test = /[^A-Za-z0-9\+\/\=]/g;
				if (base64test.exec(input)) {
					window.alert("There were invalid base64 characters in the input text.\n" +
						"Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
						"Expect errors in decoding.");
				}
				input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
				do {
					enc1 = this.keyStr.indexOf(input.charAt(i++));
					enc2 = this.keyStr.indexOf(input.charAt(i++));
					enc3 = this.keyStr.indexOf(input.charAt(i++));
					enc4 = this.keyStr.indexOf(input.charAt(i++));
					chr1 = (enc1 << 2) | (enc2 >> 4);
					chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
					chr3 = ((enc3 & 3) << 6) | enc4;
					output = output + String.fromCharCode(chr1);
					if (enc3 != 64) {
						output = output + String.fromCharCode(chr2);
					}
					if (enc4 != 64) {
						output = output + String.fromCharCode(chr3);
					}
					chr1 = chr2 = chr3 = "";
					enc1 = enc2 = enc3 = enc4 = "";
				} while (i < input.length);
				return output;
			}
		};

		function doLogin(login, password, callbackOnSuccess, callbackOnFailed) {
			var post_data = {
				login: login, 
				password: password
			};
			
			$http.post(Utils.getBaseUrlApi()+'/user/auth', post_data).then(callbackOnSuccess, callbackOnFailed);
		}

		function setCredentials(user_data) {
			if(!Utils.isEmpty(user_data.customer) && !Utils.isEmpty(user_data.customer.foto)) {
				user_data.foto = Utils.getBaseUrlApi() +"/"+ user_data.customer.foto;
			}
			else {
				user_data.foto = 'app/img/user.png';
			}

			user_data.access_token = user_data.access_token.replace('b','').replace('\'','').replace('\'','')
			
			$rootScope.globals = {
				currentUser: user_data
			};

			// store user details in globals cookie that keeps user logged in for 1 week (or until they logout)
			var cookie_expiration = new Date();
					cookie_expiration.setDate(cookie_expiration.getDate() + 7);

			$cookies.putObject('globals', $rootScope.globals, {expires: cookie_expiration});
		}

		function clearCredentials() {
			$rootScope.globals = {};
			$cookies.remove('globals');
			// $http.defaults.headers.common.Authorization = 'Basic';
		}
	}
})();
(function(){
  'use strict';

  angular
    .module('app.pages')
    .factory('Interceptors', Interceptors);

  Interceptors.$inject = ['$q','$rootScope'];

  function Interceptors($q, $rootScope) {
    return {
      request: function(config) {
        if($rootScope.globals && $rootScope.globals.currentUser && (config.url.indexOf('3000') !== -1 || config.url.indexOf('3001') !== -1))
          config.headers['Authorization'] = 'Bearer '+ $rootScope.globals.currentUser.access_token;
        return config;
      }
    }
  }
})();
// report-expenses.controller.js
(function() {
    'use strict';
  
    angular
        .module('app.relatorios')
        .controller('ReportExpensesController', Controller);
  
    Controller.$inject = [
        '$log', 
        '$rootScope', 
        '$scope', 
        '$state', 
        '$http', 
        '$uibModal', 
        'Utils', 
        'toaster', 
        'WebcamService', 
        'BusinessUnitsService', 
        'ServicesService', 
        'Colors'
      ];
  
    function Controller(
        $log, 
        $rootScope, 
        $scope, 
        $state, 
        $http, 
        $uibModal, 
        Utils, 
        toaster, 
        WebcamService, 
        BusinessUnitsService, 
        ServicesService, 
        Colors
      ) {
        var vm = this;
        
        activate();
        
        ////////////////
        
        function activate() {
          vm.currentUser = $rootScope.globals.currentUser;
          
          vm.filter = {
            limit: '10'
          };
  
          vm.columns = {
              business_unit: true,
              service: true,
              unit_value: true,
              requester_name: true,
              requested_at: true,
              status_criminal: true,
              status_finance: true,
              status_accident_report: true
          };
          
          vm.dpOptions = {
            formatYear: 'yy',
            startingDay: 1
          };
          
          vm.limit_options = ["5","10","30","50","100"];
  
          if(!Utils.isEmpty(vm.currentUser.customer)) {
              vm.filter.customer = vm.currentUser.customer;
              if(vm.filter.customer.person_type == 'PJ') {
                  if(!Utils.isEmpty(vm.filter.customer.company_name))
                      vm.filter.customer.label = vm.filter.customer.company_name;
                  else
                      vm.filter.customer.label = vm.filter.customer.fantasy_name;
              }
              else
                  vm.filter.customer.label = vm.filter.customer.name;
          }
        }
  
        vm.loadBusinessUnitsByCustomer = (customer) => {
          let params = [{
              key: 'no-limit',
              value: true
          }, {
              key: 'customer_related_id',
              value: customer.id
          }];
          BusinessUnitsService.getAll(params)
              .then(({ data }) => {
                  vm.business_units = data;
              })
              .catch((error) => {
                  console.log(error);
              });
        }
  
        vm.applyFilter = function() {
            var dta_from = null,
                dta_to = null,
                customer_id = null;
  
            if(!Utils.isEmpty(vm.filter.dta_from)){
                dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
                dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo De é obrigatório'
                });
            }
  
            if(!Utils.isEmpty(vm.filter.dta_to)) {
                dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
                dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo Até é obrigatório'
                });
            }
  
            if(!Utils.isEmpty(vm.filter.customer) && !Utils.isEmpty(vm.filter.customer.id))
              customer_id = vm.filter.customer.id
            else {
              toaster.pop({
                type: 'warning', 
                timeout: 2000, 
                bodyOutputType: 'trustedHtml',
                body: '<strong>Atençao!</strong><br/>O campo Cliente é obrigatório'
              });
            }
  
            if(!Utils.isEmpty(dta_from) && !Utils.isEmpty(dta_to) && !Utils.isEmpty(customer_id)) {
              loadReportData(dta_from, dta_to, customer_id);
            }
        }
  
        vm.clearFilter = () => {
          vm.filter = {
              dta_from: '',
              dta_to: '',
              limit: '10'
          };
          vm.items = null;
        }
  
        vm.openDatepicker = function($event, model) {
            $event.preventDefault();
            $event.stopPropagation();
            vm['dp_'+ model +'_opened'] = true;
        }
  
        vm.openModal = function(modal_name, item){
          var modal_instance = $uibModal.open({ 
              size: 'md',
              backdrop: false,
              templateUrl: '/'+ modal_name +'.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $uibModalInstance) {
            $scope.limit_options = ["5","10","30","50","100"];
            $scope.filter = {
                value: '',
                limit: "5"
            };
  
            $scope.getOrderRecordLayouts = function(offset) {
                var req_url = Utils.getBaseUrlApi()+'/order/records/layouts';
                    req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);
  
                if(!Utils.isEmpty($scope.filter.value))
                    req_url += '&filter='+ $scope.filter.value;
  
                $scope.layouts = {};
  
                $http({
                    method: "GET",
                    url: req_url
                }).then(
                    function successCallback(response) {
                        if(!Utils.isEmpty(vm.objModel)) {
                            angular.forEach(response.data.records, function(item){
                                if(!Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id})))
                                    item.selected = true;
                            });
                        }
                        $scope.layouts = response.data;
                    },
                    function errorCallback(response) {
                        $scope.layouts = null;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+ response.data
                        });
                    }
                );
            }
  
            $scope.addItem = function(item){
                if(Utils.isEmpty(vm.objModel.records_layouts))
                    vm.objModel.records_layouts = [];
                if(Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id}))) {
                    item.selected = true;
                    item.delete = false;
                    vm.objModel.records_layouts.push( angular.copy(item) );
                }
                else {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>Este layout já foi adicionado na lista.'
                    });
                }
            }
  
            $scope.selectItem = function(items, item_selected) {
                angular.forEach(items, function(item) {
                    item.selected = false;
                });
                item_selected.selected = true;
                $scope.selected_item = angular.copy(item_selected);
            }
  
            $scope.confirmSelectItem = function(model) {
                switch(model) {
                  case 'filter.customer':
                      vm.loadBusinessUnitsByCustomer($scope.selected_item);
                      vm.filter.customer = angular.copy($scope.selected_item);
                      if(vm.filter.customer.person_type == 'PJ') {
                          if(!Utils.isEmpty(vm.filter.customer.company_name))
                              vm.filter.customer.label = vm.filter.customer.company_name;
                          else
                              vm.filter.customer.label = vm.filter.customer.fantasy_name;
                      }
                      else
                          vm.filter.customer.label = vm.filter.customer.name;
                      break;
                  case 'service':
                      vm.filter.service = $scope.selected_item;
                      vm.filter.service.label = $scope.selected_item.name;
                      break;
                }
                $uibModalInstance.close('closed');
            }
  
            $scope.cancelSelection = function(){
                $scope.service_selected = null;
                $scope.objModelPerson = null;
                $scope.new_cliente = false;
                $uibModalInstance.close('closed');
            }
  
            $scope.getClientesEmpresas = function(offset) {
                var req_url = Utils.getBaseUrlApi()+'/persons';
                    req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);
  
                if(!Utils.isEmpty($scope.filter.value))
                    req_url += '&filter='+ $scope.filter.value;
  
                $scope.clientesEmpresas = {};
  
                $http({
                    method: "GET",
                    url: req_url
                }).then(
                    function successCallback(response) {
                        if(!Utils.isEmpty(vm.service_selected)) {
                            angular.forEach(response.data.records, function(item){
                                if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                    item.selected = true;
                            });
                        }
                        $scope.clientesEmpresas = response.data;
                    },
                    function errorCallback(response) {
                        $scope.clientesEmpresas = null;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+ response.data
                        });
                    }
                );
            }
  
            $scope.getServicos = function(offset) {
              let params = [{
                  key: 'offset',
                  value: offset
              },{
                  key: 'limit',
                  value: parseInt($scope.filter.limit)
              },{
                  key: 'customer_related_id',
                  value: vm.filter.customer.id
              }];
  
              if(!Utils.isEmpty($scope.filter.value)) {
                  params.push({
                      key: 'filter',
                      value: $scope.filter.value
                  });
              }
  
              $scope.servicos = {};
  
              ServicesService.getAll(params)
                  .then(({ data }) => {
                      $scope.servicos = data;
                  })
                  .catch((error) => {
                      console.log(error);
                  });
          }
          }
        }
  
        function loadReportData(dta_from, dta_to, customer_id) {
            vm.items = {};
            vm.qtd_total = 0;
            vm.vlr_total = 0;
    
            let params = [{
                key: 'dta_from',
                value: dta_from
            },{
                key: 'dta_to',
                value: dta_to
            },{
                key: 'customer_id',
                value: customer_id
            }];
    
            if(!Utils.isEmpty(vm.filter.business_unit) && !Utils.isEmpty(vm.filter.business_unit.id)) {
                params.push({
                    key: 'business_unit_id',
                    value: vm.filter.business_unit.id
                });
            }
    
            if(!Utils.isEmpty(vm.filter.service) && !Utils.isEmpty(vm.filter.service.id)) {
                params.push({
                    key: 'service_id',
                    value: vm.filter.service.id
                });
            }
    
            let query_string = Utils.generateQueryString(params);
    
            var req_url  = Utils.getBaseUrlApi();
                req_url += `/reports/expenses${query_string}`;
    
            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                vm.items = response.data;
                angular.forEach(vm.items.records, (item) =>{
                    vm.qtd_total++;
                    vm.vlr_total += item.service.default_price;
                });
                resumeCounters();
                },
                function errorCallback(response) {
                toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Desculpe!</strong><br/>'+response.data
                });
                }
            );
        }
  
        function resumeCounters() {
            vm.counters = {
                total: vm.items.records.length,
                ables: {
                    criminal: 0,
                    finance: 0,
                    accident_report: 0
                },
                unables: {
                  criminal: 0,
                  finance: 0,
                  accident_report: 0
                }
            }
            vm.items.records.forEach((item) => {
              vm.counters.ables.criminal += (item.details.criminal_able) ? 1 : 0;
              vm.counters.unables.criminal += (!item.details.criminal_able) ? 1 : 0;
  
              vm.counters.ables.finance += (item.details.finance_able) ? 1 : 0;
              vm.counters.unables.finance += (!item.details.finance_able) ? 1 : 0;
  
              vm.counters.ables.accident_report += (item.details.accident_report_able) ? 1 : 0;
              vm.counters.unables.accident_report += (!item.details.accident_report_able) ? 1 : 0;
            });
        }
  
        vm.openPDFReport = function() {
          var modal_instance = $uibModal.open({ 
              backdrop: false,
              size: 'xl',
              templateUrl: '/reportModal.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
              var dta_from = null,
                  dta_to = null;
  
              dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from,
              dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
              
              dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
              dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
              
              let report_url = `${Utils.getBaseUrlReports()}`;
              let params = [{
                  key: 'template',
                  value: 'report-expenses'
              }, {
                  key: 'format',
                  value: 'A4-L'
              }, {
                  key: 'columns',
                  value: JSON.stringify(vm.columns)
              }, {
                  key: 'dta_from',
                  value: dta_from
              }, {
                  key: 'dta_to',
                  value: dta_to
              }, {
                  key: 'customer_id',
                  value: vm.filter.customer.id
              }];
  
              if(!Utils.isEmpty(vm.filter.business_unit) && !Utils.isEmpty(vm.filter.business_unit.id)) {
                  params.push({
                      key: 'business_unit_id',
                      value: vm.filter.business_unit.id
                  });
              }
      
              if(!Utils.isEmpty(vm.filter.service) && !Utils.isEmpty(vm.filter.service.id)) {
                  params.push({
                      key: 'service_id',
                      value: vm.filter.service.id
                  });
              }
  
              let query_string = Utils.generateQueryString(params);
  
              $scope.showPDFReport = function() {
                  new PDFObject({
                      url: report_url + query_string, 
                      id: 'report-container',
                      height: '600px'
                  }).embed('report-container');
              }
  
              $scope.downloadArquivo = function() {
                  report_url += '&filename=' + $scope.nome_arquivo_download;
                  window.open(report_url, '_blank');
              }
  
              $scope.closeModal = function() {
                  $uibModalInstance.close({});
              }
          };
        }
        if(!Utils.isEmpty(vm.currentUser.customer)) {
            vm.loadBusinessUnitsByCustomer(vm.currentUser.customer);
        }
    }
    
  })();
// report-measurement.controller.js
(function() {
    'use strict';
  
    angular
        .module('app.relatorios')
        .controller('ReportMeasurementController', Controller);
  
    Controller.$inject = ['$log', '$rootScope', '$scope', '$state', '$http', '$uibModal', 'Utils', 'toaster', 'WebcamService', 'Colors'];
  
    function Controller($log, $rootScope, $scope, $state, $http, $uibModal, Utils, toaster, WebcamService, Colors) {
        var vm = this;
        
        activate();
        
        ////////////////
        
        function activate() {
          vm.currentUser = $rootScope.globals.currentUser;
          
          vm.filter = {
            dta_from: '',
            dta_to: '',
            limit: '10'
          };
          
          vm.dpOptions = {
            formatYear: 'yy',
            startingDay: 1
          };
          
          vm.limit_options = ["5","10","30","50","100"];
  
          if(!Utils.isEmpty(vm.currentUser.customer)) {
              vm.filter.customer = vm.currentUser.customer;
              if(vm.filter.customer.person_type == 'PJ') {
                  if(!Utils.isEmpty(vm.filter.customer.company_name))
                      vm.filter.customer.label = vm.filter.customer.company_name;
                  else
                      vm.filter.customer.label = vm.filter.customer.fantasy_name;
              }
              else
                  vm.filter.customer.label = vm.filter.customer.name;
          }
        }
  
        vm.applyFilter = function() {
            var dta_from = null,
                dta_to = null,
                customer_id = null;
  
            if(!Utils.isEmpty(vm.filter.dta_from)){
                dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
                dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo De é obrigatório'
                });
            }
  
            if(!Utils.isEmpty(vm.filter.dta_to)) {
                dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
                dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
            }
            else {
                toaster.pop({
                    type: 'warning', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Atençao!</strong><br/>O campo Até é obrigatório'
                });
            }
  
            if(!Utils.isEmpty(vm.filter.customer) && !Utils.isEmpty(vm.filter.customer.id))
              customer_id = vm.filter.customer.id
            else {
              toaster.pop({
                type: 'warning', 
                timeout: 2000, 
                bodyOutputType: 'trustedHtml',
                body: '<strong>Atençao!</strong><br/>O campo Cliente é obrigatório'
              });
            }
  
            if(!Utils.isEmpty(dta_from) && !Utils.isEmpty(dta_to) && !Utils.isEmpty(customer_id)) {
              loadReportData(dta_from, dta_to, customer_id, 0, 10);
            }
        }
  
        vm.clearFilter = () => {
          vm.filter = {
              dta_from: '',
              dta_to: '',
              limit: '10'
          };
          vm.items = null;
        }
  
        vm.openDatepicker = function($event, model) {
            $event.preventDefault();
            $event.stopPropagation();
            vm['dp_'+ model +'_opened'] = true;
        }
  
        vm.openModal = function(modal_name, item){
          var modal_instance = $uibModal.open({ 
              size: 'md',
              backdrop: false,
              templateUrl: '/'+ modal_name +'.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $uibModalInstance) {
            $scope.limit_options = ["5","10","30","50","100"];
            $scope.filter = {
                value: '',
                limit: "5"
            };
  
            $scope.getOrderRecordLayouts = function(offset) {
                var req_url = Utils.getBaseUrlApi()+'/order/records/layouts';
                    req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);
  
                if(!Utils.isEmpty($scope.filter.value))
                    req_url += '&filter='+ $scope.filter.value;
  
                $scope.layouts = {};
  
                $http({
                    method: "GET",
                    url: req_url
                }).then(
                    function successCallback(response) {
                        if(!Utils.isEmpty(vm.objModel)) {
                            angular.forEach(response.data.records, function(item){
                                if(!Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id})))
                                    item.selected = true;
                            });
                        }
                        $scope.layouts = response.data;
                    },
                    function errorCallback(response) {
                        $scope.layouts = null;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+ response.data
                        });
                    }
                );
            }
  
            $scope.addItem = function(item){
                if(Utils.isEmpty(vm.objModel.records_layouts))
                    vm.objModel.records_layouts = [];
                if(Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id}))) {
                    item.selected = true;
                    item.delete = false;
                    vm.objModel.records_layouts.push( angular.copy(item) );
                }
                else {
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>Este layout já foi adicionado na lista.'
                    });
                }
            }
  
            $scope.selectItem = function(items, item_selected) {
                angular.forEach(items, function(item) {
                    item.selected = false;
                });
                item_selected.selected = true;
                $scope.selected_item = angular.copy(item_selected);
            }
  
            $scope.confirmSelectItem = function(model) {
                switch(model) {
                  case 'filter.customer':
                    vm.filter.customer = angular.copy($scope.selected_item);
                    if(vm.filter.customer.person_type == 'PJ') {
                      if(!Utils.isEmpty(vm.filter.customer.company_name))
                        vm.filter.customer.label = vm.filter.customer.company_name;
                      else
                        vm.filter.customer.label = vm.filter.customer.fantasy_name;
                    }
                    else
                      vm.filter.customer.label = vm.filter.customer.name;
                    break;
                }
                $uibModalInstance.close('closed');
            }
  
            $scope.cancelSelection = function(){
                $scope.service_selected = null;
                $scope.objModelPerson = null;
                $scope.new_cliente = false;
                $uibModalInstance.close('closed');
            }
  
            $scope.getClientesEmpresas = function(offset) {
                var req_url = Utils.getBaseUrlApi()+'/persons';
                    req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);
  
                if(!Utils.isEmpty($scope.filter.value))
                    req_url += '&filter='+ $scope.filter.value;
  
                $scope.clientesEmpresas = {};
  
                $http({
                    method: "GET",
                    url: req_url
                }).then(
                    function successCallback(response) {
                        if(!Utils.isEmpty(vm.service_selected)) {
                            angular.forEach(response.data.records, function(item){
                                if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                    item.selected = true;
                            });
                        }
                        $scope.clientesEmpresas = response.data;
                    },
                    function errorCallback(response) {
                        $scope.clientesEmpresas = null;
                        toaster.pop({
                            type: 'error', 
                            timeout: 2000, 
                            bodyOutputType: 'trustedHtml',
                            body: '<strong>Desculpe!</strong><br/>'+ response.data
                        });
                    }
                );
            }
          }
        }
  
        function loadReportData(dta_from, dta_to, customer_id, offset, limit) {
          vm.items = {};
          vm.qtd_total = 0;
          vm.vlr_total = 0;
  
          var req_url  = Utils.getBaseUrlApi();
              req_url += '/measurements';
              req_url += `/${offset}/${limit}`
              req_url += '?dta_from='+ dta_from;
              req_url += '&dta_to='+ dta_to;
              req_url += '&customer_id='+ customer_id;
  
          $http({
            method: "GET",
            url: req_url
          }).then(
            function successCallback(response) {
              vm.items = response.data;
              angular.forEach(vm.items.records, (item) =>{
                vm.qtd_total++;
                vm.vlr_total += item.service.default_price;
              });
            },
            function errorCallback(response) {
              toaster.pop({
                type: 'error', 
                timeout: 2000, 
                bodyOutputType: 'trustedHtml',
                body: '<strong>Desculpe!</strong><br/>'+response.data
              });
            }
          );
        }
  
        vm.openPDFReport = function() {
          var modal_instance = $uibModal.open({ 
              backdrop: false,
              size: 'xl',
              templateUrl: '/reportModal.html',
              controller: ModalInstanceCtrl
          });
  
          ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
          function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
              var dta_from = null,
                  dta_to = null;
  
              dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from,
              dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
              
              dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
              dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
  
              var report_url = Utils.getBaseUrlReports();
                  report_url += '?template=report-monthly-resume';
                  report_url += '&format=A4-L';
                  report_url += '&dta_from='+ dta_from;
                  report_url += '&dta_to='+ dta_to;
                  report_url += '&customer_id='+ vm.filter.customer.id;
  
              $scope.showPDFReport = function() {
                  new PDFObject({
                      url: report_url, 
                      id: 'report-container',
                      height: '600px'
                  }).embed('report-container');
              }
  
              $scope.downloadArquivo = function() {
                  report_url += '&filename=' + $scope.nome_arquivo_download;
                  window.open(report_url, '_blank');
              }
  
              $scope.closeModal = function() {
                  $uibModalInstance.close({});
              }
          };
      }
    }
  })();
// report-researches.controller.js
(function() {
  'use strict';

  angular
      .module('app.relatorios')
      .controller('ReportResearchesPersonController', Controller);

  Controller.$inject = [
      '$log', 
      '$rootScope', 
      '$scope', 
      '$state', 
      '$http', 
      '$uibModal', 
      'Utils', 
      'toaster', 
      'WebcamService', 
      'BusinessUnitsService', 
      'ServicesService', 
      'Colors'
    ];

  function Controller(
    $log, 
    $rootScope, 
    $scope, 
    $state, 
    $http, 
    $uibModal, 
    Utils, 
    toaster, 
    WebcamService, 
    BusinessUnitsService, 
    ServicesService, 
    Colors
  ) {
    var vm = this;
    
    activate();
    
    ////////////////
    
    function activate() {
      vm.currentUser = $rootScope.globals.currentUser;
      
      vm.filter = {
        limit: '10'
      };

      vm.columns = {
          business_unit: true,
          service: true,
          unit_value: true,
          requester_name: true,
          requested_at: true,
          status_criminal: true,
          status_finance: true,
          status_accident_report: true
      };
      
      vm.dpOptions = {
        formatYear: 'yy',
        startingDay: 1
      };
      
      vm.limit_options = ["5","10","30","50","100"];

      if(!Utils.isEmpty(vm.currentUser.customer)) {
          vm.filter.customer = vm.currentUser.customer;
          if(vm.filter.customer.person_type == 'PJ') {
              if(!Utils.isEmpty(vm.filter.customer.company_name))
                  vm.filter.customer.label = vm.filter.customer.company_name;
              else
                  vm.filter.customer.label = vm.filter.customer.fantasy_name;
          }
          else
              vm.filter.customer.label = vm.filter.customer.name;
      }
    }

    vm.loadBusinessUnitsByCustomer = (customer) => {
      let params = [{
          key: 'no-limit',
          value: true
      }, {
          key: 'customer_related_id',
          value: customer.id
      }];
      BusinessUnitsService.getAll(params)
          .then(({ data }) => {
              vm.business_units = data;
          })
          .catch((error) => {
              console.log(error);
          });
    }

    vm.applyFilter = function() {
        var dta_from = null,
            dta_to = null,
            person_id = null;

        if(!Utils.isEmpty(vm.filter.dta_from)){
            dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
            dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
        }
        else {
            toaster.pop({
                type: 'warning', 
                timeout: 2000, 
                bodyOutputType: 'trustedHtml',
                body: '<strong>Atençao!</strong><br/>O campo De é obrigatório'
            });
        }

        if(!Utils.isEmpty(vm.filter.dta_to)) {
            dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
            dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
        }
        else {
            toaster.pop({
                type: 'warning', 
                timeout: 2000, 
                bodyOutputType: 'trustedHtml',
                body: '<strong>Atençao!</strong><br/>O campo Até é obrigatório'
            });
        }

        if(!Utils.isEmpty(vm.filter.person) && !Utils.isEmpty(vm.filter.person.id))
          person_id = vm.filter.person.id
        else {
          toaster.pop({
            type: 'warning', 
            timeout: 2000, 
            bodyOutputType: 'trustedHtml',
            body: '<strong>Atençao!</strong><br/>O campo Cliente é obrigatório'
          });
        }

        if(!Utils.isEmpty(dta_from) && !Utils.isEmpty(dta_to) && !Utils.isEmpty(person_id)) {
          loadReportData(dta_from, dta_to, person_id);
        }
    }

    vm.clearFilter = () => {
      vm.filter = {
          dta_from: '',
          dta_to: '',
          limit: '10'
      };
      vm.items = null;
    }

    vm.openDatepicker = function($event, model) {
        $event.preventDefault();
        $event.stopPropagation();
        vm['dp_'+ model +'_opened'] = true;
    }

    vm.openModal = function(modal_name, item){
      var modal_instance = $uibModal.open({ 
          size: 'md',
          backdrop: false,
          templateUrl: '/'+ modal_name +'.html',
          controller: ModalInstanceCtrl
      });

      ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
      function ModalInstanceCtrl($scope, $uibModalInstance) {
        $scope.limit_options = ["5","10","30","50","100"];
        $scope.filter = {
            value: '',
            limit: "5"
        };

        $scope.getOrderRecordLayouts = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/order/records/layouts';
                req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

            if(!Utils.isEmpty($scope.filter.value))
                req_url += '&filter='+ $scope.filter.value;

            $scope.layouts = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    if(!Utils.isEmpty(vm.objModel)) {
                        angular.forEach(response.data.records, function(item){
                            if(!Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id})))
                                item.selected = true;
                        });
                    }
                    $scope.layouts = response.data;
                },
                function errorCallback(response) {
                    $scope.layouts = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        $scope.addItem = function(item){
            if(Utils.isEmpty(vm.objModel.records_layouts))
                vm.objModel.records_layouts = [];
            if(Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id}))) {
                item.selected = true;
                item.delete = false;
                vm.objModel.records_layouts.push( angular.copy(item) );
            }
            else {
                toaster.pop({
                    type: 'error', 
                    timeout: 2000, 
                    bodyOutputType: 'trustedHtml',
                    body: '<strong>Desculpe!</strong><br/>Este layout já foi adicionado na lista.'
                });
            }
        }

        $scope.selectItem = function(items, item_selected) {
            angular.forEach(items, function(item) {
                item.selected = false;
            });
            item_selected.selected = true;
            $scope.selected_item = angular.copy(item_selected);
        }

        $scope.confirmSelectItem = function(model) {
            switch(model) {
              case 'filter.person':
                  vm.filter.person = angular.copy($scope.selected_item);
                  if(vm.filter.person.person_type == 'PJ') {
                      if(!Utils.isEmpty(vm.filter.person.company_name))
                          vm.filter.person.label = vm.filter.person.company_name;
                      else
                          vm.filter.person.label = vm.filter.person.fantasy_name;
                  }
                  else
                      vm.filter.person.label = vm.filter.person.name;
                  break;
            }
            $uibModalInstance.close('closed');
        }

        $scope.cancelSelection = function(){
            $scope.service_selected = null;
            $scope.objModelPerson = null;
            $scope.new_cliente = false;
            $uibModalInstance.close('closed');
        }

        $scope.getClientesEmpresas = function(offset) {
            var req_url = Utils.getBaseUrlApi()+'/persons';
                req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

            if(!Utils.isEmpty($scope.filter.value))
                req_url += '&filter='+ $scope.filter.value;
              
            $scope.clientesEmpresas = {};

            $http({
                method: "GET",
                url: req_url
            }).then(
                function successCallback(response) {
                    if(!Utils.isEmpty(vm.service_selected)) {
                        angular.forEach(response.data.records, function(item){
                            if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                item.selected = true;
                        });
                    }
                    $scope.clientesEmpresas = response.data;
                },
                function errorCallback(response) {
                    $scope.clientesEmpresas = null;
                    toaster.pop({
                        type: 'error', 
                        timeout: 2000, 
                        bodyOutputType: 'trustedHtml',
                        body: '<strong>Desculpe!</strong><br/>'+ response.data
                    });
                }
            );
        }

        $scope.getServicos = function(offset) {
          let params = [{
              key: 'offset',
              value: offset
          },{
              key: 'limit',
              value: parseInt($scope.filter.limit)
          },{
              key: 'customer_related_id',
              value: vm.filter.customer.id
          }];

          if(!Utils.isEmpty($scope.filter.value)) {
              params.push({
                  key: 'filter',
                  value: $scope.filter.value
              });
          }

          $scope.servicos = {};

          ServicesService.getAll(params)
              .then(({ data }) => {
                  $scope.servicos = data;
              })
              .catch((error) => {
                  console.log(error);
              });
      }
      }
    }

    function loadReportData(dta_from, dta_to, person_id) {
        vm.items = {};
        vm.qtd_total = 0;
        vm.vlr_total = 0;

        let params = [{
            key: 'dta_from',
            value: dta_from
        },{
            key: 'dta_to',
            value: dta_to
        }];

        if(!Utils.isEmpty(vm.filter.customer)){
          params.push({
            key: 'customer_id',
            value: vm.filter.customer.id
          });
        }

        let query_string = Utils.generateQueryString(params);

        var req_url  = Utils.getBaseUrlApi();
            req_url += `/person/${person_id}/researches${query_string}`;

        $http({
          method: "GET",
          url: req_url
        }).then(
          function successCallback(response) {
            vm.items = response.data;
          },
          function errorCallback(response) {
            toaster.pop({
              type: 'error', 
              timeout: 2000, 
              bodyOutputType: 'trustedHtml',
              body: '<strong>Desculpe!</strong><br/>'+response.data
            });
          }
        );
    }

    vm.openPDFReport = function(research) {
        var modal_instance = $uibModal.open({ 
            backdrop: false,
            size: 'xl',
            templateUrl: '/reportModal.html',
            controller: ModalInstanceCtrl
        });

        ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
        function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
            let report_url = `${Utils.getBaseUrlReports()}`;
            let params = [{
                key: 'restrict-use-type',
                value: (research.service.simplified) ? 'text' : 'icon'
            }, {
                key: 'format',
                value: 'A4'
            }, {
                key: 'template',
                value: research.service.report_model
            }, {
                key: 'order_id',
                value: research.order.id
            }, {
                key: 'service_id',
                value: research.service.id
            }, {
                key: 'person_id',
                value: vm.filter.person.id
            }];

            let query_string = Utils.generateQueryString(params);

            $scope.showPDFReport = function() {
                new PDFObject({
                    url: report_url + query_string, 
                    id: 'report-container',
                    height: '600px'
                }).embed('report-container');
            }

            $scope.downloadArquivo = function() {
                report_url += '&filename=' + $scope.nome_arquivo_download;
                window.open(report_url, '_blank');
            }

            $scope.closeModal = function() {
                $uibModalInstance.close({});
            }
        };
    }
    if(!Utils.isEmpty(vm.currentUser.customer)) {
        vm.loadBusinessUnitsByCustomer(vm.currentUser.customer);
    }
  }
})();
// report-researches.controller.js
(function() {
  'use strict';

  angular
      .module('app.relatorios')
      .controller('ReportResearchesController', Controller);

  Controller.$inject = [
      '$log', 
      '$rootScope', 
      '$scope', 
      '$state', 
      '$http', 
      '$uibModal', 
      'Utils', 
      'toaster', 
      'WebcamService', 
      'BusinessUnitsService', 
      'ServicesService', 
      'Colors'
    ];

  function Controller(
      $log, 
      $rootScope, 
      $scope, 
      $state, 
      $http, 
      $uibModal, 
      Utils, 
      toaster, 
      WebcamService, 
      BusinessUnitsService, 
      ServicesService, 
      Colors
    ) {
      var vm = this;
      
      activate();
      
      ////////////////
      
      function activate() {
        vm.currentUser = $rootScope.globals.currentUser;
        
        vm.filter = {
          limit: '10'
        };

        vm.columns = {
            business_unit: true,
            service: true,
            unit_value: true,
            requester_name: true,
            requested_at: true,
            status_criminal: true,
            status_finance: true,
            status_accident_report: true
        };
        
        vm.dpOptions = {
          formatYear: 'yy',
          startingDay: 1
        };
        
        vm.limit_options = ["5","10","30","50","100"];

        if(!Utils.isEmpty(vm.currentUser.customer)) {
            vm.filter.customer = vm.currentUser.customer;
            if(vm.filter.customer.person_type == 'PJ') {
                if(!Utils.isEmpty(vm.filter.customer.company_name))
                    vm.filter.customer.label = vm.filter.customer.company_name;
                else
                    vm.filter.customer.label = vm.filter.customer.fantasy_name;
            }
            else
                vm.filter.customer.label = vm.filter.customer.name;
        }
      }

      vm.loadBusinessUnitsByCustomer = (customer) => {
        let params = [{
            key: 'no-limit',
            value: true
        }, {
            key: 'customer_related_id',
            value: customer.id
        }];
        BusinessUnitsService.getAll(params)
            .then(({ data }) => {
                vm.business_units = data;
            })
            .catch((error) => {
                console.log(error);
            });
      }

      vm.applyFilter = function() {
          var dta_from = null,
              dta_to = null,
              customer_id = null;

          if(!Utils.isEmpty(vm.filter.dta_from)){
              dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from
              dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
          }
          else {
              toaster.pop({
                  type: 'warning', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Atençao!</strong><br/>O campo De é obrigatório'
              });
          }

          if(!Utils.isEmpty(vm.filter.dta_to)) {
              dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
              dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
          }
          else {
              toaster.pop({
                  type: 'warning', 
                  timeout: 2000, 
                  bodyOutputType: 'trustedHtml',
                  body: '<strong>Atençao!</strong><br/>O campo Até é obrigatório'
              });
          }

          if(!Utils.isEmpty(vm.filter.customer) && !Utils.isEmpty(vm.filter.customer.id))
            customer_id = vm.filter.customer.id
          else {
            toaster.pop({
              type: 'warning', 
              timeout: 2000, 
              bodyOutputType: 'trustedHtml',
              body: '<strong>Atençao!</strong><br/>O campo Cliente é obrigatório'
            });
          }

          if(!Utils.isEmpty(dta_from) && !Utils.isEmpty(dta_to) && !Utils.isEmpty(customer_id)) {
            loadReportData(dta_from, dta_to, customer_id);
          }
      }

      vm.clearFilter = () => {
        vm.filter = {
            dta_from: '',
            dta_to: '',
            limit: '10'
        };
        vm.items = null;
      }

      vm.openDatepicker = function($event, model) {
          $event.preventDefault();
          $event.stopPropagation();
          vm['dp_'+ model +'_opened'] = true;
      }

      vm.openModal = function(modal_name, item){
        var modal_instance = $uibModal.open({ 
            size: 'md',
            backdrop: false,
            templateUrl: '/'+ modal_name +'.html',
            controller: ModalInstanceCtrl
        });

        ModalInstanceCtrl.$inject = ['$scope', '$uibModalInstance'];
        function ModalInstanceCtrl($scope, $uibModalInstance) {
          $scope.limit_options = ["5","10","30","50","100"];
          $scope.filter = {
              value: '',
              limit: "5"
          };

          $scope.getOrderRecordLayouts = function(offset) {
              var req_url = Utils.getBaseUrlApi()+'/order/records/layouts';
                  req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

              if(!Utils.isEmpty($scope.filter.value))
                  req_url += '&filter='+ $scope.filter.value;

              $scope.layouts = {};

              $http({
                  method: "GET",
                  url: req_url
              }).then(
                  function successCallback(response) {
                      if(!Utils.isEmpty(vm.objModel)) {
                          angular.forEach(response.data.records, function(item){
                              if(!Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id})))
                                  item.selected = true;
                          });
                      }
                      $scope.layouts = response.data;
                  },
                  function errorCallback(response) {
                      $scope.layouts = null;
                      toaster.pop({
                          type: 'error', 
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: '<strong>Desculpe!</strong><br/>'+ response.data
                      });
                  }
              );
          }

          $scope.addItem = function(item){
              if(Utils.isEmpty(vm.objModel.records_layouts))
                  vm.objModel.records_layouts = [];
              if(Utils.isEmpty(_.findWhere(vm.objModel.records_layouts, {id: item.id}))) {
                  item.selected = true;
                  item.delete = false;
                  vm.objModel.records_layouts.push( angular.copy(item) );
              }
              else {
                  toaster.pop({
                      type: 'error', 
                      timeout: 2000, 
                      bodyOutputType: 'trustedHtml',
                      body: '<strong>Desculpe!</strong><br/>Este layout já foi adicionado na lista.'
                  });
              }
          }

          $scope.selectItem = function(items, item_selected) {
              angular.forEach(items, function(item) {
                  item.selected = false;
              });
              item_selected.selected = true;
              $scope.selected_item = angular.copy(item_selected);
          }

          $scope.confirmSelectItem = function(model) {
              switch(model) {
                case 'filter.customer':
                    vm.loadBusinessUnitsByCustomer($scope.selected_item);
                    vm.filter.customer = angular.copy($scope.selected_item);
                    if(vm.filter.customer.person_type == 'PJ') {
                        if(!Utils.isEmpty(vm.filter.customer.company_name))
                            vm.filter.customer.label = vm.filter.customer.company_name;
                        else
                            vm.filter.customer.label = vm.filter.customer.fantasy_name;
                    }
                    else
                        vm.filter.customer.label = vm.filter.customer.name;
                    break;
                case 'service':
                    vm.filter.service = $scope.selected_item;
                    vm.filter.service.label = $scope.selected_item.name;
                    break;
              }
              $uibModalInstance.close('closed');
          }

          $scope.cancelSelection = function(){
              $scope.service_selected = null;
              $scope.objModelPerson = null;
              $scope.new_cliente = false;
              $uibModalInstance.close('closed');
          }

          $scope.getClientesEmpresas = function(offset) {
              var req_url = Utils.getBaseUrlApi()+'/persons';
                  req_url += '?offset='+ offset +'&limit='+ parseInt($scope.filter.limit);

              if(!Utils.isEmpty($scope.filter.value))
                  req_url += '&filter='+ $scope.filter.value;
              
              if ($rootScope.globals.currentUser.profile === 'filial') {
                req_url += '&filial_related_id='+ $rootScope.globals.currentUser.id;
              }

              $scope.clientesEmpresas = {};

              $http({
                  method: "GET",
                  url: req_url
              }).then(
                  function successCallback(response) {
                      if(!Utils.isEmpty(vm.service_selected)) {
                          angular.forEach(response.data.records, function(item){
                              if(!Utils.isEmpty(_.findWhere(vm.service_selected.companies, {id: item.id})))
                                  item.selected = true;
                          });
                      }
                      $scope.clientesEmpresas = response.data;
                  },
                  function errorCallback(response) {
                      $scope.clientesEmpresas = null;
                      toaster.pop({
                          type: 'error', 
                          timeout: 2000, 
                          bodyOutputType: 'trustedHtml',
                          body: '<strong>Desculpe!</strong><br/>'+ response.data
                      });
                  }
              );
          }

          $scope.getServicos = function(offset) {
            let params = [{
                key: 'offset',
                value: offset
            },{
                key: 'limit',
                value: parseInt($scope.filter.limit)
            },{
                key: 'customer_related_id',
                value: vm.filter.customer.id
            }];

            if(!Utils.isEmpty($scope.filter.value)) {
                params.push({
                    key: 'filter',
                    value: $scope.filter.value
                });
            }

            $scope.servicos = {};

            ServicesService.getAll(params)
                .then(({ data }) => {
                    $scope.servicos = data;
                })
                .catch((error) => {
                    console.log(error);
                });
        }
        }
      }

    function loadReportData(dta_from, dta_to, customer_id) {
        vm.items = {};
        vm.qtd_total = 0;
        vm.vlr_total = 0;

        let params = [{
            key: 'dta_from',
            value: dta_from
        },{
            key: 'dta_to',
            value: dta_to
        },{
            key: 'customer_id',
            value: customer_id
        }];

        if(!Utils.isEmpty(vm.filter.business_unit) && !Utils.isEmpty(vm.filter.business_unit.id)) {
            params.push({
                key: 'business_unit_id',
                value: vm.filter.business_unit.id
            });
        }

        if(!Utils.isEmpty(vm.filter.service) && !Utils.isEmpty(vm.filter.service.id)) {
            params.push({
                key: 'service_id',
                value: vm.filter.service.id
            });
        }

        let query_string = Utils.generateQueryString(params);

        var req_url  = Utils.getBaseUrlApi();
            req_url += `/reports/researches${query_string}`;

        $http({
          method: "GET",
          url: req_url
        }).then(
          function successCallback(response) {
            vm.items = response.data;
            angular.forEach(vm.items.records, (item) =>{
              vm.qtd_total++;
              vm.vlr_total += item.service.default_price;
            });
            resumeCounters();
          },
          function errorCallback(response) {
            toaster.pop({
              type: 'error', 
              timeout: 2000, 
              bodyOutputType: 'trustedHtml',
              body: '<strong>Desculpe!</strong><br/>'+response.data
            });
          }
        );
    }

      function resumeCounters() {
          vm.counters = {
              total: vm.items.records.length,
              ables: {
                  criminal: 0,
                  finance: 0,
                  accident_report: 0
              },
              unables: {
                criminal: 0,
                finance: 0,
                accident_report: 0
              }
          }
          vm.items.records.forEach((item) => {
            vm.counters.ables.criminal += (item.details.criminal_able) ? 1 : 0;
            vm.counters.unables.criminal += (!item.details.criminal_able) ? 1 : 0;

            vm.counters.ables.finance += (item.details.finance_able) ? 1 : 0;
            vm.counters.unables.finance += (!item.details.finance_able) ? 1 : 0;

            vm.counters.ables.accident_report += (item.details.accident_report_able) ? 1 : 0;
            vm.counters.unables.accident_report += (!item.details.accident_report_able) ? 1 : 0;
          });
      }

      vm.openPDFReport = function() {
        var modal_instance = $uibModal.open({ 
            backdrop: false,
            size: 'xl',
            templateUrl: '/reportModal.html',
            controller: ModalInstanceCtrl
        });

        ModalInstanceCtrl.$inject = ['$scope', '$rootScope', '$uibModalInstance'];
        function ModalInstanceCtrl($scope, $rootScope, $uibModalInstance) {
            var dta_from = null,
                dta_to = null;

            dta_from = JSON.parse(JSON.stringify(vm.filter)).dta_from,
            dta_from = moment(dta_from).set('h', 0).set('m', 0).set('s', 0).format('YYYY-MM-DD HH:mm:ss');
            
            dta_to = JSON.parse(JSON.stringify(vm.filter)).dta_to,
            dta_to = moment(dta_to).set('h', 23).set('m', 59).set('s', 59).format('YYYY-MM-DD HH:mm:ss');
            
            let report_url = `${Utils.getBaseUrlReports()}`;
            let params = [{
                key: 'template',
                value: 'report-researches'
            }, {
                key: 'format',
                value: 'A4-L'
            }, {
                key: 'columns',
                value: JSON.stringify(vm.columns)
            }, {
                key: 'dta_from',
                value: dta_from
            }, {
                key: 'dta_to',
                value: dta_to
            }, {
                key: 'customer_id',
                value: vm.filter.customer.id
            }];

            if(!Utils.isEmpty(vm.filter.business_unit) && !Utils.isEmpty(vm.filter.business_unit.id)) {
                params.push({
                    key: 'business_unit_id',
                    value: vm.filter.business_unit.id
                });
            }
    
            if(!Utils.isEmpty(vm.filter.service) && !Utils.isEmpty(vm.filter.service.id)) {
                params.push({
                    key: 'service_id',
                    value: vm.filter.service.id
                });
            }

            let query_string = Utils.generateQueryString(params);

            $scope.showPDFReport = function() {
                new PDFObject({
                    url: report_url + query_string, 
                    id: 'report-container',
                    height: '600px'
                }).embed('report-container');
            }

            $scope.downloadArquivo = function() {
                report_url += '&filename=' + $scope.nome_arquivo_download;
                window.open(report_url, '_blank');
            }

            $scope.closeModal = function() {
                $uibModalInstance.close({});
            }
        };
    }
    if(!Utils.isEmpty(vm.currentUser.customer)) {
        vm.loadBusinessUnitsByCustomer(vm.currentUser.customer);
    }
  }
})();
/**=========================================================
 * Module: helpers.js
 * Provides helper functions for routes definition
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.routes')
        .provider('RouteHelpers', RouteHelpersProvider)
        ;

    RouteHelpersProvider.$inject = ['APP_REQUIRES'];
    function RouteHelpersProvider(APP_REQUIRES) {

      /* jshint validthis:true */
      return {
        // provider access level
        basepath: basepath,
        resolveFor: resolveFor,
        // controller access level
        $get: function() {
          return {
            basepath: basepath,
            resolveFor: resolveFor
          };
        }
      };

      // Set here the base of the relative path
      // for all app views
      function basepath(uri) {
        return 'app/views/' + uri;
      }

      // Generates a resolve object by passing script names
      // previously configured in constant.APP_REQUIRES
      function resolveFor() {
        var _args = arguments;
        return {
          deps: ['$ocLazyLoad','$q', function ($ocLL, $q) {
            // Creates a promise chain for each argument
            var promise = $q.when(1); // empty promise
            for(var i=0, len=_args.length; i < len; i ++){
              promise = andThen(_args[i]);
            }
            return promise;

            // creates promise to chain dynamically
            function andThen(_arg) {
              // also support a function that returns a promise
              if(typeof _arg === 'function')
                  return promise.then(_arg);
              else
                  return promise.then(function() {
                    // if is a module, pass the name. If not, pass the array
                    var whatToLoad = getRequired(_arg);
                    // simple error check
                    if(!whatToLoad) return $.error('Route resolve: Bad resource name [' + _arg + ']');
                    // finally, return a promise
                    return $ocLL.load( whatToLoad );
                  });
            }
            // check and returns required data
            // analyze module items with the form [name: '', files: []]
            // and also simple array of script files (for not angular js)
            function getRequired(name) {
              if (APP_REQUIRES.modules)
                  for(var m in APP_REQUIRES.modules)
                      if(APP_REQUIRES.modules[m].name && APP_REQUIRES.modules[m].name === name)
                          return APP_REQUIRES.modules[m];
              return APP_REQUIRES.scripts && APP_REQUIRES.scripts[name];
            }

          }]};
      } // resolveFor

    }


})();


/**=========================================================
 * Module: config.js
 * App routes and resources configuration
 =========================================================*/


// routes.config.js
(function() {
    'use strict';

    angular
        .module('app.routes')
        .config(routesConfig);

    routesConfig.$inject = ['$stateProvider', '$locationProvider', '$urlRouterProvider', 'RouteHelpersProvider'];
    function routesConfig($stateProvider, $locationProvider, $urlRouterProvider, helper){
        
        // Set the following to true to enable the HTML5 Mode
        // You may have to set <base> tag in index and a routing configuration in your server
        $locationProvider.html5Mode(false);

        // defaults to dashboard
        $urlRouterProvider.otherwise('/page/login');

        // 
        // Application Routes
        // -----------------------------------   
        $stateProvider
          .state('app', {
              url: '/app',
              abstract: true,
              templateUrl: helper.basepath('app.html'),
              resolve: helper.resolveFor(
                'modernizr', 
                'icons', 
                'underscore', 
                'angular-underscore', 
                'angular-input-masks', 
                'highcharts',
                'angular-highcharts',
                'brasil.filters', 
                'angularBootstrapConfirm',
                'toaster',
                'summernote',
                'webcam',
                'pdfobject',
                'easypiechart',
                'cp.ngConfirm'
              )
          })
          .state('app.dashboard', {
              url: '/dashboard',
              templateUrl: helper.basepath('dashboard.html'),
              controller: 'DashboardController',
              controllerAs: 'ctrl'
          })
          .state('app.order-new', {
              url: '/order/new',
              templateUrl: helper.basepath('order-new.html'),
              controller: 'OrderController',
              controllerAs: 'ctrl'
          })
          .state('app.order-list', {
              url: '/order/list',
              templateUrl: helper.basepath('order-list.html'),
              controller: 'OrderController',
              controllerAs: 'ctrl'
          })
          .state('app.order-records', {
              url: '/order/records',
              templateUrl: helper.basepath('order-records.html'),
              controller: 'OrderRecordController',
              controllerAs: 'ctrl'
          })
          .state('app.order-proceedings-list', {
              url: '/order/proceedings/list',
              templateUrl: helper.basepath('order-proceedings-list.html'),
              controller: 'OrderProceedingsController',
              controllerAs: 'ctrl'
          })
          .state('app.order-proceedings-new', {
              url: '/order/proceedings/new',
              templateUrl: helper.basepath('order-proceedings-new.html'),
              controller: 'OrderProceedingsController',
              controllerAs: 'ctrl'
          })
          .state('app.user-new', {
              url: '/user/new',
              templateUrl: helper.basepath('user-new.html'),
              controller: 'UserController',
              controllerAs: 'ctrl'
          })

          .state('app.user-new2', {
            url: '/user/new2',
            templateUrl: helper.basepath('user-new2.html'),
            controller: 'UserController',
            controllerAs: 'ctrl'
        })
          .state('app.user-list', {
              url: '/user/list',
              templateUrl: helper.basepath('user-list.html'),
              controller: 'UserController',
              controllerAs: 'ctrl'
          })
          .state('app.person-new', {
              url: '/person/new',
              templateUrl: helper.basepath('person-new.html'),
              controller: 'PersonController',
              controllerAs: 'ctrl'
          })
          .state('app.person-list', {
              url: '/person/list',
              templateUrl: helper.basepath('person-list.html'),
              controller: 'PersonController',
              controllerAs: 'ctrl'
          })
          .state('app.service-new', {
              url: '/service/new',
              templateUrl: helper.basepath('service-new.html'),
              controller: 'ServiceController',
              controllerAs: 'ctrl'
          })
          .state('app.service-list', {
              url: '/service/list',
              templateUrl: helper.basepath('service-list.html'),
              controller: 'ServiceController',
              controllerAs: 'ctrl'
          })
          .state('app.business-unit-new', {
              url: '/business-unit/new',
              templateUrl: helper.basepath('business-unit-new.html'),
              controller: 'BusinessUnitController',
              controllerAs: 'ctrl'
          })
          .state('app.business-unit-list', {
              url: '/business-unit/list',
              templateUrl: helper.basepath('business-unit-list.html'),
              controller: 'BusinessUnitController',
              controllerAs: 'ctrl'
          })
          .state('app.criminal-article-new', {
              url: '/criminal-article/new',
              templateUrl: helper.basepath('criminal-article-new.html'),
              controller: 'CriminalArticleController',
              controllerAs: 'ctrl'
          })
          .state('app.criminal-article-list', {
              url: '/criminal-article/list',
              templateUrl: helper.basepath('criminal-article-list.html'),
              controller: 'CriminalArticleController',
              controllerAs: 'ctrl'
          })
          .state('app.measurement-new', {
              url: '/measurement/new',
              templateUrl: helper.basepath('measurement-new.html'),
              controller: 'MeasurementController',
              controllerAs: 'ctrl'
          })
          .state('app.measurement-list', {
              url: '/measurement/list',
              templateUrl: helper.basepath('measurement-list.html'),
              controller: 'MeasurementController',
              controllerAs: 'ctrl'
          })
          .state('app.order-record-layout-new', {
              url: '/order/record/layout/new',
              templateUrl: helper.basepath('order-record-layout-new.html'),
              controller: 'OrderRecordLayoutController',
              controllerAs: 'ctrl'
          })
          .state('app.order-record-layout-list', {
              url: '/order/record/layout/list',
              templateUrl: helper.basepath('order-record-layout-list.html'),
              controller: 'OrderRecordLayoutController',
              controllerAs: 'ctrl'
          })
          .state('app.report-researches', {
            url: '/report/researches',
            templateUrl: helper.basepath('report-researches.html'),
            controller: 'ReportResearchesController',
            controllerAs: 'ctrl'
          })
          .state('app.report-expenses', { 
            url: '/report/expenses',
            templateUrl: helper.basepath('report-expenses.html'),
            controller: 'ReportExpensesController',
            controllerAs: 'ctrl'
          })
          .state('app.report-researches-person', {
            url: '/report/researches-person',
            templateUrl: helper.basepath('report-researches-person.html'),
            controller: 'ReportResearchesPersonController',
            controllerAs: 'ctrl'
          })
          .state('page', {
            url: '/page',
            templateUrl: 'app/pages/page.html',
            resolve: helper.resolveFor('modernizr', 'icons'),
            controller: ['$rootScope', function($rootScope) {
              $rootScope.app.layout.isBoxed = false;
            }]
          })
          .state('page.login', {
            url: '/login',
            title: 'Login',
            templateUrl: 'app/pages/login.html',
            controller: 'LoginFormController',
            controllerAs: 'ctrl'
          })
        ;
    } // routesConfig
})();
// business-units.service.js
(function() {
  'use strict';
  
  angular
    .module('app.services')
    .service('BusinessUnitsService', Service);
  
    Service.$inject = ['$http', 'Utils'];
    function Service($http, Utils) {
      return {
        getAll: (params) => {
          let url_params = Utils.generateQueryString(params);
          return $http.get(`${Utils.getBaseUrlApi()}/business-units${url_params}`);
        },
        getById: (id) => {
          return $http.get(`${Utils.getBaseUrlApi()}/business-unit/${id}`);
        },
        save: (data) => {
          return $http.post(`${Utils.getBaseUrlApi()}/business-unit`, JSON.stringify(data));
        },
        update: (id, data) => {
          return $http.put(`${Utils.getBaseUrlApi()}/business-unit/${id}`, JSON.stringify(data));
        },
        delete: (id) => {
          return $http.delete(`${Utils.getBaseUrlApi()}/business-unit/${id}`);
        }
      }
    }
})();
// infosimples.service.js
(function(){
    'use strict';
    
    angular
        .module('app.services')
        .service('InfoSimplesService', Service);

        Service.$inject  = ['$http', 'Utils'];
        function Service($http, Utils){
            return {
                getByCaixaEconomicaFederal: (params) => {
                    let url_params = Utils.generateQueryString(params);
                    return $http.get(`${Utils.getBaseUrlApi()}/infosimples/caixa/regularidade/fgts${url_params}`);
                },
                getByReceitaFederal: (params) => {
                    let url_params = Utils.generateQueryString(params);
                    return $http.get(`${Utils.getBaseUrlApi()}/infosimples/receita-federal/pgfn/certidao-debitos-tributarios${url_params}`);
                },
                getByTribunalSuperiorTrabalho: (params) => {
                    let url_params = Utils.generateQueryString(params);
                    return $http.get(`${Utils.getBaseUrlApi()}/infosimples/tribunal/tst/certidao-negativa-debitos-trabalhista${url_params}`);
                },
                getByCadinEstadual: (params) => {
                    let url_params = Utils.generateQueryString(params);
                    return $http.get(`${Utils.getBaseUrlApi()}/infosimples/cadin/estadual/certidao${url_params}`);
                },
                getByCadinMunicipal: (params) => {
                    let url_params = Utils.generateQueryString(params);
                    return $http.get(`${Utils.getBaseUrlApi()}/infosimples/cadin/municipal/certidao${url_params}`);
                }


            }
        }
})();
// persons.service.js
(function() {
  'use strict';
  
  angular
    .module('app.services')
    .service('PersonsService', Service);
  
    Service.$inject = ['$http', 'Utils'];
    function Service($http, Utils) {
      return {
        validate: (cpf_cnpj, customer_id) => {
          let req_url = `${Utils.getBaseUrlApi()}/person/${cpf_cnpj}/exists`;
          let req_payload = null;

          if(customer_id)
            req_payload = JSON.stringify({customer_id: customer_id});
          
          return $http.post(req_url, req_payload);
        },
        getAll: (params) => {
          let url_params = Utils.generateQueryString(params);
          return $http.get(`${Utils.getBaseUrlApi()}/persons${url_params}`);
        },
        getById: (id) => {
          return $http.get(`${Utils.getBaseUrlApi()}/person/${id}`);
        },
        save: (data) => {
          return $http.post(`${Utils.getBaseUrlApi()}/person`, JSON.stringify(data));
        },
        update: (id, data) => {
          return $http.put(`${Utils.getBaseUrlApi()}/person/${id}`, JSON.stringify(data));
        },
        delete: (id) => {
          return $http.delete(`${Utils.getBaseUrlApi()}/person/${id}`);
        }
      }
    }
})();
// services.service.js
(function() {
  'use strict';
  
  angular
    .module('app.services')
    .service('ServicesService', Service);
  
    Service.$inject = ['$http', 'Utils'];
    function Service($http, Utils) {
      return {
        getAll: (params) => {
          let url_params = Utils.generateQueryString(params);
          return $http.get(`${Utils.getBaseUrlApi()}/services${url_params}`);
        },
        getById: (id) => {
          return $http.get(`${Utils.getBaseUrlApi()}/service/${id}`);
        },
        save: (data) => {
          return $http.post(`${Utils.getBaseUrlApi()}/service`, JSON.stringify(data));
        },
        update: (id, data) => {
          return $http.put(`${Utils.getBaseUrlApi()}/service/${id}`, JSON.stringify(data));
        },
        delete: (id) => {
          return $http.delete(`${Utils.getBaseUrlApi()}/service/${id}`);
        }
      }
    }
})();
(function(){
    'use strict';
  
  angular
    .module('app.services')
    .service('SintegraService', Service);

    Service.$inject = ['$http', 'Utils'];
    function Service($http, Utils) {
      return {
        getByCNPJSintegra: (params) => {
          let url_params = Utils.generateQueryString(params);
          return $http.get(`${Utils.getBaseUrlApi()}/sintegraws/receita-federal/cnpj${url_params}`);
        }
      }
    }

})();
// users.service.js
(function() {
  'use strict';
  
  angular
    .module('app.services')
    .service('UsersService', Service);
  
    Service.$inject = ['$http', 'Utils'];
    function Service($http, Utils) {
      return {
        getAll: (params) => {
          let url_params = Utils.generateQueryString(params);
          return $http.get(`${Utils.getBaseUrlApi()}/users${url_params}`);
        },
        getById: (id) => {
          return $http.get(`${Utils.getBaseUrlApi()}/user/${id}`);
        },
        save: (data) => {
          return $http.post(`${Utils.getBaseUrlApi()}/user`, JSON.stringify(data));
        },
        update: (id, data) => {
          return $http.put(`${Utils.getBaseUrlApi()}/user/${id}`, JSON.stringify(data));
        },
        updatePassword: (id, data) => {
          return $http.put(`${Utils.getBaseUrlApi()}/user/${id}/password`, JSON.stringify(data));
        },
        delete: (id) => {
          return $http.delete(`${Utils.getBaseUrlApi()}/user/${id}`);
        }
      }
    }
})();
(function() {
    'use strict';

    angular
        .module('app.settings')
        .run(settingsRun);

    settingsRun.$inject = ['$rootScope', '$localStorage'];

    function settingsRun($rootScope, $localStorage){


      // User Settings
      // -----------------------------------
      /*$rootScope.user = {
        name:     'John',
        job:      'ng-developer',
        picture:  'app/img/user/02.jpg'
      };*/

      // Hides/show user avatar on sidebar from any element
      $rootScope.toggleUserBlock = function(){
        $rootScope.$broadcast('toggleUserBlock');
      };

      // Global Settings
      // -----------------------------------
      $rootScope.app = {
        name: 'UnitAdmin',
        description: 'Proccess Management Tool',
        year: ((new Date()).getFullYear()),
        layout: {
          isFixed: true,
          isCollapsed: false,
          isBoxed: false,
          isRTL: false,
          horizontal: false,
          isFloat: false,
          asideHover: false,
          theme: 'app/css/theme-h.css',
          asideScrollbar: false,
          isCollapsedText: false
        },
        useFullLayout: false,
        hiddenFooter: false,
        offsidebarOpen: false,
        asideToggled: false,
        viewAnimation: 'ng-fadeInUp'
      };

      // Setup the layout mode
      $rootScope.app.layout.horizontal = ( $rootScope.$stateParams.layout === 'app-h') ;

      // Restore layout settings [*** UNCOMMENT TO ENABLE ***]
      // if( angular.isDefined($localStorage.layout) )
      //   $rootScope.app.layout = $localStorage.layout;
      // else
      //   $localStorage.layout = $rootScope.app.layout;
      //
      // $rootScope.$watch('app.layout', function () {
      //   $localStorage.layout = $rootScope.app.layout;
      // }, true);

      // Close submenu when sidebar change from collapsed to normal
      $rootScope.$watch('app.layout.isCollapsed', function(newValue) {
        if( newValue === false )
          $rootScope.$broadcast('closeSidebarMenu');
      });

    }

})();

/**=========================================================
 * Module: sidebar-menu.js
 * Handle sidebar collapsible elements
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .controller('SidebarController', SidebarController);

    SidebarController.$inject = ['$rootScope', '$scope', '$state', 'SidebarLoader', 'Utils'];
    function SidebarController($rootScope, $scope, $state, SidebarLoader,  Utils) {

        activate();

        ////////////////

        function activate() {
          var collapseList = [];

          // demo: when switch from collapse to hover, close all items
          var watchOff1 = $rootScope.$watch('app.layout.asideHover', function(oldVal, newVal){
            if ( newVal === false && oldVal === true) {
              closeAllBut(-1);
            }
          });


          // Load menu from json file
          // -----------------------------------

          SidebarLoader.getMenu(sidebarReady);

          function sidebarReady(items) {
            $scope.menuItems = items.data;
          }

          // Handle sidebar and collapse items
          // ----------------------------------

          $scope.getMenuItemPropClasses = function(item) {
            return (item.heading ? 'nav-heading' : '') +
                   (isActive(item) ? ' active' : '') ;
          };

          $scope.addCollapse = function($index, item) {
            collapseList[$index] = $rootScope.app.layout.asideHover ? true : !isActive(item);
          };

          $scope.isCollapse = function($index) {
            return (collapseList[$index]);
          };

          $scope.toggleCollapse = function($index, isParentItem) {

            // collapsed sidebar doesn't toggle drodopwn
            if( Utils.isSidebarCollapsed() || $rootScope.app.layout.asideHover ) return true;

            // make sure the item index exists
            if( angular.isDefined( collapseList[$index] ) ) {
              if ( ! $scope.lastEventFromChild ) {
                collapseList[$index] = !collapseList[$index];
                closeAllBut($index);
              }
            }
            else if ( isParentItem ) {
              closeAllBut(-1);
            }

            $scope.lastEventFromChild = isChild($index);

            return true;
          };

          $scope.canShowItemMenu = function(item) {
            return ($.inArray($rootScope.globals.currentUser.profile, item.profiles) != -1);
          }

          // Controller helpers
          // -----------------------------------

          // Check item and children active state
          function isActive(item) {

            if(!item) return;

            if( !item.sref || item.sref === '#') {
              var foundActive = false;
              angular.forEach(item.submenu, function(value) {
                if(isActive(value)) foundActive = true;
              });
              return foundActive;
            }
            else
              return $state.is(item.sref) || $state.includes(item.sref);
          }

          function closeAllBut(index) {
            index += '';
            for(var i in collapseList) {
              if(index < 0 || index.indexOf(i) < 0)
                collapseList[i] = true;
            }
          }

          function isChild($index) {
            /*jshint -W018*/
            return (typeof $index === 'string') && !($index.indexOf('-') < 0);
          }

          $scope.$on('$destroy', function() {
              watchOff1();
          });

        } // activate
    }

})();

/**=========================================================
 * Module: sidebar.js
 * Wraps the sidebar and handles collapsed state
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .directive('sidebar', sidebar);

    sidebar.$inject = ['$rootScope', '$timeout', '$window', 'Utils'];
    function sidebar ($rootScope, $timeout, $window, Utils) {
        var $win = angular.element($window);
        var directive = {
            // bindToController: true,
            // controller: Controller,
            // controllerAs: 'vm',
            link: link,
            restrict: 'EA',
            template: '<nav class="sidebar" ng-transclude></nav>',
            transclude: true,
            replace: true
            // scope: {}
        };
        return directive;

        function link(scope, element, attrs) {

          var currentState = $rootScope.$state.current.name;
          var $sidebar = element;

          var eventName = Utils.isTouch() ? 'click' : 'mouseenter' ;
          var subNav = $();

          $sidebar.on( eventName, '.nav > li', function() {

            if( Utils.isSidebarCollapsed() || $rootScope.app.layout.asideHover ) {

              subNav.trigger('mouseleave');
              subNav = toggleMenuItem( $(this), $sidebar);

              // Used to detect click and touch events outside the sidebar
              sidebarAddBackdrop();

            }

          });

          var eventOff1 = scope.$on('closeSidebarMenu', function() {
            removeFloatingNav();
          });

          // Normalize state when resize to mobile
          $win.on('resize.sidebar', function() {
            if( ! Utils.isMobile() )
          	asideToggleOff();
          });

          // Adjustment on route changes
          var eventOff2 = $rootScope.$on('$stateChangeStart', function(event, toState) {
            currentState = toState.name;
            // Hide sidebar automatically on mobile
            asideToggleOff();

            $rootScope.$broadcast('closeSidebarMenu');
          });

      	  // Autoclose when click outside the sidebar
          if ( angular.isDefined(attrs.sidebarAnyclickClose) ) {

            var wrapper = $('.wrapper');
            var sbclickEvent = 'click.sidebar';

            var watchOff1 = $rootScope.$watch('app.asideToggled', watchExternalClicks);

          }

          //////

          function watchExternalClicks(newVal) {
            // if sidebar becomes visible
            if ( newVal === true ) {
              $timeout(function(){ // render after current digest cycle
                wrapper.on(sbclickEvent, function(e){
                  // if not child of sidebar
                  if( ! $(e.target).parents('.aside').length ) {
                    asideToggleOff();
                  }
                });
              });
            }
            else {
              // dettach event
              wrapper.off(sbclickEvent);
            }
          }

          function asideToggleOff() {
            $rootScope.app.asideToggled = false;
            if(!scope.$$phase) scope.$apply(); // anti-pattern but sometimes necessary
      	  }

          scope.$on('$destroy', function() {
            // detach scope events
            eventOff1();
            eventOff2();
            watchOff1();
            // detach dom events
            $sidebar.off(eventName);
            $win.off('resize.sidebar');
            wrapper.off(sbclickEvent);
          });

        }

        ///////

        function sidebarAddBackdrop() {
          var $backdrop = $('<div/>', { 'class': 'dropdown-backdrop'} );
          $backdrop.insertAfter('.aside-inner').on('click mouseenter', function () {
            removeFloatingNav();
          });
        }

        // Open the collapse sidebar submenu items when on touch devices
        // - desktop only opens on hover
        function toggleTouchItem($element){
          $element
            .siblings('li')
            .removeClass('open')
            .end()
            .toggleClass('open');
        }

        // Handles hover to open items under collapsed menu
        // -----------------------------------
        function toggleMenuItem($listItem, $sidebar) {

          removeFloatingNav();

          var ul = $listItem.children('ul');

          if( !ul.length ) return $();
          if( $listItem.hasClass('open') ) {
            toggleTouchItem($listItem);
            return $();
          }

          var $aside = $('.aside');
          var $asideInner = $('.aside-inner'); // for top offset calculation
          // float aside uses extra padding on aside
          var mar = parseInt( $asideInner.css('padding-top'), 0) + parseInt( $aside.css('padding-top'), 0);
          var subNav = ul.clone().appendTo( $aside );

          toggleTouchItem($listItem);

          var itemTop = ($listItem.position().top + mar) - $sidebar.scrollTop();
          var vwHeight = $win.height();

          subNav
            .addClass('nav-floating')
            .css({
              position: $rootScope.app.layout.isFixed ? 'fixed' : 'absolute',
              top:      itemTop,
              bottom:   (subNav.outerHeight(true) + itemTop > vwHeight) ? 0 : 'auto'
            });

          subNav.on('mouseleave', function() {
            toggleTouchItem($listItem);
            subNav.remove();
          });

          return subNav;
        }

        function removeFloatingNav() {
          $('.dropdown-backdrop').remove();
          $('.sidebar-subnav.nav-floating').remove();
          $('.sidebar li.open').removeClass('open');
        }
    }


})();


(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .service('SidebarLoader', SidebarLoader);

    SidebarLoader.$inject = ['$http'];
    function SidebarLoader($http) {
        this.getMenu = getMenu;

        ////////////////

        function getMenu(onReady, onError) {
          var menuJson = 'server/sidebar-menu.json',
              menuURL  = menuJson + '?v=' + (new Date().getTime()); // jumps cache
            
          onError = onError || function() { alert('Failure loading menu'); };

          $http
            .get(menuURL)
            .then(onReady, onError);
        }
    }
})();
(function() {
    'use strict';

    angular
        .module('app.sidebar')
        .controller('UserBlockController', UserBlockController);

    UserBlockController.$inject = ['$scope', '$rootScope'];
    function UserBlockController($scope, $rootScope) {

        activate();

        ////////////////

        function activate() {

          $scope.user = $rootScope.globals.currentUser;

          $scope.userBlockVisible = false;

          var detach = $scope.$on('toggleUserBlock', function(/*event, args*/) {

            $scope.userBlockVisible = ! $scope.userBlockVisible;

          });

          $scope.$on('$destroy', detach);
        }
    }
})();

(function() {
    'use strict';

    angular
        .module('app.translate')
        .config(translateConfig)
        ;
    translateConfig.$inject = ['$translateProvider'];
    function translateConfig($translateProvider){

      $translateProvider.useStaticFilesLoader({
          prefix : 'app/i18n/',
          suffix : '.json'
      });

      $translateProvider.preferredLanguage('en');
      $translateProvider.useLocalStorage();
      $translateProvider.usePostCompiling(true);
      $translateProvider.useSanitizeValueStrategy('sanitizeParameters');

    }
})();
(function() {
    'use strict';

    angular
        .module('app.translate')
        .run(translateRun)
        ;
    translateRun.$inject = ['$rootScope', '$translate'];
    
    function translateRun($rootScope, $translate){

      // Internationalization
      // ----------------------

      $rootScope.language = {
        // Handles language dropdown
        listIsOpen: false,
        // list of available languages
        available: {
          'en':       'English',
          'es_AR':    'Español'
        },
        // display always the current ui language
        init: function () {
          var proposedLanguage = $translate.proposedLanguage() || $translate.use();
          var preferredLanguage = $translate.preferredLanguage(); // we know we have set a preferred one in app.config
          $rootScope.language.selected = $rootScope.language.available[ (proposedLanguage || preferredLanguage) ];
        },
        set: function (localeId) {
          // Set the new idiom
          $translate.use(localeId);
          // save a reference for the current language
          $rootScope.language.selected = $rootScope.language.available[localeId];
          // finally toggle dropdown
          $rootScope.language.listIsOpen = ! $rootScope.language.listIsOpen;
        }
      };

      $rootScope.language.init();

    }
})();
/**=========================================================
 * Module: animate-enabled.js
 * Enable or disables ngAnimate for element with directive
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('animateEnabled', animateEnabled);

    animateEnabled.$inject = ['$animate'];
    function animateEnabled ($animate) {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element, attrs) {
          scope.$watch(function () {
            return scope.$eval(attrs.animateEnabled, scope);
          }, function (newValue) {
            $animate.enabled(!!newValue, element);
          });
        }
    }

})();

/**=========================================================
 * Module: browser.js
 * Browser detection
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .service('Browser', Browser);

    Browser.$inject = ['$window'];
    function Browser($window) {
      return $window.jQBrowser;
    }

})();

/**=========================================================
 * Module: clear-storage.js
 * Removes a key from the browser storage via element click
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('resetKey', resetKey);

    resetKey.$inject = ['$state', '$localStorage'];
    function resetKey ($state, $localStorage) {
        var directive = {
            link: link,
            restrict: 'A',
            scope: {
              resetKey: '@'
            }
        };
        return directive;

        function link(scope, element) {
          element.on('click', function (e) {
              e.preventDefault();

              if(scope.resetKey) {
                delete $localStorage[scope.resetKey];
                $state.go($state.current, {}, {reload: true});
              }
              else {
                $.error('No storage key specified for reset.');
              }
          });
        }
    }

})();

/**=========================================================
 * Module: fullscreen.js
 * Toggle the fullscreen mode on/off
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('toggleFullscreen', toggleFullscreen);

    toggleFullscreen.$inject = ['Browser'];
    function toggleFullscreen (Browser) {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element) {
          // Not supported under IE
          if( Browser.msie ) {
            element.addClass('hide');
          }
          else {
            element.on('click', function (e) {
                e.preventDefault();

                if (screenfull.enabled) {
                  
                  screenfull.toggle();
                  
                  // Switch icon indicator
                  if(screenfull.isFullscreen)
                    $(this).children('em').removeClass('fa-expand').addClass('fa-compress');
                  else
                    $(this).children('em').removeClass('fa-compress').addClass('fa-expand');

                } else {
                  $.error('Fullscreen not enabled');
                }

            });
          }
        }
    }

})();

/**=========================================================
 * Module: load-css.js
 * Request and load into the current page a css file
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('loadCss', loadCss);

    function loadCss () {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element, attrs) {
          element.on('click', function (e) {
              if(element.is('a')) e.preventDefault();
              var uri = attrs.loadCss,
                  link;

              if(uri) {
                link = createLink(uri);
                if ( !link ) {
                  $.error('Error creating stylesheet link element.');
                }
              }
              else {
                $.error('No stylesheet location defined.');
              }

          });
        }
        
        function createLink(uri) {
          var linkId = 'autoloaded-stylesheet',
              oldLink = $('#'+linkId).attr('id', linkId + '-old');

          $('head').append($('<link/>').attr({
            'id':   linkId,
            'rel':  'stylesheet',
            'href': uri
          }));

          if( oldLink.length ) {
            oldLink.remove();
          }

          return $('#'+linkId);
        }
    }

})();

/**=========================================================
 * Module: ng-enter.js
 * Provides a simple way to dispatch enter key event the current field element
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('ngEnter', ngEnter);

    ngEnter.$inject = [];
    function ngEnter() {
      var directive = {
        link: link
      };

      return directive;

      function link(scope, element, attrs) {
        element.bind("keydown keypress", function(event) {
          if(event.which === 13) {
            scope.$apply(function (){
              scope.$eval(attrs.ngEnter);
            });
            
            event.preventDefault();
          }
        });
      }
    }
})();
/**=========================================================
 * Module: now.js
 * Provides a simple way to display the current time formatted
 =========================================================*/

(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('now', now);

    now.$inject = ['dateFilter', '$interval'];
    function now (dateFilter, $interval) {
        var directive = {
            link: link,
            restrict: 'EA'
        };
        return directive;

        function link(scope, element, attrs) {
          var format = attrs.format;

          function updateTime() {
            var dt = dateFilter(new Date(), format);
            element.text(dt);
          }

          updateTime();
          var intervalPromise = $interval(updateTime, 1000);

          scope.$on('$destroy', function(){
            $interval.cancel(intervalPromise);
          });

        }
    }

})();

/**=========================================================
 * Module: table-checkall.js
 * Tables check all checkbox
 =========================================================*/
(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('checkAll', checkAll);

    function checkAll () {
        var directive = {
            link: link,
            restrict: 'A'
        };
        return directive;

        function link(scope, element) {
          element.on('change', function() {
            var $this = $(this),
                index= $this.index() + 1,
                checkbox = $this.find('input[type="checkbox"]'),
                table = $this.parents('table');
            // Make sure to affect only the correct checkbox column
            table.find('tbody > tr > td:nth-child('+index+') input[type="checkbox"]')
              .prop('checked', checkbox[0].checked);

          });
        }
    }

})();

/**=========================================================
 * Module: trigger-resize.js
 * Triggers a window resize event from any element
 =========================================================*/
(function() {
    'use strict';

    angular
        .module('app.utils')
        .directive('triggerResize', triggerResize);

    triggerResize.$inject = ['$window', '$timeout'];
    function triggerResize ($window, $timeout) {
      var directive = {
          link: link,
          restrict: 'A'
      };
      return directive;

      function link(scope, element, attributes) {
        element.on('click', function(){
          $timeout(function(){
            // all IE friendly dispatchEvent
            var evt = document.createEvent('UIEvents');
            evt.initUIEvent('resize', true, false, $window, 0);
            $window.dispatchEvent(evt);
            // modern dispatchEvent way
            // $window.dispatchEvent(new Event('resize'));
          }, attributes.triggerResize || 300);
        });
      }
    }

})();

/**=========================================================
 * Module: utils.js
 * Utility library to use across the theme
 =========================================================*/

 (function() {
  'use strict';

  angular
      .module('app.utils')
      .service('Utils', Utils);

  Utils.$inject = ['$window', '$http', 'APP_MEDIAQUERY'];
  function Utils($window, $http, APP_MEDIAQUERY) {

      var $html = angular.element('html'),
          $win  = angular.element($window),
          $body = angular.element('body');

      return {
        // DETECTION
        support: {
          transition: (function() {
                  var transitionEnd = (function() {

                      var element = document.body || document.documentElement,
                          transEndEventNames = {
                              WebkitTransition: 'webkitTransitionEnd',
                              MozTransition: 'transitionend',
                              OTransition: 'oTransitionEnd otransitionend',
                              transition: 'transitionend'
                          }, name;

                      for (name in transEndEventNames) {
                          if (element.style[name] !== undefined) return transEndEventNames[name];
                      }
                  }());

                  return transitionEnd && { end: transitionEnd };
              })(),
          animation: (function() {

              var animationEnd = (function() {

                  var element = document.body || document.documentElement,
                      animEndEventNames = {
                          WebkitAnimation: 'webkitAnimationEnd',
                          MozAnimation: 'animationend',
                          OAnimation: 'oAnimationEnd oanimationend',
                          animation: 'animationend'
                      }, name;

                  for (name in animEndEventNames) {
                      if (element.style[name] !== undefined) return animEndEventNames[name];
                  }
              }());

              return animationEnd && { end: animationEnd };
          })(),
          requestAnimationFrame: window.requestAnimationFrame ||
                                 window.webkitRequestAnimationFrame ||
                                 window.mozRequestAnimationFrame ||
                                 window.msRequestAnimationFrame ||
                                 window.oRequestAnimationFrame ||
                                 function(callback){ window.setTimeout(callback, 1000/60); },
          /*jshint -W069*/
          touch: (
              ('ontouchstart' in window && navigator.userAgent.toLowerCase().match(/mobile|tablet/)) ||
              (window.DocumentTouch && document instanceof window.DocumentTouch)  ||
              (window.navigator['msPointerEnabled'] && window.navigator['msMaxTouchPoints'] > 0) || //IE 10
              (window.navigator['pointerEnabled'] && window.navigator['maxTouchPoints'] > 0) || //IE >=11
              false
          ),
          mutationobserver: (window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver || null)
        },
        // UTILITIES
        isInView: function(element, options) {
            /*jshint -W106*/
            var $element = $(element);

            if (!$element.is(':visible')) {
                return false;
            }

            var window_left = $win.scrollLeft(),
                window_top  = $win.scrollTop(),
                offset      = $element.offset(),
                left        = offset.left,
                top         = offset.top;

            options = $.extend({topoffset:0, leftoffset:0}, options);

            if (top + $element.height() >= window_top && top - options.topoffset <= window_top + $win.height() &&
                left + $element.width() >= window_left && left - options.leftoffset <= window_left + $win.width()) {
              return true;
            } else {
              return false;
            }
        },

        langdirection: $html.attr('dir') === 'rtl' ? 'right' : 'left',

        isTouch: function () {
          return $html.hasClass('touch');
        },

        isSidebarCollapsed: function () {
          return $body.hasClass('aside-collapsed') || $body.hasClass('aside-collapsed-text');
        },

        isSidebarToggled: function () {
          return $body.hasClass('aside-toggled');
        },

        isMobile: function () {
          return $win.width() < APP_MEDIAQUERY.tablet;
        },

        isEmpty: function(value) {
          return (typeof value === "undefined" || value === null || value === "");
        },

        getUrlVars: function() {
          if(window.location.href.indexOf('?') != -1) {
            var vars = {}, hash;
            var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
            for(var i = 0; i < hashes.length; i++)
            {
              hash = hashes[i].split('=');
              vars[hash[0]] = hash[1];
            }

            return vars;
          }
          else
            return null;
        },

        getBaseUrl: function() {
          return location.protocol + '//' + location.hostname;
        },

        getBaseUrlReports: function() {
          let endpoint = 'reports';
          if(location.hostname.indexOf('localhost') !== -1)
            endpoint = 'unit-consult-core-reports';
          return `${location.protocol}//${location.hostname}/${endpoint}`;
        },

        getBaseUrlApi: function() {
          var url = this.getBaseUrl();

          switch(location.protocol) {
            case "http:":
              url += ":3000";
              break;
            case "https:":
              url += ":3001";
              break;
          }

          return url;
        },

        validateFields: function(scope, form_group, str_replace) {
          var fields_empty = false;
          
          var isEmptyCallBack = this.isEmpty;

          $.each($(form_group +' .ui-select-container[required="required"],'+ form_group +' [required="required"]'), function(i, field){
              $(field).closest('.form-group').removeClass('has-error');

              var model = null;
              if(!isEmptyCallBack($(field).attr('ng-model')))
                model = $(field).attr('ng-model');
              else if(!isEmptyCallBack($(field).attr('ng-value')))
                model = $(field).attr('ng-value');

              if(!isEmptyCallBack(str_replace))
                model = model.replaceAll(str_replace, '');

              if(!isEmptyCallBack(model)) {
                var field_array = model.replace('ctrl.', '').split('.');
                
                if((field_array.length === 1) && (isEmptyCallBack(scope[model]))) {
                  $(field).closest('.form-group').addClass('has-error');
                  fields_empty = true;
                }
                else if(field_array.length === 2) {
                  var model_scope = field_array[field_array.length-2];
                  var model_field = field_array[field_array.length-1];
                  if(
                      isEmptyCallBack(scope) || 
                      isEmptyCallBack(scope[model_scope]) || 
                      isEmptyCallBack(scope[model_scope][model_field])
                    ) {
                      $(field).closest('.form-group').addClass('has-error');
                      fields_empty = true;
                  }
                }
                else if(field_array.length === 3) {
                  var model_scope         = field_array[field_array.length-3];
                  var model_intermediate  = field_array[field_array.length-2];
                  var model_field         = field_array[field_array.length-1];
                  if(
                      isEmptyCallBack(scope) || 
                      isEmptyCallBack(scope[model_scope]) || 
                      isEmptyCallBack(scope[model_scope][model_intermediate]) || 
                      isEmptyCallBack(scope[model_scope][model_intermediate][model_field])) {
                      $(field).closest('.form-group').addClass('has-error');
                      fields_empty = true;
                  }
                }
                else if(field_array.length === 4) {
                  var model_scope         = field_array[field_array.length-4];
                  var model_medium        = field_array[field_array.length-3];
                  var model_intermediate  = field_array[field_array.length-2];
                  var model_field         = field_array[field_array.length-1];
                  if(
                      isEmptyCallBack(scope) || 
                      isEmptyCallBack(scope[model_scope]) || 
                      isEmptyCallBack(scope[model_scope][model_medium]) || 
                      isEmptyCallBack(scope[model_scope][model_medium][model_intermediate]) || 
                      isEmptyCallBack(scope[model_scope][model_medium][model_intermediate][model_field])
                    ) {
                      $(field).closest('.form-group').addClass('has-error');
                      fields_empty = true;
                  }
                }
              }
          });

          return fields_empty;
        },

        validateEmail: function(email) {
          var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
          return re.test(email);
        },

        getObjectValueIfNotValidate: function (object, property, value){
          if(object[property] !== value)
            return object[property]; 
          return null;          
        },

        getAddressByCEP: function(cep, successCallback, errorCallback) {
          cep = cep.replaceAll('.', '').replaceAll('/', '').replaceAll('-', '');
          $http({
              method: "GET",
              url: 'https://viacep.com.br/ws/' + cep + '/json/'
          }).then(successCallback, errorCallback);
        },
        
        numberFormat: function(number, decimals, dec_point, thousands_sep) {
          number = (number + '').replace(/[^0-9+\-Ee.]/g, '');
          var n = !isFinite(+number) ? 0 : +number,
              prec = !isFinite(+decimals) ? 0 : Math.abs(decimals),
              sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep,
              dec = (typeof dec_point === 'undefined') ? '.' : dec_point,
              s = '',
              toFixedFix = function(n, prec) {
                var k = Math.pow(10, prec);
                return '' + (Math.round(n * k) / k).toFixed(prec);
              };
          s = (prec ? toFixedFix(n, prec) : '' + Math.round(n)).split('.');
          if (s[0].length > 3) {
            s[0] = s[0].replace(/\B(?=(?:\d{3})+(?!\d))/g, sep);
          }
          if ((s[1] || '').length < prec) {
            s[1] = s[1] || '';
            s[1] += new Array(prec - s[1].length + 1).join('0');
          }

          return s.join(dec);
        },

        generateRandomHash: function(length) {
          var hash = '';
          var possible = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
          for (var i = 0; i < length; i++) {
            hash += possible.charAt(Math.floor(Math.random() * possible.length));
          }
          return hash;
        },
        
        calcBase64SizeInKBytes: function(base64String){
          var result = -1.0;
          if(!this.isEmpty(base64String)) {
            var padding = 0;
            if(base64String.endsWith("==")) {
              padding = 2;
            }
            else {
              if (base64String.endsWith("="))
                padding = 1;
            }
            result = (Math.ceil(base64String.length / 4) * 3 ) - padding;
          }
          return (result / 1000);
        },

        generateQueryString: (params) => {
          var query_string = "";
          params.forEach( (param, key) => {
            if (key === 0)
              query_string += '?' + param.key + '=' + param.value;
            else
              query_string += '&' + param.key + '=' + param.value;
          });
          return query_string;
        }
      };
  }
})();
(function() {
    'use strict';

    angular
        .module('custom', [
            // request the the entire framework
            'angle',
            // or just modules
            'app.core',
            'app.sidebar'
            /*...*/
        ]);
})();

// To run this code, edit file index.html or index.jade and change
// html data-ng-app attribute from angle to myAppName
// ----------------------------------------------------------------------

(function() {
    'use strict';

    angular
        .module('custom')
        .controller('Controller', Controller);

    Controller.$inject = ['$log'];
    function Controller($log) {
        // for controllerAs syntax
        // var vm = this;

        activate();

        ////////////////

        function activate() {
          $log.log('I\'m a line from custom.js');
        }
    }
})();
